#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using CDIStudio.CDMenus;
using CDIStudio.CDMenus.Forms;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;



namespace CDIStudio.Autorun
{
	/// <summary>
	/// Autorun is the program responsible to launch the CDMenu.
	/// </summary>
	public class Autorun
	{
		
		public Autorun()
		{	
			try
			{
				//Set project path
				string proj = Path.GetDirectoryName(Application.ExecutablePath);
				proj = proj.Remove(proj.Length - CDMenu.BinFolder.Length, CDMenu.BinFolder.Length);
				CDMenu.ProjectFolder = proj;

				//Open the file written above and read values from it.
				CDMenuFactory.OpenCDMenu(CDMenu.CDMenuFolder + @"\CDMenu.cdi" , true);
				//Run Autorun action
				CDIStudio.CDMenus.ProcessManager.Start(CDMenuFactory.CDMenu.Options.Autorun);
				AutorunInitialization();
				CDMenuFactory.CDMenu.AutorunInitialization();
				if ( CDMenuFactory.CDMenu != null)
				{	
					if(	CDMenuFactory.CDMenu.DB != null)
					{	
						CDMenuFactory.CDMenu.DB.OpenDB();
						CDMenuFactory.CDMenu.InitializeDataBindings();					
					}

					Application.Run(CDMenuFactory.CDMenu);
				}
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message,"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

			private void AutorunInitialization()
			{
				//Add initialization code
			}
						
		

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{	
			Application.EnableVisualStyles();
			new Autorun();
			
		}
	}
}
