#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

namespace CDIStudio.Studio
{
	enum State{ Alpha,Beta,Stable };

	/// <summary>
	/// About dialog.
	/// </summary>
	public class About : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.LinkLabel linkLabel2;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Label lblState;
		private System.Windows.Forms.Label lblState_;
		private System.Windows.Forms.TabPage tabInfo;
		private System.Windows.Forms.TabPage tabCredits;
		private System.Windows.Forms.LinkLabel linkLabel3;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.LinkLabel linkLabel6;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.LinkLabel linkLabel5;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.LinkLabel linkLabel4;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.LinkLabel linkLabel7;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.LinkLabel linkLabel8;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.LinkLabel linkLabel9;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TabPage tabTranslators;
		private System.Windows.Forms.ListView lvTranslators;
		private System.Windows.Forms.ColumnHeader LanguageColumn;
		private System.Windows.Forms.ColumnHeader TranslatorColumn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// About dialog.
		/// </summary>
		public About()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		
			lblVersion.Text = "Version : " + Application.ProductVersion;

			if (state == State.Alpha)
			{
				lblState.Text = "Alpha";
				lblState.ForeColor = Color.Red;
			}
			else if (state == State.Beta)
			{
				lblState.Text = "Beta";
				lblState.ForeColor = Color.Green;
			}
			else if (state == State.Stable)
			{
				lblState.Hide(); 
				lblState_.Hide();
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(About));
			System.Windows.Forms.ListViewItem listViewItem1 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "Dutch",
																													 "elmo"}, -1);
			System.Windows.Forms.ListViewItem listViewItem2 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "German",
																													 "Patrick Schafer"}, -1);
			System.Windows.Forms.ListViewItem listViewItem3 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "Greek",
																													 "Theodoros Antoniou"}, -1);
			System.Windows.Forms.ListViewItem listViewItem4 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "Indonesian",
																													 "Iqbal Rush"}, -1);
			System.Windows.Forms.ListViewItem listViewItem5 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "Portuguese",
																													 "Tiago Teixeira"}, -1);
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lblVersion = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabInfo = new System.Windows.Forms.TabPage();
			this.linkLabel2 = new System.Windows.Forms.LinkLabel();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.tabCredits = new System.Windows.Forms.TabPage();
			this.linkLabel9 = new System.Windows.Forms.LinkLabel();
			this.label11 = new System.Windows.Forms.Label();
			this.linkLabel8 = new System.Windows.Forms.LinkLabel();
			this.label10 = new System.Windows.Forms.Label();
			this.linkLabel7 = new System.Windows.Forms.LinkLabel();
			this.label9 = new System.Windows.Forms.Label();
			this.linkLabel6 = new System.Windows.Forms.LinkLabel();
			this.label2 = new System.Windows.Forms.Label();
			this.linkLabel5 = new System.Windows.Forms.LinkLabel();
			this.label8 = new System.Windows.Forms.Label();
			this.linkLabel4 = new System.Windows.Forms.LinkLabel();
			this.label7 = new System.Windows.Forms.Label();
			this.tabTranslators = new System.Windows.Forms.TabPage();
			this.lvTranslators = new System.Windows.Forms.ListView();
			this.LanguageColumn = new System.Windows.Forms.ColumnHeader();
			this.TranslatorColumn = new System.Windows.Forms.ColumnHeader();
			this.linkLabel3 = new System.Windows.Forms.LinkLabel();
			this.label6 = new System.Windows.Forms.Label();
			this.lblState = new System.Windows.Forms.Label();
			this.lblState_ = new System.Windows.Forms.Label();
			this.tabControl1.SuspendLayout();
			this.tabInfo.SuspendLayout();
			this.tabCredits.SuspendLayout();
			this.tabTranslators.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(116, 75);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(48, 48);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.SlateGray;
			this.label1.Location = new System.Drawing.Point(52, 10);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(184, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "CDInterface Studio";
			// 
			// lblVersion
			// 
			this.lblVersion.ForeColor = System.Drawing.Color.SteelBlue;
			this.lblVersion.Location = new System.Drawing.Point(98, 38);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(124, 14);
			this.lblVersion.TabIndex = 2;
			this.lblVersion.Text = "Version : 2.3.0.0";
			// 
			// label3
			// 
			this.label3.ForeColor = System.Drawing.Color.SteelBlue;
			this.label3.Location = new System.Drawing.Point(35, 124);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(232, 19);
			this.label3.TabIndex = 3;
			this.label3.Text = "Copyright 2004-2005 Theodoros Antoniou";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabInfo);
			this.tabControl1.Controls.Add(this.tabCredits);
			this.tabControl1.Controls.Add(this.tabTranslators);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.tabControl1.Location = new System.Drawing.Point(0, 155);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(298, 131);
			this.tabControl1.TabIndex = 4;
			// 
			// tabInfo
			// 
			this.tabInfo.Controls.Add(this.linkLabel2);
			this.tabInfo.Controls.Add(this.label5);
			this.tabInfo.Controls.Add(this.label4);
			this.tabInfo.Controls.Add(this.linkLabel1);
			this.tabInfo.Location = new System.Drawing.Point(4, 22);
			this.tabInfo.Name = "tabInfo";
			this.tabInfo.Size = new System.Drawing.Size(290, 105);
			this.tabInfo.TabIndex = 0;
			this.tabInfo.Text = "Info";
			// 
			// linkLabel2
			// 
			this.linkLabel2.Location = new System.Drawing.Point(18, 76);
			this.linkLabel2.Name = "linkLabel2";
			this.linkLabel2.Size = new System.Drawing.Size(159, 15);
			this.linkLabel2.TabIndex = 3;
			this.linkLabel2.TabStop = true;
			this.linkLabel2.Text = "defdef@users.sourceforge.net";
			this.linkLabel2.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelMailClicked);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(10, 58);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(41, 15);
			this.label5.TabIndex = 2;
			this.label5.Text = "E-mail:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(10, 11);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(68, 13);
			this.label4.TabIndex = 1;
			this.label4.Text = "Home Page:";
			// 
			// linkLabel1
			// 
			this.linkLabel1.Location = new System.Drawing.Point(18, 27);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(173, 14);
			this.linkLabel1.TabIndex = 0;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "http://cdinterface.sourceforge.net";
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// tabCredits
			// 
			this.tabCredits.AutoScroll = true;
			this.tabCredits.Controls.Add(this.linkLabel9);
			this.tabCredits.Controls.Add(this.label11);
			this.tabCredits.Controls.Add(this.linkLabel8);
			this.tabCredits.Controls.Add(this.label10);
			this.tabCredits.Controls.Add(this.linkLabel7);
			this.tabCredits.Controls.Add(this.label9);
			this.tabCredits.Controls.Add(this.linkLabel6);
			this.tabCredits.Controls.Add(this.label2);
			this.tabCredits.Controls.Add(this.linkLabel5);
			this.tabCredits.Controls.Add(this.label8);
			this.tabCredits.Controls.Add(this.linkLabel4);
			this.tabCredits.Controls.Add(this.label7);
			this.tabCredits.Location = new System.Drawing.Point(4, 22);
			this.tabCredits.Name = "tabCredits";
			this.tabCredits.Size = new System.Drawing.Size(290, 105);
			this.tabCredits.TabIndex = 1;
			this.tabCredits.Text = "Credits";
			// 
			// linkLabel9
			// 
			this.linkLabel9.Location = new System.Drawing.Point(26, 183);
			this.linkLabel9.Name = "linkLabel9";
			this.linkLabel9.Size = new System.Drawing.Size(247, 26);
			this.linkLabel9.TabIndex = 27;
			this.linkLabel9.TabStop = true;
			this.linkLabel9.Text = "http://www.steepvalley.net";
			this.linkLabel9.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(18, 164);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(189, 23);
			this.label11.TabIndex = 26;
			this.label11.Text = "steepvalley.net:";
			// 
			// linkLabel8
			// 
			this.linkLabel8.Location = new System.Drawing.Point(23, 289);
			this.linkLabel8.Name = "linkLabel8";
			this.linkLabel8.Size = new System.Drawing.Size(247, 26);
			this.linkLabel8.TabIndex = 25;
			this.linkLabel8.TabStop = true;
			this.linkLabel8.Text = "http://www.codeproject.com/cs/miscctrl/bending_property.asp";
			this.linkLabel8.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(15, 276);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(189, 23);
			this.label10.TabIndex = 24;
			this.label10.Text = "PropertyBag:";
			// 
			// linkLabel7
			// 
			this.linkLabel7.Location = new System.Drawing.Point(23, 234);
			this.linkLabel7.Name = "linkLabel7";
			this.linkLabel7.Size = new System.Drawing.Size(247, 26);
			this.linkLabel7.TabIndex = 23;
			this.linkLabel7.TabStop = true;
			this.linkLabel7.Text = "http://www.codeproject.com/cs/miscctrl/XPTaskBar.asp";
			this.linkLabel7.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(15, 219);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(189, 23);
			this.label9.TabIndex = 22;
			this.label9.Text = "XPExplorer Bar:";
			// 
			// linkLabel6
			// 
			this.linkLabel6.Location = new System.Drawing.Point(26, 130);
			this.linkLabel6.Name = "linkLabel6";
			this.linkLabel6.Size = new System.Drawing.Size(247, 26);
			this.linkLabel6.TabIndex = 21;
			this.linkLabel6.TabStop = true;
			this.linkLabel6.Text = "http://www.divil.co.uk/net";
			this.linkLabel6.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(18, 111);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(189, 23);
			this.label2.TabIndex = 20;
			this.label2.Text = "divelements:";
			// 
			// linkLabel5
			// 
			this.linkLabel5.Location = new System.Drawing.Point(26, 80);
			this.linkLabel5.Name = "linkLabel5";
			this.linkLabel5.Size = new System.Drawing.Size(238, 23);
			this.linkLabel5.TabIndex = 19;
			this.linkLabel5.TabStop = true;
			this.linkLabel5.Text = "http://sourceforge.net/projects/adodotnetsqlite";
			this.linkLabel5.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(18, 63);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(188, 14);
			this.label8.TabIndex = 18;
			this.label8.Text = "ADO.NET Data Provider for SQLite:";
			// 
			// linkLabel4
			// 
			this.linkLabel4.Location = new System.Drawing.Point(26, 30);
			this.linkLabel4.Name = "linkLabel4";
			this.linkLabel4.Size = new System.Drawing.Size(121, 23);
			this.linkLabel4.TabIndex = 17;
			this.linkLabel4.TabStop = true;
			this.linkLabel4.Text = "http://www.sqlite.org";
			this.linkLabel4.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelClicked);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(18, 16);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(100, 13);
			this.label7.TabIndex = 16;
			this.label7.Text = "SQLite:";
			// 
			// tabTranslators
			// 
			this.tabTranslators.Controls.Add(this.lvTranslators);
			this.tabTranslators.Location = new System.Drawing.Point(4, 22);
			this.tabTranslators.Name = "tabTranslators";
			this.tabTranslators.Size = new System.Drawing.Size(290, 105);
			this.tabTranslators.TabIndex = 2;
			this.tabTranslators.Text = "Translators";
			// 
			// lvTranslators
			// 
			this.lvTranslators.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							this.LanguageColumn,
																							this.TranslatorColumn});
			this.lvTranslators.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvTranslators.GridLines = true;
			this.lvTranslators.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			listViewItem2.Checked = true;
			listViewItem2.StateImageIndex = 1;
			this.lvTranslators.Items.AddRange(new System.Windows.Forms.ListViewItem[] {
																						  listViewItem1,
																						  listViewItem2,
																						  listViewItem3,
																						  listViewItem4,
																						  listViewItem5});
			this.lvTranslators.Location = new System.Drawing.Point(0, 0);
			this.lvTranslators.Name = "lvTranslators";
			this.lvTranslators.Size = new System.Drawing.Size(290, 105);
			this.lvTranslators.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvTranslators.TabIndex = 0;
			this.lvTranslators.View = System.Windows.Forms.View.Details;
			// 
			// LanguageColumn
			// 
			this.LanguageColumn.Text = "Language";
			this.LanguageColumn.Width = 80;
			// 
			// TranslatorColumn
			// 
			this.TranslatorColumn.Text = "Translator";
			this.TranslatorColumn.Width = 205;
			// 
			// linkLabel3
			// 
			this.linkLabel3.Location = new System.Drawing.Point(0, 0);
			this.linkLabel3.Name = "linkLabel3";
			this.linkLabel3.TabIndex = 0;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(0, 0);
			this.label6.Name = "label6";
			this.label6.TabIndex = 0;
			// 
			// lblState
			// 
			this.lblState.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblState.ForeColor = System.Drawing.Color.Red;
			this.lblState.Location = new System.Drawing.Point(136, 56);
			this.lblState.Name = "lblState";
			this.lblState.Size = new System.Drawing.Size(48, 17);
			this.lblState.TabIndex = 5;
			this.lblState.Text = "Alpha";
			// 
			// lblState_
			// 
			this.lblState_.Location = new System.Drawing.Point(103, 55);
			this.lblState_.Name = "lblState_";
			this.lblState_.Size = new System.Drawing.Size(35, 12);
			this.lblState_.TabIndex = 6;
			this.lblState_.Text = "State:";
			// 
			// About
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(298, 286);
			this.Controls.Add(this.lblState_);
			this.Controls.Add(this.lblState);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.pictureBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "About";
			this.Opacity = 0.85;
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "About";
			this.tabControl1.ResumeLayout(false);
			this.tabInfo.ResumeLayout(false);
			this.tabCredits.ResumeLayout(false);
			this.tabTranslators.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
																													                         
		private State state = State.Beta;

		private void linkLabelClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)				                                                                   
		{									                                                                                                                                  
			LinkLabel Lbl;
			Lbl = sender as LinkLabel;
			System.Diagnostics.Process.Start(Lbl.Text);
		}																															                       

		private void linkLabelMailClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			LinkLabel Lbl;
			Lbl = sender as LinkLabel;
			System.Diagnostics.Process.Start("mailto:" + Lbl.Text);
		}
	}

}
