#region	 Licence and informations

/***************************************************************************************
 *		Date	:	19-5-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 *		Managed localized strings.
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Resources;
using System.Threading;
using System.Globalization;
using System.Collections;
using System.Windows.Forms;

namespace CDIStudio.Studio
{
	public delegate void SimpleDelegate();

	/// <summary>
	/// Managed localized strings.
	/// </summary>
	public class Localization 
	{
		#region Constructor
		public Localization()
		{	
			rm = ResourceManager.CreateFileBasedResourceManager("Strings",@"Language",null);
		}
		#endregion


		#region Fields
		/// <summary>
		/// This ResourceManager holds the localized strings.
		/// </summary>
		private System.Resources.ResourceManager rm;
		#endregion


		#region Propertys


		#endregion


		#region Indexes

		public string this[string name]
		{
			get 
			{
				return rm.GetString(name);
			}
		}

		#endregion


		#region Events

		/// <summary>
		/// This event is called after the locale has changed.
		/// </summary>
		public event SimpleDelegate LocaleChanged;

		#endregion


		#region Methods
		/// <summary>
		/// Changes the current locale.
		/// </summary>
		/// <param name="locale"></param>
		public void ChangeLocale(string locale)
		{
			try
			{
				rm.ReleaseAllResources();
				Thread.CurrentThread.CurrentUICulture = new CultureInfo(locale);
			}
			catch(ArgumentException e)
			{
				Thread.CurrentThread.CurrentUICulture = new CultureInfo("en");
			}
			finally
			{
				LocaleChanged();
			}
		}
		
		public void ReleaseAllResources()
		{
			rm.ReleaseAllResources();
		}

		#endregion
				
	}
}
