#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CDIStudio.CDMenus;
using CDIStudio.CDMenus.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Reflection;
using System.Threading;
using CustomUIControls;
using CDIStudio.Studio.OptionsDlg;

namespace CDIStudio.Studio
{
	/// <summary>
	/// Studio is the developing enviroment of CDI.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private TD.SandBar.ToolBarContainer topSandBarDock;
		private TD.SandBar.MenuButtonItem menuItemNew;
		private TD.SandBar.SandBarManager BarManager;
		private TD.SandBar.MenuBar menuBar;
		private TD.SandBar.MenuButtonItem menuItemClose;
		private TD.SandBar.MenuButtonItem menuItemSave;
		private TD.SandBar.MenuButtonItem menuItemOpen;
		private TD.SandBar.MenuBarItem menuItemFile;
		private TD.SandBar.MenuBarItem menuItemProject;
		private TD.SandBar.MenuButtonItem menuItemRunCDMenu;
		private TD.SandBar.MenuButtonItem menuItemHelp;
		private TD.SandBar.MenuButtonItem menuItemAbout;
		private System.Windows.Forms.Panel MainPanel;
		private System.Windows.Forms.Panel panelBottom;
		private System.Windows.Forms.StatusBar statusBar1;
		private TD.SandBar.MenuButtonItem menuItemExit;
		private TD.SandBar.DropDownMenuItem BarItemNew;
		private TD.SandBar.ButtonItem BarItemSave;
		private TD.SandBar.ButtonItem BarItemClose;
		private TD.SandBar.DropDownMenuItem BarItemOpen;
		private TD.SandBar.ToolBar toolBarFile;
		private TD.SandBar.ButtonItem BarItemRunCDMenu;
		private TD.SandBar.ButtonItem BarItemProjectFolder;
		private TD.SandBar.MenuButtonItem menuItemOpenCDMenuFolder;
		private TD.SandBar.MenuBarItem menuItemTools;
		private TD.SandBar.MenuButtonItem menuItemOptions;
		private TD.SandBar.MenuButtonItem menuItemCheckUpdate;
		private TD.SandBar.MenuButtonItem menuButtonEnglish;
		private TD.SandBar.MenuButtonItem menuButtonGreek;
		private TD.SandBar.MenuButtonItem menuButtonItaly;
		private TD.SandBar.MenuBarItem menuItemHelpMain;
		private TD.SandBar.MenuButtonItem menuItemTranslator;
		private TD.SandBar.MenuButtonItem menuItemNewDialog;
		private TD.SandBar.MenuButtonItem menuButtonItem1;
		private TD.SandBar.ButtonItem BarItemOptions;
		private System.Windows.Forms.TabControl tabsTools;
		private System.Windows.Forms.TabPage DataManager;
		private System.Windows.Forms.Label lblDBWarning;
		private System.Windows.Forms.TabPage CustomizeManager;
		private System.Windows.Forms.PropertyGrid propertyGrid;
		private System.Windows.Forms.Splitter splitter1;
		private TD.SandBar.ButtonItem buttonItem1;
		private TD.SandBar.ButtonItem BarItemStopRunningCDMenu;
		private TD.SandBar.MenuButtonItem menuItemStopRunningCDMenu;
		private System.ComponentModel.IContainer components;
		/// <summary>
		/// 
		/// </summary>
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InitializeStudio();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.BarManager = new TD.SandBar.SandBarManager();
			this.topSandBarDock = new TD.SandBar.ToolBarContainer();
			this.menuBar = new TD.SandBar.MenuBar();
			this.menuItemFile = new TD.SandBar.MenuBarItem();
			this.menuItemNew = new TD.SandBar.MenuButtonItem();
			this.menuItemNewDialog = new TD.SandBar.MenuButtonItem();
			this.menuItemOpen = new TD.SandBar.MenuButtonItem();
			this.menuButtonItem1 = new TD.SandBar.MenuButtonItem();
			this.menuItemSave = new TD.SandBar.MenuButtonItem();
			this.menuItemClose = new TD.SandBar.MenuButtonItem();
			this.menuItemExit = new TD.SandBar.MenuButtonItem();
			this.menuItemProject = new TD.SandBar.MenuBarItem();
			this.menuItemRunCDMenu = new TD.SandBar.MenuButtonItem();
			this.menuItemStopRunningCDMenu = new TD.SandBar.MenuButtonItem();
			this.menuItemOpenCDMenuFolder = new TD.SandBar.MenuButtonItem();
			this.menuItemTools = new TD.SandBar.MenuBarItem();
			this.menuItemOptions = new TD.SandBar.MenuButtonItem();
			this.menuItemTranslator = new TD.SandBar.MenuButtonItem();
			this.menuItemHelpMain = new TD.SandBar.MenuBarItem();
			this.menuItemHelp = new TD.SandBar.MenuButtonItem();
			this.menuItemAbout = new TD.SandBar.MenuButtonItem();
			this.menuItemCheckUpdate = new TD.SandBar.MenuButtonItem();
			this.toolBarFile = new TD.SandBar.ToolBar();
			this.BarItemNew = new TD.SandBar.DropDownMenuItem();
			this.BarItemOpen = new TD.SandBar.DropDownMenuItem();
			this.BarItemSave = new TD.SandBar.ButtonItem();
			this.BarItemClose = new TD.SandBar.ButtonItem();
			this.BarItemRunCDMenu = new TD.SandBar.ButtonItem();
			this.BarItemStopRunningCDMenu = new TD.SandBar.ButtonItem();
			this.BarItemProjectFolder = new TD.SandBar.ButtonItem();
			this.BarItemOptions = new TD.SandBar.ButtonItem();
			this.buttonItem1 = new TD.SandBar.ButtonItem();
			this.menuButtonEnglish = new TD.SandBar.MenuButtonItem();
			this.menuButtonGreek = new TD.SandBar.MenuButtonItem();
			this.menuButtonItaly = new TD.SandBar.MenuButtonItem();
			this.MainPanel = new System.Windows.Forms.Panel();
			this.panelBottom = new System.Windows.Forms.Panel();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.tabsTools = new System.Windows.Forms.TabControl();
			this.CustomizeManager = new System.Windows.Forms.TabPage();
			this.propertyGrid = new System.Windows.Forms.PropertyGrid();
			this.DataManager = new System.Windows.Forms.TabPage();
			this.lblDBWarning = new System.Windows.Forms.Label();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.topSandBarDock.SuspendLayout();
			this.panelBottom.SuspendLayout();
			this.tabsTools.SuspendLayout();
			this.CustomizeManager.SuspendLayout();
			this.DataManager.SuspendLayout();
			this.SuspendLayout();
			// 
			// BarManager
			// 
			this.BarManager.OwnerForm = this;
			// 
			// topSandBarDock
			// 
			this.topSandBarDock.Controls.Add(this.menuBar);
			this.topSandBarDock.Controls.Add(this.toolBarFile);
			this.topSandBarDock.Dock = System.Windows.Forms.DockStyle.Top;
			this.topSandBarDock.Guid = new System.Guid("a1310d2d-f43b-4a87-b792-05bb42edac7a");
			this.topSandBarDock.Location = new System.Drawing.Point(0, 0);
			this.topSandBarDock.Manager = this.BarManager;
			this.topSandBarDock.Name = "topSandBarDock";
			this.topSandBarDock.Size = new System.Drawing.Size(688, 56);
			this.topSandBarDock.TabIndex = 13;
			// 
			// menuBar
			// 
			this.menuBar.Guid = new System.Guid("fd4f1b52-dc76-48e3-aae1-177a22fb6727");
			this.menuBar.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																			 this.menuItemFile,
																			 this.menuItemProject,
																			 this.menuItemTools,
																			 this.menuItemHelpMain});
			this.menuBar.Location = new System.Drawing.Point(2, 0);
			this.menuBar.Movable = false;
			this.menuBar.Name = "menuBar";
			this.menuBar.OwnerForm = this;
			this.menuBar.Size = new System.Drawing.Size(686, 24);
			this.menuBar.TabIndex = 0;
			this.menuBar.Text = "menuBar1";
			// 
			// menuItemFile
			// 
			this.menuItemFile.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																				  this.menuItemNew,
																				  this.menuItemOpen,
																				  this.menuItemSave,
																				  this.menuItemClose,
																				  this.menuItemExit});
			this.menuItemFile.Text = "&File";
			this.menuItemFile.BeforePopup += new TD.SandBar.MenuItemBase.BeforePopupEventHandler(this.menuItemFile_BeforePopup);
			// 
			// menuItemNew
			// 
			this.menuItemNew.Image = ((System.Drawing.Image)(resources.GetObject("menuItemNew.Image")));
			this.menuItemNew.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																				 this.menuItemNewDialog});
			this.menuItemNew.Tag = "";
			this.menuItemNew.Text = "&New...";
			this.menuItemNew.Activate += new System.EventHandler(this.NewCDMenu);
			// 
			// menuItemNewDialog
			// 
			this.menuItemNewDialog.BeginGroup = true;
			this.menuItemNewDialog.Text = "New dialog...";
			this.menuItemNewDialog.Activate += new System.EventHandler(this.NewCDMenu_Activate);
			// 
			// menuItemOpen
			// 
			this.menuItemOpen.IconSize = new System.Drawing.Size(24, 24);
			this.menuItemOpen.Image = ((System.Drawing.Image)(resources.GetObject("menuItemOpen.Image")));
			this.menuItemOpen.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																				  this.menuButtonItem1});
			this.menuItemOpen.Text = "&Open...";
			// 
			// menuButtonItem1
			// 
			this.menuButtonItem1.Text = "menuButtonItem1";
			// 
			// menuItemSave
			// 
			this.menuItemSave.Enabled = false;
			this.menuItemSave.Image = ((System.Drawing.Image)(resources.GetObject("menuItemSave.Image")));
			this.menuItemSave.Text = "&Save";
			this.menuItemSave.Activate += new System.EventHandler(this.SaveCDMenu);
			// 
			// menuItemClose
			// 
			this.menuItemClose.Enabled = false;
			this.menuItemClose.Image = ((System.Drawing.Image)(resources.GetObject("menuItemClose.Image")));
			this.menuItemClose.Text = "&Close";
			this.menuItemClose.Activate += new System.EventHandler(this.CloseCDMenu);
			// 
			// menuItemExit
			// 
			this.menuItemExit.Image = ((System.Drawing.Image)(resources.GetObject("menuItemExit.Image")));
			this.menuItemExit.Text = "E&xit";
			this.menuItemExit.Activate += new System.EventHandler(this.menuItemExit_Activate);
			// 
			// menuItemProject
			// 
			this.menuItemProject.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																					 this.menuItemRunCDMenu,
																					 this.menuItemStopRunningCDMenu,
																					 this.menuItemOpenCDMenuFolder});
			this.menuItemProject.Text = "&Project";
			// 
			// menuItemRunCDMenu
			// 
			this.menuItemRunCDMenu.Enabled = false;
			this.menuItemRunCDMenu.Image = ((System.Drawing.Image)(resources.GetObject("menuItemRunCDMenu.Image")));
			this.menuItemRunCDMenu.Text = "Save && &Run CD-Menu";
			this.menuItemRunCDMenu.Activate += new System.EventHandler(this.menuItemRunCDMenu_Activate);
			// 
			// menuItemStopRunningCDMenu
			// 
			this.menuItemStopRunningCDMenu.Enabled = false;
			this.menuItemStopRunningCDMenu.Image = ((System.Drawing.Image)(resources.GetObject("menuItemStopRunningCDMenu.Image")));
			this.menuItemStopRunningCDMenu.Text = "Stop Running CDMenu";
			this.menuItemStopRunningCDMenu.Activate += new System.EventHandler(this.BarItemStopCDMenu_Activate);
			// 
			// menuItemOpenCDMenuFolder
			// 
			this.menuItemOpenCDMenuFolder.Enabled = false;
			this.menuItemOpenCDMenuFolder.Image = ((System.Drawing.Image)(resources.GetObject("menuItemOpenCDMenuFolder.Image")));
			this.menuItemOpenCDMenuFolder.Text = "Open CD-Menu &folder";
			this.menuItemOpenCDMenuFolder.Activate += new System.EventHandler(this.menuItemOpenCDMenuFolder_Activate);
			// 
			// menuItemTools
			// 
			this.menuItemTools.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																				   this.menuItemOptions,
																				   this.menuItemTranslator});
			this.menuItemTools.Text = "&Tools";
			// 
			// menuItemOptions
			// 
			this.menuItemOptions.Image = ((System.Drawing.Image)(resources.GetObject("menuItemOptions.Image")));
			this.menuItemOptions.Text = "&Options";
			this.menuItemOptions.Activate += new System.EventHandler(this.Options_Activate);
			// 
			// menuItemTranslator
			// 
			this.menuItemTranslator.Image = ((System.Drawing.Image)(resources.GetObject("menuItemTranslator.Image")));
			this.menuItemTranslator.Text = "Translator";
			this.menuItemTranslator.Activate += new System.EventHandler(this.menuItemTranslator_Activate);
			// 
			// menuItemHelpMain
			// 
			this.menuItemHelpMain.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																					  this.menuItemHelp,
																					  this.menuItemAbout,
																					  this.menuItemCheckUpdate});
			this.menuItemHelpMain.Text = "&Help";
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Image = ((System.Drawing.Image)(resources.GetObject("menuItemHelp.Image")));
			this.menuItemHelp.Text = "&Help";
			this.menuItemHelp.Activate += new System.EventHandler(this.menuItemHelp_Activate);
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Image = ((System.Drawing.Image)(resources.GetObject("menuItemAbout.Image")));
			this.menuItemAbout.Text = "&About...";
			this.menuItemAbout.Activate += new System.EventHandler(this.menuItemAbout_Activate);
			// 
			// menuItemCheckUpdate
			// 
			this.menuItemCheckUpdate.Text = "Update";
			this.menuItemCheckUpdate.Activate += new System.EventHandler(this.menuItemCheckUpdate_Activate);
			// 
			// toolBarFile
			// 
			this.toolBarFile.AddRemoveButtonsVisible = false;
			this.toolBarFile.AllowMerge = true;
			this.toolBarFile.Closable = false;
			this.toolBarFile.DockLine = 1;
			this.toolBarFile.Guid = new System.Guid("27525b1c-e4f7-4c41-ba0c-1ae26198c0f8");
			this.toolBarFile.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																				 this.BarItemNew,
																				 this.BarItemOpen,
																				 this.BarItemSave,
																				 this.BarItemClose,
																				 this.BarItemRunCDMenu,
																				 this.BarItemStopRunningCDMenu,
																				 this.BarItemProjectFolder,
																				 this.BarItemOptions,
																				 this.buttonItem1});
			this.toolBarFile.Location = new System.Drawing.Point(2, 24);
			this.toolBarFile.Movable = false;
			this.toolBarFile.Name = "toolBarFile";
			this.toolBarFile.Resizable = false;
			this.toolBarFile.ShowShortcutsInToolTips = true;
			this.toolBarFile.Size = new System.Drawing.Size(686, 32);
			this.toolBarFile.Stretch = true;
			this.toolBarFile.TabIndex = 1;
			this.toolBarFile.Tearable = false;
			this.toolBarFile.Text = "";
			// 
			// BarItemNew
			// 
			this.BarItemNew.Image = ((System.Drawing.Image)(resources.GetObject("BarItemNew.Image")));
			this.BarItemNew.ToolTipText = "Create new CD-Menu";
			this.BarItemNew.Activate += new System.EventHandler(this.NewCDMenu_Activate);
			// 
			// BarItemOpen
			// 
			this.BarItemOpen.Image = ((System.Drawing.Image)(resources.GetObject("BarItemOpen.Image")));
			this.BarItemOpen.ToolTipText = "Open CD-Menu";
			this.BarItemOpen.Activate += new System.EventHandler(this.OpenCDMenu_Activate);
			this.BarItemOpen.BeforePopup += new TD.SandBar.MenuItemBase.BeforePopupEventHandler(this.menuItemFile_BeforePopup);
			// 
			// BarItemSave
			// 
			this.BarItemSave.Enabled = false;
			this.BarItemSave.Image = ((System.Drawing.Image)(resources.GetObject("BarItemSave.Image")));
			this.BarItemSave.ToolTipText = "Save";
			this.BarItemSave.Activate += new System.EventHandler(this.SaveCDMenu);
			// 
			// BarItemClose
			// 
			this.BarItemClose.Enabled = false;
			this.BarItemClose.Image = ((System.Drawing.Image)(resources.GetObject("BarItemClose.Image")));
			this.BarItemClose.ToolTipText = "Close CD-Menu";
			this.BarItemClose.Activate += new System.EventHandler(this.CloseCDMenu);
			// 
			// BarItemRunCDMenu
			// 
			this.BarItemRunCDMenu.BeginGroup = true;
			this.BarItemRunCDMenu.Enabled = false;
			this.BarItemRunCDMenu.Image = ((System.Drawing.Image)(resources.GetObject("BarItemRunCDMenu.Image")));
			this.BarItemRunCDMenu.ToolTipText = "Save and Run CD-Menu";
			this.BarItemRunCDMenu.Activate += new System.EventHandler(this.menuItemRunCDMenu_Activate);
			// 
			// BarItemStopRunningCDMenu
			// 
			this.BarItemStopRunningCDMenu.Enabled = false;
			this.BarItemStopRunningCDMenu.Image = ((System.Drawing.Image)(resources.GetObject("BarItemStopRunningCDMenu.Image")));
			this.BarItemStopRunningCDMenu.ToolTipText = "Stop running CD Menu";
			this.BarItemStopRunningCDMenu.Activate += new System.EventHandler(this.BarItemStopCDMenu_Activate);
			// 
			// BarItemProjectFolder
			// 
			this.BarItemProjectFolder.Enabled = false;
			this.BarItemProjectFolder.Image = ((System.Drawing.Image)(resources.GetObject("BarItemProjectFolder.Image")));
			this.BarItemProjectFolder.ToolTipText = "Open CD-Menu folder";
			this.BarItemProjectFolder.Activate += new System.EventHandler(this.menuItemOpenCDMenuFolder_Activate);
			// 
			// BarItemOptions
			// 
			this.BarItemOptions.BeginGroup = true;
			this.BarItemOptions.Image = ((System.Drawing.Image)(resources.GetObject("BarItemOptions.Image")));
			this.BarItemOptions.ToolTipText = "Options";
			this.BarItemOptions.Activate += new System.EventHandler(this.Options_Activate);
			// 
			// buttonItem1
			// 
			this.buttonItem1.Activate += new System.EventHandler(this.buttonItem1_Activate);
			// 
			// MainPanel
			// 
			this.MainPanel.AutoScroll = true;
			this.MainPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.MainPanel.Location = new System.Drawing.Point(0, 56);
			this.MainPanel.Name = "MainPanel";
			this.MainPanel.Size = new System.Drawing.Size(424, 294);
			this.MainPanel.TabIndex = 14;
			// 
			// panelBottom
			// 
			this.panelBottom.Controls.Add(this.statusBar1);
			this.panelBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panelBottom.Location = new System.Drawing.Point(0, 350);
			this.panelBottom.Name = "panelBottom";
			this.panelBottom.Size = new System.Drawing.Size(688, 24);
			this.panelBottom.TabIndex = 15;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 2);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(688, 22);
			this.statusBar1.TabIndex = 16;
			// 
			// tabsTools
			// 
			this.tabsTools.Controls.Add(this.DataManager);
			this.tabsTools.Controls.Add(this.CustomizeManager);
			this.tabsTools.Dock = System.Windows.Forms.DockStyle.Right;
			this.tabsTools.HotTrack = true;
			this.tabsTools.Location = new System.Drawing.Point(424, 56);
			this.tabsTools.Multiline = true;
			this.tabsTools.Name = "tabsTools";
			this.tabsTools.SelectedIndex = 0;
			this.tabsTools.Size = new System.Drawing.Size(264, 294);
			this.tabsTools.TabIndex = 16;
			// 
			// CustomizeManager
			// 
			this.CustomizeManager.Controls.Add(this.propertyGrid);
			this.CustomizeManager.Location = new System.Drawing.Point(4, 22);
			this.CustomizeManager.Name = "CustomizeManager";
			this.CustomizeManager.Size = new System.Drawing.Size(256, 268);
			this.CustomizeManager.TabIndex = 1;
			this.CustomizeManager.Text = "Customize";
			this.CustomizeManager.Visible = false;
			// 
			// propertyGrid
			// 
			this.propertyGrid.CommandsVisibleIfAvailable = true;
			this.propertyGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.propertyGrid.HelpVisible = false;
			this.propertyGrid.LargeButtons = false;
			this.propertyGrid.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.propertyGrid.Location = new System.Drawing.Point(0, 0);
			this.propertyGrid.Name = "propertyGrid";
			this.propertyGrid.Size = new System.Drawing.Size(256, 268);
			this.propertyGrid.TabIndex = 2;
			this.propertyGrid.Text = "propertyGrid";
			this.propertyGrid.ToolbarVisible = false;
			this.propertyGrid.ViewBackColor = System.Drawing.SystemColors.Window;
			this.propertyGrid.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// DataManager
			// 
			this.DataManager.Controls.Add(this.lblDBWarning);
			this.DataManager.Location = new System.Drawing.Point(4, 22);
			this.DataManager.Name = "DataManager";
			this.DataManager.Size = new System.Drawing.Size(256, 268);
			this.DataManager.TabIndex = 0;
			this.DataManager.Text = "Data";
			// 
			// lblDBWarning
			// 
			this.lblDBWarning.Location = new System.Drawing.Point(61, 26);
			this.lblDBWarning.Name = "lblDBWarning";
			this.lblDBWarning.Size = new System.Drawing.Size(100, 37);
			this.lblDBWarning.TabIndex = 0;
			this.lblDBWarning.Text = "No database exist in this CD-Menu.";
			this.lblDBWarning.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblDBWarning.Visible = false;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter1.Location = new System.Drawing.Point(421, 56);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 294);
			this.splitter1.TabIndex = 18;
			this.splitter1.TabStop = false;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 374);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.MainPanel);
			this.Controls.Add(this.tabsTools);
			this.Controls.Add(this.topSandBarDock);
			this.Controls.Add(this.panelBottom);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "CDI Studio";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			this.topSandBarDock.ResumeLayout(false);
			this.panelBottom.ResumeLayout(false);
			this.tabsTools.ResumeLayout(false);
			this.CustomizeManager.ResumeLayout(false);
			this.DataManager.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			//Problem with Visual styles & imagelist. The result is the listview 
			//do not show images. The solution to the problem is to 
			//call "Application.DoEvents()" . For more information refer to:
			//http://blogs.msdn.com/rprabhu/archive/2003/09/28/56540.aspx  
			Application.DoEvents();
			Application.Run(new MainForm());
		}


		#region Fields

		private CDIStudio.Studio.Paths fPaths;
		private OptionsDialog optionsDlg;
		private CDIStudio.Studio.OpenDialog openDialog;
		private CDIStudio.Studio.About about;
		private UpdateNotifyer updateNotifier;
		private System.Diagnostics.Process CDMenuProcess;
		public Localization  localization = new Localization();
		
		private string[] ProjectFiles = new string[]{
														"Autorun.exe",
														"CDMenus.dll",
														"SQLite3.dll",
														"sqlite.net.dll"
													};
		
		
		/// <summary>
		/// Options	for Studio.
		/// </summary>
		public CDIStudio.Studio.Options options;
		#endregion


		#region Propertys	

		/// <summary>
		/// Paths for files	and folders of studio.
		/// </summary>
		public CDIStudio.Studio.Paths Paths
		{
			get{ return fPaths; }
		}



		#endregion


		#region Indexes


		#endregion


		#region Methods

		private void InitializeStudio()
		{

			InitializeVar();
			fPaths = new CDIStudio.Studio.Paths();
			fPaths.CreateFolders();
			InitializeOptions();
			CreateProjectsFolder();
			optionsDlg = new OptionsDialog();
			openDialog = new OpenDialog(this);
			about = new About();
			updateNotifier = new UpdateNotifyer();
			PopulateNewMenu();
			//localize
			localization.LocaleChanged += new SimpleDelegate(this.localeChanged); 
			localization.ChangeLocale(options.CultureInfo);
			

			//Check for new version
			if(options.AutoUpdate)
			{
				updateNotifier.CheckNewVersionSilent();
			}
		}

		private void InitializeVar()
		{
		  Var.MainForm = this;
		}

		private void InitializeOptions()
		{
			//Var
			Stream stream;
			BinaryFormatter bformatter;

			//Open existing "Options.Dat"
			if(System.IO.File.Exists(Paths.OptionsFile))
			{
				stream = File.Open(Paths.OptionsFile, FileMode.Open);
				bformatter = new BinaryFormatter();
				options = (Options)bformatter.Deserialize(stream);
				stream.Close();
			}
			//Create new "option"
			else
			{
				options = new Options();
				options.DefaultValues();
				options.Save();
			}
		}

		private void PopulateNewMenu()
		{
			TD.SandBar.MenuButtonItem newItem;

			foreach(string cdInfoName in CDMenuFactory.cdMenusList.Keys)
			{
				//MainMenu
				newItem = new TD.SandBar.MenuButtonItem();
				newItem.Text = cdInfoName; 
				newItem.Activate += new System.EventHandler(this.NewCDMenu);
				this.menuItemNew.Items.AddRange(new TD.SandBar.ToolbarItemBase[]{newItem});

				//ToolBar
				newItem = new TD.SandBar.MenuButtonItem();
				newItem.Text = cdInfoName; 
				newItem.Activate += new System.EventHandler(this.NewCDMenu);
				this.BarItemNew.Items.Add(newItem);
			}

			//Add a group line between the "New dialog..." and cd-menus.
			//MainMenu
			if(this.menuItemNew.Items.Count > 1)
			{
				((TD.SandBar.MenuButtonItem)this.menuItemNew.Items[1]).BeginGroup = true;
			}
		}

		private void PopulateOpenMenu()
		{
			TD.SandBar.MenuButtonItem newItem;
			this.menuItemOpen.Items.Clear();
			this.BarItemOpen.Items.Clear();


			//MainMenu
			newItem = new TD.SandBar.MenuButtonItem();
			newItem.Text = localization["Open"] + "..."; //"Open dialog...";
			newItem.ImageIndex = 1;
			newItem.Activate += new System.EventHandler(this.OpenCDMenu_Activate);
			this.menuItemOpen.Items.AddRange(new TD.SandBar.ToolbarItemBase[]{newItem});
	

			foreach(string proj in Directory.GetDirectories(options.ProjectsFolder))
			{				
				//MainMenu
				newItem = new TD.SandBar.MenuButtonItem();
				newItem.Text = Path.GetFileName(proj);
				newItem.Activate += new System.EventHandler(this.OpenCDMenu);
				this.menuItemOpen.Items.AddRange(new TD.SandBar.ToolbarItemBase[]{newItem});
			
				//ToolBar
				newItem = new TD.SandBar.MenuButtonItem();
				newItem.Text = Path.GetFileName(proj);
				newItem.Activate += new System.EventHandler(this.OpenCDMenu);
				this.BarItemOpen.Items.Add(newItem);
			}

			//Add a group line between the "Open dialog..." and cd-menus.
			//MainMenu
			if(this.menuItemOpen.Items.Count > 1)
			{
				((TD.SandBar.MenuButtonItem)this.menuItemOpen.Items[1]).BeginGroup = true;
			}
		}
		private void UpdateStudio()
		{
			statusBar1.Text = CDMenu.ProjectFolder;

			if( CDMenuFactory.CDMenu == null)
			{

				menuItemRunCDMenu.Enabled = false;
				menuItemSave.Enabled = false;
				menuItemClose.Enabled = false;
				menuItemOpenCDMenuFolder.Enabled = false;
				BarItemSave.Enabled = false;
				BarItemClose.Enabled = false;
				BarItemRunCDMenu.Enabled = false;
				BarItemStopRunningCDMenu.Enabled = false;
				menuItemStopRunningCDMenu.Enabled = false;
				BarItemProjectFolder.Enabled = false;
				lblDBWarning.Visible = false;
			}
			else
			{
				menuItemRunCDMenu.Enabled = true;
				menuItemSave.Enabled = true;
				menuItemClose.Enabled = true;
				menuItemOpenCDMenuFolder.Enabled = true;
				BarItemSave.Enabled = true;
				BarItemClose.Enabled = true;
				BarItemRunCDMenu.Enabled = true;
				BarItemProjectFolder.Enabled = true;

				if( CDMenuFactory.CDMenu.DB == null)
				{
					lblDBWarning.Visible = true;
				}
			}
		}

		//Project related
		private bool NewCDMenu(string ClassName)
		{
			try
			{
				this.Cursor = Cursors.WaitCursor;
				NewDialog newDialog = new NewDialog(this);
				newDialog.CDMenu = ClassName;
				if (newDialog.ShowDialog() == DialogResult.OK)
				{
					CloseCDMenu();

					ClassName = newDialog.listView.SelectedItems[0].Text;
					CDMenu.ProjectFolder = options.ProjectsFolder + @"\" + newDialog.ProjectName;
					CreateProjectDirectorys();
					CreateProjectFiles();
					CopyProjectFiles(ClassName);
					CDMenuFactory.CreateCDMenu(CDMenuFactory.GetCDMenu(ClassName));			   
					CDMenuFactory.CDMenu.Options.Autorun = new ActionParameters();
					if   (CDMenuFactory.CDMenu.DB != null)
					{
						CDMenuFactory.CDMenu.DB.CreateDB();
					}
					InitializeCDMenu();
					//Create file "CDMenu.cdi"
					SerializeCDMenu();

					UpdateStudio();
					return true;
				}
			}
			finally
			{
				this.Cursor = Cursors.Default;
			}
			return false;
		}

		private void OpenCDMenu(string projectFolder)
		{
			CloseCDMenu();
			CDMenu.ProjectFolder = projectFolder;
			CDMenuFactory.OpenCDMenu(CDMenu.CDMenuFolder + @"\CDMenu.cdi", false);
			InitializeCDMenu();
			UpdateStudio();
		}

		private void CloseCDMenu()
		{
			if (CDMenuFactory.CDMenu != null)
			{
				Validate();
				KillCDMenuProcess();
				propertyGrid.SelectedObject = null;
				CDMenuFactory.CDMenu.Dispose();
				CDMenuFactory.CDMenu = null;
			}

			CDMenu.ProjectFolder = "";
			UpdateStudio();
		}
		private void SaveCDMenu()
		{
			Validate();
			//Make sure the files are not used by "CDMenuProcess"
			if((CDMenuProcess == null) ||((CDMenuProcess != null) && (CDMenuProcess.HasExited)))
			{
				CreateProjectDirectorys();
				CreateProjectFiles();
				CopyProjectFiles(CDMenuFactory.CDMenuName);
			
				//Serialize
				SerializeCDMenu();

				//Save DB
				if (CDMenuFactory.CDMenu.DB != null)
				{	
					CDMenuFactory.CDMenu.DB.SaveDB();
				}
			}
			else
				MessageBox.Show(this,"Please close the running cd-menu before save.","CD-Menu running",System.Windows.Forms.MessageBoxButtons.OK,
					System.Windows.Forms.MessageBoxIcon.Warning);

		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			CloseCDMenu();
		}

		private void buttonItem1_Activate(object sender, System.EventArgs e)
		{
			string str = "";
			foreach(System.Diagnostics.Process pr in System.Diagnostics.Process.GetProcesses())
			{
				if(pr.ProcessName == "Autorun")
				
				str +=	pr.ProcessName + " : " + Convert.ToString(pr.Handle) + "\n";
			}
				MessageBox.Show(str);
			
		}

		private void BarItemStopCDMenu_Activate(object sender, System.EventArgs e)
		{
			KillCDMenuProcess();
		}



		private void menuItemTranslator_Activate(object sender, System.EventArgs e)
		{
			if(
				MessageBox.Show(this,"With translator you can translate CDI Studio in your " + 
				"native language and send it for inclusion in the next release. The file " +
				"you send will be under GNU General Public License (GPL)." , "Read me" ,
				MessageBoxButtons.OKCancel , MessageBoxIcon.Information) == DialogResult.OK)
			{
				CDIStudio.Studio.Tools.Translator.Translator tr = new CDIStudio.Studio.Tools.Translator.Translator();
				tr.Show();
			}
		}


		private void localeChanged()
		{
			//MainMenu
			menuItemFile.Text = localization["File"];
			menuItemNew.Text = localization["New"];
			menuItemNewDialog.Text = localization["New"] + "...";
			menuItemOpen.Text = localization["Open"];
			menuItemSave.Text = localization["Save"];
			menuItemClose.Text = localization["Close"];
			menuItemExit.Text = localization["Exit"];
			menuItemProject.Text = localization["Project"];
			menuItemRunCDMenu.Text = localization["Save and Run CD-Menu"];
			menuItemOpenCDMenuFolder.Text = localization["Open CD-Menu folder"];
			menuItemTools.Text = localization["Tools"];
		    menuItemOptions.Text = localization["Options"] + "...";
			menuItemTranslator.Text = localization["Translator"] + "...";
			menuItemHelpMain.Text = localization["Help"];
			menuItemHelp.Text = localization["Help"] + "...";
			menuItemAbout.Text = localization["About"] + "...";
			menuItemCheckUpdate.Text = localization["Update"] + "...";

			//ToolTips
			BarItemNew.ToolTipText = localization["New"];
			BarItemOpen.ToolTipText = localization["Open"];
			BarItemSave.ToolTipText = localization["Save"];
			BarItemClose.ToolTipText = localization["Close"];
			BarItemRunCDMenu.ToolTipText = localization["Save and Run CD-Menu"];
			BarItemProjectFolder.ToolTipText = localization["Open CD-Menu folder"];
			BarItemOptions.ToolTipText = localization["Options"];

			//Various
			lblDBWarning.Text = localization["No database exists in this CD-Menu"];
			DataManager.Text =	localization["Data"];
			CustomizeManager.Text = localization["Customize"];
		}

		private void OpenCDMenu_Activate(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				if(openDialog.ShowDialog(this) == DialogResult.OK)
				{
					string prjPath;

					prjPath = options.ProjectsFolder + @"\" + openDialog.listView.SelectedItems[0].Text;
					OpenCDMenu(prjPath);
				}
			}
			finally
			{
				Cursor = Cursors.Default;
			}		
		}

		private void NewCDMenu_Activate(object sender, System.EventArgs e)
		{		
			NewCDMenu("");		
		}

		private void menuItemHelp_Activate(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start(@"Help\CDI_Studio_2_User_Guide.chm");
		}

		private void menuItemCheckUpdate_Activate(object sender, System.EventArgs e)
		{
			updateNotifier.CheckNewVersionLoud();
		}

		private void Options_Activate(object sender, System.EventArgs e)
		{
			optionsDlg.ShowDialog();
		}


		private void menuItemExit_Activate(object sender, System.EventArgs e)
		{
			CloseCDMenu();
			Application.Exit();
		}

		private void menuItemAbout_Activate(object sender, System.EventArgs e)
		{
			about.ShowDialog();
		}

		private void CDMenuForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			CloseCDMenu();
		}

		private void menuItemFile_BeforePopup(object sender, TD.SandBar.MenuPopupEventArgs e)
		{
			PopulateOpenMenu();
		}


		private void menuItemRunCDMenu_Activate(object sender, System.EventArgs e)
		{		
			if (CDMenuFactory.CDMenu != null) 
				if((CDMenuProcess == null) ||((CDMenuProcess != null) && (CDMenuProcess.HasExited)))
				{
					SaveCDMenu();
					//Bypass the win32 "Autostart.exe" , because it start the .net "Autostart.exe" in the 
					//bin folder and exits . So starts directly the .net "Autostart.exe".
					CDMenuProcess = System.Diagnostics.Process.Start(CDMenu.BinFolder + @"\Autorun.exe");
					BarItemStopRunningCDMenu.Enabled = true;
					menuItemStopRunningCDMenu.Enabled = true;

//					Process p = Process.Start(&quot;notepad.exe&quot;);
					BarItemRunCDMenu.Enabled = false;
					menuItemRunCDMenu.Enabled = false;
					while (!CDMenuProcess.HasExited)

					{

						System.Windows.Forms.Application.DoEvents();

					}
					BarItemStopRunningCDMenu.Enabled = false;
					menuItemStopRunningCDMenu.Enabled = false;

					if(CDMenuFactory.CDMenu != null)
					{
						BarItemRunCDMenu.Enabled = true;
						menuItemRunCDMenu.Enabled = true;
					}
				}
		}

		private void KillCDMenuProcess()
		{
			
			if((CDMenuProcess != null) && (!CDMenuProcess.HasExited))
				CDMenuProcess.Kill();
		}

		private void menuItemOpenCDMenuFolder_Activate(object sender, System.EventArgs e)
		{
			if (CDMenuFactory.CDMenu != null)
			{
				if (CDMenu.ProjectFolder != "")
					System.Diagnostics.Process.Start(CDMenu.ProjectFolder);
			}
		}


		private void InitializeCDMenu()
		{
			CDMenuFactory.CDMenu.IDEMode = true;
			CDMenuFactory.CDMenu.StudioInitialization();
			CDMenuFactory.CDMenu.TopLevel = false;
			CDMenuFactory.CDMenu.Location = new System.Drawing.Point(10, 10);
			CDMenuFactory.CDMenu.Parent = MainPanel;
			CDMenuFactory.CDMenu.PropertyGrid = propertyGrid;
			CDMenuFactory.CDMenu.SizeChanged += new System.EventHandler(this.CDMenuSizeChanged);
			CDMenuFactory.CDMenu.Closing += new System.ComponentModel.CancelEventHandler(this.CDMenuForm_Closing);
			if   (CDMenuFactory.CDMenu.DB != null)
			{
				CDMenuFactory.CDMenu.DB.OpenDB();
				CDMenuFactory.CDMenu.InitializeDataBindings();
				CDMenuFactory.CDMenu.DB.CreateDataPanel();
				CDMenuFactory.CDMenu.DB.dataPanel.Parent =	DataManager;
				CDMenuFactory.CDMenu.DB.dataPanel.Dock = System.Windows.Forms.DockStyle.Fill;	
			}


			CDMenuFactory.CDMenu.Show();
			propertyGrid.SelectedObject = CDMenuFactory.CDMenu.PropBag;	
		}

		private	void CreateProjectDirectorys()
		{
			if (!Directory.Exists(CDMenu.ProjectFolder))
				Directory.CreateDirectory(CDMenu.ProjectFolder);
			if (!Directory.Exists(CDMenu.MyFilesFolder))
				Directory.CreateDirectory(CDMenu.MyFilesFolder);
			if (!Directory.Exists(CDMenu.DataFolder))
				Directory.CreateDirectory(CDMenu.DataFolder);
			if (!Directory.Exists(CDMenu.BinFolder))
				Directory.CreateDirectory(CDMenu.BinFolder);
			if (!Directory.Exists(CDMenu.CDMenuFolder))
				Directory.CreateDirectory(CDMenu.CDMenuFolder);
			if (!Directory.Exists(CDMenu.DBFolder))
				Directory.CreateDirectory(CDMenu.DBFolder);
		}

		/// <summary>
		/// Create the "ProjectsFolder" where all projects are stored. 
		/// </summary>
		public void CreateProjectsFolder()
		{
			System.IO.DirectoryInfo dir = new DirectoryInfo(options.ProjectsFolder);	
			
			if (!Directory.Exists(options.ProjectsFolder))
			{
				dir	= Directory.CreateDirectory(options.ProjectsFolder);			
			}

			dir.Attributes = dir.Attributes | System.IO.FileAttributes.System;
			

			//This gives a custom icon look to the folder
			//Create 'desktop.ini' file in 'Projects directory'
			string txtFile = options.ProjectsFolder + @"\desktop.ini";
			StreamWriter strmtxt;
			if(!File.Exists(txtFile))					
			{
				strmtxt = File.CreateText(txtFile);
				strmtxt.WriteLine(@"[.ShellClassInfo]");
				strmtxt.WriteLine(@"IconFile=" + Application.StartupPath + @"\CDFolder.ICO");
				strmtxt.WriteLine(@"IconIndex=0");
				strmtxt.Close();
			}
			System.IO.FileInfo fileIni = new FileInfo(options.ProjectsFolder + @"\desktop.ini");
			fileIni.Attributes = fileIni.Attributes | System.IO.FileAttributes.Hidden;
		}

		private void CreateProjectFiles()
		{
			string txtFile;
			StreamWriter strmtxt;

			//'Readme.txt' file in 'data' folder
			txtFile = CDMenu.DataFolder + @"/Read me.txt";
			if(!File.Exists(txtFile))
			{
				strmtxt = File.CreateText(txtFile);
				strmtxt.WriteLine("");
				strmtxt.WriteLine(@"***** PLEASE DO NOT MODIFY THE CONTEND OF THIS FOLDER. *****");
				strmtxt.WriteLine("");
				strmtxt.WriteLine(@" The content of this folder is autogenerated by ");
				strmtxt.WriteLine("             'CDInterface Studio'.");
				strmtxt.Close();
			}

			//'Readme.txt' file in 'My Files' folder
			txtFile = CDMenu.MyFilesFolder + @"/Read me.txt";
			if(!File.Exists(txtFile))
			{
				strmtxt = File.CreateText(txtFile);
				strmtxt.WriteLine("");
				strmtxt.WriteLine(@"***** PLEASE PLACE ALL YOUR FILES IN THIS FOLDER. *****");
				strmtxt.WriteLine("");
				strmtxt.WriteLine(@" This folder is autogenerated by 'CDInterface Studio'");
				strmtxt.WriteLine("             for your personal use.");
				strmtxt.Close();
			}

			//'autorun.inf' file in Project Folder
			txtFile = CDMenu.ProjectFolder + @"/autorun.inf";
			strmtxt = File.CreateText(txtFile);
			strmtxt.WriteLine(@"[autorun]");
			strmtxt.WriteLine(@"OPEN=Autorun.exe");
			if(CDMenuFactory.CDMenu != null)
			{
				if(CDMenuFactory.CDMenu.Options.Icon != null)
				{
					//Create Icon for CD
					System.IO.FileStream IconStream =   new System.IO.FileStream(CDMenu.CDMenuFolder + @"\icon.ico",System.IO.FileMode.Create);
					CDMenuFactory.CDMenu.Options.Icon.Save(IconStream);
					IconStream.Close();
					
					//Write "ICON" in the 'autorun.inf'
					strmtxt.WriteLine(@"ICON=" + CDMenu.GetRelativePath(CDMenu.CDMenuFolder)+ @"\icon.ico");
				}
			}
			strmtxt.Close();
		}
		private void CopyProjectFiles(string CDMenuName)
		{
			string currDir =  Path.GetDirectoryName(Application.ExecutablePath) + @"\";
			
			//copy to the bin folder
			foreach(string aFile in ProjectFiles)
				File.Copy(currDir + aFile, CDMenu.BinFolder+@"\" + aFile, true);

			//copy librarys of the specific CDMenu to the bin folder
			if ( CDMenuFactory.GetCDMenuInfo(CDMenuName).Librarys != null)
			{
				foreach(string aFile in CDMenuFactory.GetCDMenuInfo(CDMenuName).Librarys)
					File.Copy(currDir + aFile, CDMenu.BinFolder+@"\" + aFile, true);
			}

			//Copy   Autorun32
		    File.Copy(currDir + "Autorun32.exe", CDMenu.ProjectFolder+@"\Autorun.exe", true);
		}

		private void SerializeCDMenu()
		{
			//Serialize
			CDMenuFactory.SerializeCDMenu(CDMenu.CDMenuFolder+@"\CDMenu.cdi");
		}

		private void CDMenuSizeChanged(object sender, System.EventArgs e)
		{
			if(CDMenuFactory.CDMenu != null)
			{
				MainPanel.Refresh();
				this.ActiveControl = CDMenuFactory.CDMenu;
//				if(CDMenuFactory.CDMenu.Size.Width + 20 > MainPanel.Width)
////				MainPanel.Width  = MainPanel.ClientSize.Width + 20;
//				MainPanel.SetAutoScrollMargin(100,100);
			}
		}
		#endregion


		#region Events
		private void  NewCDMenu(object sender, System.EventArgs e)
		{   
			string className = ((TD.SandBar.MenuButtonItem)sender).Text;
			
			NewCDMenu(className);
		}

		private void OpenCDMenu(object sender, System.EventArgs e)
		{
			TD.SandBar.MenuButtonItem menuItem = (TD.SandBar.MenuButtonItem)sender;
			string projectFolder;

			//MessageBox.Show(menuItem.Text);
			projectFolder = options.ProjectsFolder + @"\" + menuItem.Text;
			OpenCDMenu(projectFolder);
		}

		private void Select_MenuItemOpen(object sender, System.EventArgs e)
		{
			PopulateOpenMenu();
		}

		private void  CloseCDMenu(object sender, System.EventArgs e)
		{
			CloseCDMenu();		  
		}



		private void SaveCDMenu(object sender, System.EventArgs e)
		{
			SaveCDMenu();
		}


		#endregion

	}
}
