#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using CDIStudio.CDMenus;
using MsHtmlCustomization;
using System.Runtime.InteropServices;
using CDIStudio.CDMenus.Components;

namespace CDIStudio.Studio
{
	/// <summary>
	/// Summary description for NewDialog.
	/// </summary>
	public class NewDialog : System.Windows.Forms.Form,
		IOleClientSite,
		IDocHostUIHandler
	{
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.TextBox tbName;
		private System.Windows.Forms.ImageList imageList32;
		private CDIStudio.Studio.MainForm mainForm;
		public System.Windows.Forms.ListView listView;
		private AxSHDocVw.AxWebBrowser WebBrowser;
		private System.ComponentModel.IContainer components;
		/// <summary>
		/// 
		/// </summary>
		public NewDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// tell WebBrowser that we are its host
			object obj = WebBrowser.GetOcx();
			IOleObject oc = obj as IOleObject;
			oc.SetClientSite(this);

			//localize
			Var.MainForm.localization.LocaleChanged += new SimpleDelegate(this.localeChanged); 
		}
	   /// <summary>
	   /// 
	   /// </summary>
	   /// <param name="aMainForm"></param>
		public NewDialog(CDIStudio.Studio.MainForm aMainForm):this()
		{
			mainForm = aMainForm;
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(NewDialog));
			this.lblName = new System.Windows.Forms.Label();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.tbName = new System.Windows.Forms.TextBox();
			this.listView = new System.Windows.Forms.ListView();
			this.imageList32 = new System.Windows.Forms.ImageList(this.components);
			this.WebBrowser = new AxSHDocVw.AxWebBrowser();
			((System.ComponentModel.ISupportInitialize)(this.WebBrowser)).BeginInit();
			this.SuspendLayout();
			// 
			// lblName
			// 
			this.lblName.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblName.Location = new System.Drawing.Point(165, 379);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(146, 13);
			this.lblName.TabIndex = 7;
			this.lblName.Text = "Name:";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(594, 418);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 6;
			this.btnCancel.Text = "Cancel";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(509, 418);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 5;
			this.btnOK.Text = "OK";
			// 
			// tbName
			// 
			this.tbName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbName.Location = new System.Drawing.Point(165, 392);
			this.tbName.Name = "tbName";
			this.tbName.Size = new System.Drawing.Size(499, 20);
			this.tbName.TabIndex = 4;
			this.tbName.Text = "";
			this.tbName.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tbName_KeyPress);
			// 
			// listView
			// 
			this.listView.Activation = System.Windows.Forms.ItemActivation.OneClick;
			this.listView.HideSelection = false;
			this.listView.HoverSelection = true;
			this.listView.LargeImageList = this.imageList32;
			this.listView.Location = new System.Drawing.Point(3, 5);
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(157, 406);
			this.listView.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.listView.TabIndex = 8;
			this.listView.DoubleClick += new System.EventHandler(this.listView_DoubleClick);
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			// 
			// imageList32
			// 
			this.imageList32.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList32.ImageSize = new System.Drawing.Size(32, 32);
			this.imageList32.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList32.ImageStream")));
			this.imageList32.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// WebBrowser
			// 
			this.WebBrowser.Enabled = true;
			this.WebBrowser.Location = new System.Drawing.Point(165, 5);
			this.WebBrowser.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("WebBrowser.OcxState")));
			this.WebBrowser.Size = new System.Drawing.Size(499, 365);
			this.WebBrowser.TabIndex = 9;
			// 
			// NewDialog
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(671, 446);
			this.Controls.Add(this.WebBrowser);
			this.Controls.Add(this.listView);
			this.Controls.Add(this.lblName);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.tbName);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NewDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "New";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.NewDialog_Closing);
			this.VisibleChanged += new System.EventHandler(this.NewDialog_VisibleChanged);
			((System.ComponentModel.ISupportInitialize)(this.WebBrowser)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion



		#region Fields
		private string FCDMenu;
		private	char[]invalidChar = new char[]{'\\','/',':','*','?','"','<','>','|','.'};
		#endregion


		#region Propertys
		/// <summary>
		/// The name of the project.
		/// </summary>
		public string ProjectName
		{
			get{ return tbName.Text;}
		}

		/// <summary>
		/// The name of the CDMenuClass.
		/// </summary>
		public string CDMenu 
		{
			get
			{
				return FCDMenu;
			}
			set
			{
				FCDMenu = value;
			}
		}
		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void NewDialog_VisibleChanged(object sender, System.EventArgs e)
		{
			if (this.Visible)
			{

				listView.Clear();
				foreach(string cdInfoName in CDMenuFactory.cdMenusList.Keys)
				{
					listView.Items.Add(Path.GetFileName(cdInfoName),0);
				}
				btnOK.Enabled = false;					
				CDMenuToWebBrowser("");

				if(CDMenu != "")
				{
					foreach(ListViewItem item in listView.Items)
						if(item.Text == CDMenu)
						{
							listView.Items[listView.Items.IndexOf(item)].Selected = true;
							listView.Select();
							break;
						}						
				}

				tbName.Text = "";
			}
		}
		
		private void localeChanged()
		{
			this.Text = Var.MainForm.localization["New"];
			this.btnOK.Text = Var.MainForm.localization["OK"];
			this.btnCancel.Text = Var.MainForm.localization["Cancel"];
			this.lblName.Text = Var.MainForm.localization["Name"];
		}

		private void CDMenuToWebBrowser(string typeName)
		{
			string url;
			if(typeName == "")
			{
				url = Application.StartupPath + @"\Empty.htm"; 
			}
			else
			{
				string prefix = @"ms-its:";
				string helpFile = Application.StartupPath + @"\Help\CDI_Studio_2_User_Guide.chm";
				url = prefix + helpFile + "::/Html/CDMenus/"+ typeName + ".htm";
			}
			WebBrowser.Navigate(url);
		}
		#endregion


		#region Events

		#endregion

		#region	 Name Validation
		private bool IsValid(char testChar)
		{
			//if(tbName.Text.IndexOfAny(invalidChar) > -1)
			//	return false;
			foreach(char invChar in invalidChar)
			{
				if (invChar == testChar)
				{
					return false;
				}
			}
			return true;
		}

 		private void tbName_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if  (!IsValid(e.KeyChar)) 
			{
				e.Handled = true;			
			}
		}
			
		private void NewDialog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(this.DialogResult == DialogResult.OK)
			{
				//Not empty string
				if(tbName.Text == "")
				{
					this.DialogResult = System.Windows.Forms.DialogResult.None;
					MessageBox.Show("'Name' can NOT be empty.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}

					//Valid name
				else if(tbName.Text.IndexOfAny(invalidChar) > -1)
				{
					this.DialogResult = System.Windows.Forms.DialogResult.None;
					MessageBox.Show(@"Invalid 'name'. The folowing characters are NOT allowed:
	\ / : * . ? "" <  > |",
						"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
					tbName.Text = "";
				}

					//Project already exist
				else if (Directory.Exists(mainForm.options.ProjectsFolder + @"\" + tbName.Text))
				{
					this.DialogResult = System.Windows.Forms.DialogResult.None;
					MessageBox.Show("Project already exist. Please select a different name.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
			}
		}

	    #endregion

		#region	 CD-Menu Selection
		private void listView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			CDIStudio.CDMenus.CDMenuInfo info;
			btnOK.Enabled =	(listView.SelectedItems.Count > 0);
				
			if (listView.SelectedItems.Count > 0)
			{		  	
				info = CDMenuFactory.GetCDMenuInfo( listView.SelectedItems[0].Text);
				CDMenu = listView.SelectedItems[0].Text;
				CDMenuToWebBrowser(CDMenuFactory.GetCDMenu(info.Name).Name);
			}
			else
			{
				CDMenu = "";
				CDMenuToWebBrowser("");
			}
		}

		private void listView_DoubleClick(object sender, System.EventArgs e)
		{
			if(CDMenu != "")
			{
				if(listView.SelectedItems.Count > 0)
				{
					DialogResult = System.Windows.Forms.DialogResult.OK;
				}
			}
		}


		#endregion

		#region IOleClientSite methods

		void IOleClientSite.SaveObject() {}
		void IOleClientSite.GetMoniker(uint dwAssign, uint dwWhichMoniker, ref object ppmk) {}
		void IOleClientSite.GetContainer(ref object ppContainer) {ppContainer = this;}
		void IOleClientSite.ShowObject() {}
		void IOleClientSite.OnShowWindow(bool fShow) {}
		void IOleClientSite.RequestNewObjectLayout() {}

		#endregion
  
		#region IDocHostUIHandler methods

		public void ShowContextMenu(MsHtmlCustomization.ContextMenuTarget dwContext, 
			ref MsHtmlCustomization.POINT pPoint, 
			MsHtmlCustomization.IOleCommandTarget pCommandTarget, 
			object HTMLTagElement) 
		{
			// use this code to show a custom menu
//			const int Ok = 0;
//			Point p = new Point(pPoint.x, pPoint.y);
//			p = PointToClient(p); 
//			myCustomContextMenu.Show(this, p);
//			throw new COMException("", Ok); // HRESULT = S_OK: MSHTML won't show its menu

			// use this code to disable menu
			const int Ok = 0;
			throw new COMException("", Ok); // HRESULT = S_OK: MSHTML won't show its menu

			// use this code to let MsHtml shows its menu
			// const int Error = 1;
			// throw new COMException("", Error); // HRESULT = S_FALSE: MSHTML will show its menu
		}

		public void GetHostInfo(ref MsHtmlCustomization.DOCHOSTUIINFO theHostUIInfo)
		{
			// turn three flags on
//			theHostUIInfo.dwFlags |= (DOCHOSTUIFLAG.DOCHOSTUIFLAG_SCROLL_NO |
//				DOCHOSTUIFLAG.DOCHOSTUIFLAG_NO3DBORDER |
//				DOCHOSTUIFLAG.DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE);
		}
    
		public void ShowUI(int dwID, object pActiveObject, MsHtmlCustomization.IOleCommandTarget pCommandTarget, object pFrame, object pDoc) {}
		public void HideUI() {}
		public void UpdateUI() {}
		public void EnableModeless(int fEnable) 
		{
			int i = fEnable;
//			Trace.WriteLine("EnableModeless: fEnable= " + i);
		}
		public void OnDocWindowActivate(int fActivate) {}
		public void OnFrameWindowActivate(int fActivate) {}
		public void ResizeBorder(ref MsHtmlCustomization.RECT prcBorder, int pUIWindow, int fFrameWindow) {}
    
		public void TranslateAccelerator(ref MsHtmlCustomization.MSG lpMsg, ref MsHtmlCustomization.UUID pguidCmdGroup, int nCmdID) 
		{
			const int Ok = 0;
			const int Error = 1;
			const int WM_KEYDOWN = 0x0100;
      
			if (lpMsg.message != WM_KEYDOWN)
				// allow message
				throw new COMException("", Error); // returns HRESULT = S_FALSE

			if ( (Control.ModifierKeys & Keys.Control) != Keys.Control) 
				throw new COMException("", Error); // returns HRESULT = S_FALSE

			// disable the Ctrl-N and Ctrl-P accelerators
			lpMsg.wParam &= 0xFF; // get the virtual keycode
			if ( (lpMsg.wParam == 'N') || ((lpMsg.wParam == 'P')) )
				throw new COMException("", Ok); // returns HRESULT = S_OK

			// allow everything else
			throw new COMException("", Error); // returns HRESULT = S_FALSE
		}
    
		public void GetOptionKeyPath(ref string path, int dw) {} 

		public MsHtmlCustomization.IDropTarget GetDropTarget(MsHtmlCustomization.IDropTarget pDropTarget) 
		{
			return pDropTarget;
		}
		public object GetExternal() 
		{
			return null;
		}

		public void TranslateUrl(int dwTranslate, string URLIn, out string URLOut)
		{
			URLOut = URLIn; // add code here to modify the Url the user is trying to
			// navigate to. Ex:
			//      // prevent users from leaving your web site
			//      if (URLIn.IndexOf("mywebsite.com") < 0)
			//        URLOut = "http://www.mywebsite.com";
			//      else
			//        URLOut = URLIn;
		}

		public MsHtmlCustomization.IDataObject FilterDataObject(MsHtmlCustomization.IDataObject doIn) 
		{
			return doIn;
		}
		#endregion

	}
}
