#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace CDIStudio.Studio
{
	/// <summary>
	/// Summary description for OpenDialog.
	/// </summary>
	public class OpenDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		/// <summary>
		/// 
		/// </summary>
		public System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// 
		/// </summary>
		public System.Windows.Forms.ListView listView;
		private System.Windows.Forms.ImageList imageList32;
		private System.ComponentModel.IContainer components;
		/// <summary>
		/// 
		/// 
		/// </summary>
		public OpenDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//localize
			Var.MainForm.localization.LocaleChanged += new SimpleDelegate(this.localeChanged);
		}
		/// <summary>
		/// 
		/// 
		/// </summary>
		/// <param name="aMainForm"></param>
		public OpenDialog(MainForm aMainForm):this()
		{
			mainForm = aMainForm;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OpenDialog));
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.listView = new System.Windows.Forms.ListView();
			this.imageList32 = new System.Windows.Forms.ImageList(this.components);
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Controls.Add(this.btnOK);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 236);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(401, 39);
			this.panel1.TabIndex = 1;
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(316, 9);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "Cancel";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Enabled = false;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(231, 9);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "OK";
			// 
			// listView
			// 
			this.listView.Activation = System.Windows.Forms.ItemActivation.OneClick;
			this.listView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView.HoverSelection = true;
			this.listView.LargeImageList = this.imageList32;
			this.listView.Location = new System.Drawing.Point(0, 0);
			this.listView.MultiSelect = false;
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(401, 236);
			this.listView.SmallImageList = this.imageList32;
			this.listView.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.listView.StateImageList = this.imageList32;
			this.listView.TabIndex = 2;
			this.listView.Click += new System.EventHandler(this.listView_Click);
			this.listView.VisibleChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			this.listView.DoubleClick += new System.EventHandler(this.listView_DoubleClick);
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			// 
			// imageList32
			// 
			this.imageList32.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList32.ImageSize = new System.Drawing.Size(32, 32);
			this.imageList32.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList32.ImageStream")));
			this.imageList32.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// OpenDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(401, 275);
			this.Controls.Add(this.listView);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OpenDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Open";
			this.VisibleChanged += new System.EventHandler(this.OpenDialog_VisibleChanged);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Fields
		private CDIStudio.Studio.MainForm mainForm;

		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void listView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listView.SelectedItems.Count > 0)
				btnOK.Enabled =true;
			else 
				btnOK.Enabled = false;			
		}

		private void listView_Click(object sender, System.EventArgs e)
		{
			//MessageBox.Show(listView.SelectedItems[0].Text);
		}

		private void listView_DoubleClick(object sender, System.EventArgs e)
		{
			if(listView.SelectedItems.Count > 0)
			{
				DialogResult = System.Windows.Forms.DialogResult.OK;
			}
		}

		private void OpenDialog_VisibleChanged(object sender, System.EventArgs e)
		{
			if (this.Visible)
			{
				listView.Clear();			
				foreach(string proj in Directory.GetDirectories(mainForm.options.ProjectsFolder))
				{				
					listView.Items.Add(Path.GetFileName(proj),0);
				}
			}
		}

		
		private void localeChanged()
		{
			this.Text = Var.MainForm.localization["Open"];
			this.btnOK.Text = Var.MainForm.localization["OK"];
			this.btnCancel.Text = Var.MainForm.localization["Cancel"];
		}
		
		#endregion


		#region Events


		#endregion
	}
}
