#region	 Licence and informations



/***************************************************************************************
 *		Date	:	23-4-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description: Retrieve info from a PAD file.
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Xml;
using System.Runtime ;
using System.Runtime.InteropServices ;

namespace CDIStudio.Studio
		  
{
	/// <summary>
	/// Represent a PAD file.
	/// </summary>
	public class PAD
	{
		/// <summary>
		/// Represent a PAD file.
		/// </summary>
		public PAD()
		{
			//
			// TODO: Add constructor logic here
			//
			xmlDoc = new XmlDocument();
		}

	    private string fURL;
		System.Xml.XmlDocument xmlDoc;
		System.Xml.XmlTextReader rd ;
			

		/// <summary>
		/// The URL of the PAD file.
		/// </summary>
		public string URL
		{
			get{ return fURL;}
			set{ fURL = value;}
		}

		/// <summary>
		/// The version of the software that is descriped by the PAD.
		/// </summary>
		public string Version
		{
			get{return xmlDoc.ChildNodes[1].ChildNodes[2].ChildNodes[1].InnerText;}
		}

		/// <summary>
		/// Read the PAD file.
		/// </summary>
		public void Read()
		{
			rd = new XmlTextReader(URL);
			xmlDoc.Load(rd);
		}
	}


	/// <summary>
	/// Checks if you are connected to the internet
	/// </summary>
	public class InternetCS
	{

		//Creating the extern function...
		[DllImport("wininet.dll")]
		private extern static bool InternetGetConnectedState(out int  Description, int ReservedValue ) ;

		
		/// <summary>
		/// Check if you are connected to the internet
		/// </summary>
		/// <returns></returns>
		public static bool IsConnectedToInternet( )
		{
		   //Creating a function that uses the API function...
			int Desc ;
			return InternetGetConnectedState( out Desc, 0 ) ;

		}

	}
}
