#region	 Licence and informations



/***************************************************************************************
 *		Date	:	21-4-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description: Paths for files and folder.
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.IO;
using System.Windows.Forms;

namespace CDIStudio.Studio
{
	/// <summary>
	/// Paths for files and folder.
	/// </summary>
	public class Paths
	{
		/// <summary>
		/// Paths for files and folder.
		/// </summary>
		public Paths()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#region	 Fields


		#endregion

		#region	Properties

		/// <summary>
		/// CDIStudio's corresponding LocalApplicationData folder.
		/// Ex."C:\Documents and Settings\UserName\Local Settings\Application Data\CDInterface Studio"
		/// </summary>
		public  string UserLocalFolder
		{
			get
			{ 
				return Environment.GetFolderPath(
					Environment.SpecialFolder.LocalApplicationData) +
					@"\CDInterface Studio";
			}
		}

		/// <summary>
		/// CDIStudio's corresponding LocalApplicationData folder for version 2.
		/// Ex."C:\Documents and Settings\UserName\Local Settings\Application Data\CDInterface Studio\CDI2"
		/// </summary>
		public  string UserLocalFolderCDI2
		{
			get
			{ 
				return UserLocalFolder +@"\CDI2";
			}
		}

		/// <summary>
		/// Options file.
		/// </summary>
		public  string OptionsFile
		{
			get
			{ 
				return UserLocalFolderCDI2 +@"\Options.dat";
			}
		}

		/// <summary>
		/// Language folder.
		/// </summary>
		public  string LanguageFolder
		{
			get
			{ 
				return Application.StartupPath + @"\Language";
			}
		}
	    #endregion

		#region	 Methods

		/// <summary>
		/// Create studio's folders.
		/// </summary>
		public void CreateFolders()
		{
			if(!Directory.Exists(UserLocalFolderCDI2))
			{
				Directory.CreateDirectory(UserLocalFolderCDI2);
			}
		}


		#endregion
	}
}
