#region	 Licence and informations



/***************************************************************************************
 *		Date	:	21-4-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:  A dialog to modify options.
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Globalization;
using System.Threading;
using System.IO;

namespace CDIStudio.Studio.OptionsDlg
{
	/// <summary>
	/// A dialog to modify options.
	/// </summary>
	public class OptionsDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox txtBoxProjectsFolder;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
		private System.Windows.Forms.CheckBox chBoxAutoUpdate;
		private SteepValley.Windows.Forms.XPLine xpLine1;
		private SteepValley.Windows.Forms.XPLine xpLine2;
		private System.Windows.Forms.ComboBox cbLanguage;
		private System.Windows.Forms.Label lblProjectsFolder;
		private System.Windows.Forms.Label lblLanguage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// A dialog to modify options.
		/// </summary>
		public OptionsDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Var.MainForm.localization.LocaleChanged += new SimpleDelegate(this.localeChanged); 
			Var.MainForm.localization.ChangeLocale(Var.MainForm.options.CultureInfo);
		}

    	/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OptionsDialog));
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.txtBoxProjectsFolder = new System.Windows.Forms.TextBox();
			this.lblProjectsFolder = new System.Windows.Forms.Label();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
			this.chBoxAutoUpdate = new System.Windows.Forms.CheckBox();
			this.cbLanguage = new System.Windows.Forms.ComboBox();
			this.lblLanguage = new System.Windows.Forms.Label();
			this.xpLine1 = new SteepValley.Windows.Forms.XPLine();
			this.xpLine2 = new SteepValley.Windows.Forms.XPLine();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Controls.Add(this.btnOK);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 155);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(329, 35);
			this.panel1.TabIndex = 0;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(250, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "Cancel";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(170, 8);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "OK";
			// 
			// txtBoxProjectsFolder
			// 
			this.txtBoxProjectsFolder.Location = new System.Drawing.Point(11, 33);
			this.txtBoxProjectsFolder.Name = "txtBoxProjectsFolder";
			this.txtBoxProjectsFolder.ReadOnly = true;
			this.txtBoxProjectsFolder.Size = new System.Drawing.Size(281, 20);
			this.txtBoxProjectsFolder.TabIndex = 1;
			this.txtBoxProjectsFolder.Text = "";
			// 
			// lblProjectsFolder
			// 
			this.lblProjectsFolder.Location = new System.Drawing.Point(11, 16);
			this.lblProjectsFolder.Name = "lblProjectsFolder";
			this.lblProjectsFolder.Size = new System.Drawing.Size(100, 15);
			this.lblProjectsFolder.TabIndex = 2;
			this.lblProjectsFolder.Text = "Projects Folder:";
			// 
			// btnBrowse
			// 
			this.btnBrowse.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowse.Location = new System.Drawing.Point(297, 32);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(23, 23);
			this.btnBrowse.TabIndex = 3;
			this.btnBrowse.Text = "...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// folderBrowserDialog
			// 
			this.folderBrowserDialog.Description = "Select \"Projects folder\" :";
			// 
			// chBoxAutoUpdate
			// 
			this.chBoxAutoUpdate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chBoxAutoUpdate.Location = new System.Drawing.Point(11, 73);
			this.chBoxAutoUpdate.Name = "chBoxAutoUpdate";
			this.chBoxAutoUpdate.Size = new System.Drawing.Size(276, 24);
			this.chBoxAutoUpdate.TabIndex = 4;
			this.chBoxAutoUpdate.Text = "Check for new version on startup.";
			// 
			// cbLanguage
			// 
			this.cbLanguage.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
			this.cbLanguage.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbLanguage.Location = new System.Drawing.Point(11, 129);
			this.cbLanguage.Name = "cbLanguage";
			this.cbLanguage.Size = new System.Drawing.Size(310, 21);
			this.cbLanguage.Sorted = true;
			this.cbLanguage.TabIndex = 5;
			this.cbLanguage.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.cbLanguage_DrawItem);
			// 
			// lblLanguage
			// 
			this.lblLanguage.Location = new System.Drawing.Point(11, 115);
			this.lblLanguage.Name = "lblLanguage";
			this.lblLanguage.Size = new System.Drawing.Size(100, 14);
			this.lblLanguage.TabIndex = 6;
			this.lblLanguage.Text = "Language";
			// 
			// xpLine1
			// 
			this.xpLine1.BackColor = System.Drawing.SystemColors.Control;
			this.xpLine1.Location = new System.Drawing.Point(13, 102);
			this.xpLine1.Name = "xpLine1";
			this.xpLine1.Size = new System.Drawing.Size(308, 13);
			this.xpLine1.TabIndex = 7;
			// 
			// xpLine2
			// 
			this.xpLine2.BackColor = System.Drawing.SystemColors.Control;
			this.xpLine2.Location = new System.Drawing.Point(13, 60);
			this.xpLine2.Name = "xpLine2";
			this.xpLine2.Size = new System.Drawing.Size(308, 13);
			this.xpLine2.TabIndex = 8;
			// 
			// OptionsDialog
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(329, 190);
			this.Controls.Add(this.xpLine2);
			this.Controls.Add(this.xpLine1);
			this.Controls.Add(this.lblLanguage);
			this.Controls.Add(this.cbLanguage);
			this.Controls.Add(this.chBoxAutoUpdate);
			this.Controls.Add(this.btnBrowse);
			this.Controls.Add(this.lblProjectsFolder);
			this.Controls.Add(this.txtBoxProjectsFolder);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OptionsDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Options";
			this.Closed += new System.EventHandler(this.OptionsDialog_Closed);
			this.VisibleChanged += new System.EventHandler(this.OptionsDialog_VisibleChanged);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Fields
		
	    #endregion

		private void localeChanged()
		{
			this.Text = Var.MainForm.localization["Options"];
			lblProjectsFolder.Text = Var.MainForm.localization["Projects folder"];
			chBoxAutoUpdate.Text = Var.MainForm.localization["Check for new version on startup"];
			lblLanguage.Text = Var.MainForm.localization["Language"];
			btnOK.Text = Var.MainForm.localization["OK"];
			btnCancel.Text = Var.MainForm.localization["Cancel"];
		}

		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			if(CDMenus.CDMenuFactory.CDMenu == null)
			{
				if(folderBrowserDialog.ShowDialog() == DialogResult.OK)
				{
					txtBoxProjectsFolder.Text = folderBrowserDialog.SelectedPath;
				}
			}
			else
			{
				MessageBox.Show( "Close CD-Menu before changing Projects directory.");
			}
		}

		private void OptionsDialog_VisibleChanged(object sender, System.EventArgs e)
		{
			if( Visible == true)
			{
				txtBoxProjectsFolder.Text = Var.MainForm.options.ProjectsFolder;
				chBoxAutoUpdate.Checked = Var.MainForm.options.AutoUpdate;


				//Add supported language
			    cbLanguage.Items.Clear();
				cbLanguage.Items.Add(new CultureInfo("en")); 
				foreach(string file in Directory.GetFiles(Var.MainForm.Paths.LanguageFolder , "*.resources"))
				{
					string cultExt;
					cultExt = Path.GetFileNameWithoutExtension(file);
					cultExt = Path.GetExtension(cultExt);
					if(cultExt != "")
					{
						cultExt = cultExt.Remove(0,1);
						cbLanguage.Items.Add(new CultureInfo(cultExt));
					}
				}
				//Set select language
				cbLanguage.SelectedIndex = cbLanguage.Items.IndexOf(
					new CultureInfo(Var.MainForm.options.CultureInfo));
			}
		}

		private void OptionsDialog_Closed(object sender, System.EventArgs e)
		{
			if(this.DialogResult == System.Windows.Forms.DialogResult.OK)
			{
				UpdateOptions();
				UpdateEnviroment();
				Var.MainForm.options.Save();
			}
		}

		private void UpdateOptions()
		{
			Var.MainForm.options.ProjectsFolder = txtBoxProjectsFolder.Text;
			Var.MainForm.options.CultureInfo = ((CultureInfo)cbLanguage.SelectedItem).TwoLetterISOLanguageName;
			Var.MainForm.options.AutoUpdate = chBoxAutoUpdate.Checked;
		}

		private void UpdateEnviroment()
		{
			Var.MainForm.CreateProjectsFolder();
			Var.MainForm.localization.ChangeLocale(((CultureInfo)cbLanguage.SelectedItem).TwoLetterISOLanguageName);
		}

		private void cbLanguage_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			Brush myBrush = Brushes.Black;
			e.DrawBackground();

			if (e.Index != -1)
			{
				e.Graphics.DrawString(((CultureInfo)cbLanguage.Items[e.Index]).EnglishName, e.Font, myBrush,e.Bounds,StringFormat.GenericDefault);				
				//				MessageBox.Show(Convert.ToString(e.Index));
			}
			// If the ListBox has focus, draw a focus rectangle around the selected item.
			e.DrawFocusRectangle();
		}
	}
}
