#region	 Licence and informations

/***************************************************************************************
 *		Date	:	26-5-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Globalization;

namespace CDIStudio.Studio.Tools.Translator
{
	/// <summary>
	/// Summary description for LanguageSelector.
	/// </summary>
	public class LanguageSelector : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbLanguage;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LanguageSelector()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Add language to cbLanguage
			foreach(CultureInfo cult in CultureInfo.GetCultures(System.Globalization.CultureTypes.NeutralCultures))
			{
				//Cancel if language is English
				if(cult.EnglishName != "English")
				{
					cbLanguage.Items.Add(cult.EnglishName);
				}
			}
			cbLanguage.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)			  
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.cbLanguage = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(14, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 13);
			this.label1.TabIndex = 1;
			this.label1.Text = "Language";
			// 
			// btnOk
			// 
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOk.Location = new System.Drawing.Point(119, 59);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 2;
			this.btnOk.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(205, 60);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "Cancel";
			// 
			// cbLanguage
			// 
			this.cbLanguage.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbLanguage.Location = new System.Drawing.Point(16, 26);
			this.cbLanguage.Name = "cbLanguage";
			this.cbLanguage.Size = new System.Drawing.Size(267, 21);
			this.cbLanguage.Sorted = true;
			this.cbLanguage.TabIndex = 4;
			// 
			// LanguageSelector
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(290, 89);
			this.Controls.Add(this.cbLanguage);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOk);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "LanguageSelector";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Select a Language";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.LanguageSelector_Closing);
			this.Load += new System.EventHandler(this.LanguageSelector_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		/// <summary>
		/// The selected CultureInfo.
		/// </summary>
		public CultureInfo cultInfo;

		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods

		private void LanguageSelector_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(DialogResult == DialogResult.OK )
			{	   													
				foreach(CultureInfo cult in CultureInfo.GetCultures(System.Globalization.CultureTypes.NeutralCultures))
				{
					if((string)cbLanguage.SelectedItem == cult.EnglishName)
					{
						cultInfo = cult;
						break;
					}
					else  cultInfo = null;
				}	
			}
			else  cultInfo = null;
		}

		private void LanguageSelector_Load(object sender, System.EventArgs e)
		{
			this.ActiveControl = cbLanguage;
		}

		#endregion
	}
}

