#region	 Licence and informations

/***************************************************************************************
 *		Date	:	28-5-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 *		A dialog to send the translated file.
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Web.Mail;
using System.Globalization;
using System.IO;
using DotNetOpenMail;

namespace CDIStudio.Studio.Tools.Translator
{
	/// <summary>
	/// Summary description for Postman.
	/// </summary>
	public class Postman : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lbName;
		private System.Windows.Forms.TextBox txtBName;
		private System.Windows.Forms.Button btnSend;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.GroupBox gbMail;
		private System.Windows.Forms.Label lbSubjectCaption;
		private System.Windows.Forms.Label lbToCaption;
		private System.Windows.Forms.TextBox txtbFrom;
		private System.Windows.Forms.Label lbFrom;
		private System.Windows.Forms.Label lblTo;
		private System.Windows.Forms.Label lbBody;
		private System.Windows.Forms.Label lbInfo;
		private System.Windows.Forms.Label lblSubject;
		private System.Windows.Forms.Label lblAttachmentCaption;
		private System.Windows.Forms.Label lblAttachment;
		private System.Windows.Forms.TextBox txtbBody;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Postman()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Postman));
			this.gbMail = new System.Windows.Forms.GroupBox();
			this.txtbBody = new System.Windows.Forms.TextBox();
			this.lblAttachment = new System.Windows.Forms.Label();
			this.lblAttachmentCaption = new System.Windows.Forms.Label();
			this.lblSubject = new System.Windows.Forms.Label();
			this.lbBody = new System.Windows.Forms.Label();
			this.lblTo = new System.Windows.Forms.Label();
			this.lbSubjectCaption = new System.Windows.Forms.Label();
			this.lbToCaption = new System.Windows.Forms.Label();
			this.txtbFrom = new System.Windows.Forms.TextBox();
			this.lbFrom = new System.Windows.Forms.Label();
			this.txtBName = new System.Windows.Forms.TextBox();
			this.lbName = new System.Windows.Forms.Label();
			this.btnSend = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.lbInfo = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.gbMail.SuspendLayout();
			this.SuspendLayout();
			// 
			// gbMail
			// 
			this.gbMail.Controls.Add(this.label1);
			this.gbMail.Controls.Add(this.textBox2);
			this.gbMail.Controls.Add(this.textBox1);
			this.gbMail.Controls.Add(this.txtbBody);
			this.gbMail.Controls.Add(this.lblAttachment);
			this.gbMail.Controls.Add(this.lblAttachmentCaption);
			this.gbMail.Controls.Add(this.lblSubject);
			this.gbMail.Controls.Add(this.lbBody);
			this.gbMail.Controls.Add(this.lblTo);
			this.gbMail.Controls.Add(this.lbSubjectCaption);
			this.gbMail.Controls.Add(this.lbToCaption);
			this.gbMail.Controls.Add(this.txtbFrom);
			this.gbMail.Controls.Add(this.lbFrom);
			this.gbMail.Controls.Add(this.txtBName);
			this.gbMail.Controls.Add(this.lbName);
			this.gbMail.Dock = System.Windows.Forms.DockStyle.Top;
			this.gbMail.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.gbMail.Location = new System.Drawing.Point(0, 0);
			this.gbMail.Name = "gbMail";
			this.gbMail.Size = new System.Drawing.Size(388, 249);
			this.gbMail.TabIndex = 0;
			this.gbMail.TabStop = false;
			this.gbMail.Text = "Mail";
			// 
			// txtbBody
			// 
			this.txtbBody.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtbBody.Location = new System.Drawing.Point(76, 100);
			this.txtbBody.Multiline = true;
			this.txtbBody.Name = "txtbBody";
			this.txtbBody.ReadOnly = true;
			this.txtbBody.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtbBody.Size = new System.Drawing.Size(296, 96);
			this.txtbBody.TabIndex = 25;
			this.txtbBody.Text = "";
			// 
			// lblAttachment
			// 
			this.lblAttachment.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lblAttachment.Location = new System.Drawing.Point(100, 200);
			this.lblAttachment.Name = "lblAttachment";
			this.lblAttachment.Size = new System.Drawing.Size(266, 40);
			this.lblAttachment.TabIndex = 24;
			this.lblAttachment.Text = "CDI Translation";
			// 
			// lblAttachmentCaption
			// 
			this.lblAttachmentCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lblAttachmentCaption.Location = new System.Drawing.Point(16, 200);
			this.lblAttachmentCaption.Name = "lblAttachmentCaption";
			this.lblAttachmentCaption.Size = new System.Drawing.Size(77, 13);
			this.lblAttachmentCaption.TabIndex = 23;
			this.lblAttachmentCaption.Text = "Attachment :";
			// 
			// lblSubject
			// 
			this.lblSubject.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lblSubject.Location = new System.Drawing.Point(76, 82);
			this.lblSubject.Name = "lblSubject";
			this.lblSubject.Size = new System.Drawing.Size(216, 13);
			this.lblSubject.TabIndex = 22;
			this.lblSubject.Text = "CDI Translation";
			// 
			// lbBody
			// 
			this.lbBody.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lbBody.Location = new System.Drawing.Point(16, 100);
			this.lbBody.Name = "lbBody";
			this.lbBody.Size = new System.Drawing.Size(44, 13);
			this.lbBody.TabIndex = 21;
			this.lbBody.Text = "Body:";
			// 
			// lblTo
			// 
			this.lblTo.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lblTo.Location = new System.Drawing.Point(76, 64);
			this.lblTo.Name = "lblTo";
			this.lblTo.Size = new System.Drawing.Size(216, 13);
			this.lblTo.TabIndex = 20;
			this.lblTo.Text = "theodoros.a@cytanet.com.cy";
			// 
			// lbSubjectCaption
			// 
			this.lbSubjectCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lbSubjectCaption.Location = new System.Drawing.Point(16, 81);
			this.lbSubjectCaption.Name = "lbSubjectCaption";
			this.lbSubjectCaption.Size = new System.Drawing.Size(54, 13);
			this.lbSubjectCaption.TabIndex = 17;
			this.lbSubjectCaption.Text = "Subject";
			// 
			// lbToCaption
			// 
			this.lbToCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lbToCaption.Location = new System.Drawing.Point(16, 62);
			this.lbToCaption.Name = "lbToCaption";
			this.lbToCaption.Size = new System.Drawing.Size(32, 13);
			this.lbToCaption.TabIndex = 13;
			this.lbToCaption.Text = "To:";
			// 
			// txtbFrom
			// 
			this.txtbFrom.Location = new System.Drawing.Point(76, 40);
			this.txtbFrom.Name = "txtbFrom";
			this.txtbFrom.Size = new System.Drawing.Size(296, 20);
			this.txtbFrom.TabIndex = 12;
			this.txtbFrom.Text = "";
			this.txtbFrom.TextChanged += new System.EventHandler(this.txtbFrom_TextChanged);
			// 
			// lbFrom
			// 
			this.lbFrom.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lbFrom.Location = new System.Drawing.Point(16, 43);
			this.lbFrom.Name = "lbFrom";
			this.lbFrom.Size = new System.Drawing.Size(38, 13);
			this.lbFrom.TabIndex = 11;
			this.lbFrom.Text = "From:";
			// 
			// txtBName
			// 
			this.txtBName.Location = new System.Drawing.Point(76, 19);
			this.txtBName.Name = "txtBName";
			this.txtBName.Size = new System.Drawing.Size(296, 20);
			this.txtBName.TabIndex = 1;
			this.txtBName.Text = "";
			this.txtBName.TextChanged += new System.EventHandler(this.txtbFrom_TextChanged);
			// 
			// lbName
			// 
			this.lbName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.lbName.Location = new System.Drawing.Point(16, 24);
			this.lbName.Name = "lbName";
			this.lbName.Size = new System.Drawing.Size(46, 13);
			this.lbName.TabIndex = 0;
			this.lbName.Text = "Name:";
			// 
			// btnSend
			// 
			this.btnSend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSend.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnSend.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnSend.Image = ((System.Drawing.Image)(resources.GetObject("btnSend.Image")));
			this.btnSend.Location = new System.Drawing.Point(219, 263);
			this.btnSend.Name = "btnSend";
			this.btnSend.TabIndex = 1;
			this.btnSend.Text = "Send";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(306, 262);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			// 
			// lbInfo
			// 
			this.lbInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lbInfo.ForeColor = System.Drawing.Color.LightSlateGray;
			this.lbInfo.Location = new System.Drawing.Point(2, 265);
			this.lbInfo.Name = "lbInfo";
			this.lbInfo.Size = new System.Drawing.Size(199, 18);
			this.lbInfo.TabIndex = 3;
			this.lbInfo.Text = "This is the e-mail you\'ll send.";
			this.lbInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(74, 61);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(143, 20);
			this.textBox1.TabIndex = 26;
			this.textBox1.Text = "theodoros.a@cytanet.com.cy";
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(225, 77);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(141, 20);
			this.textBox2.TabIndex = 27;
			this.textBox2.Text = "mail-out.cytanet.com.cy";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(161)));
			this.label1.Location = new System.Drawing.Point(224, 66);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(143, 11);
			this.label1.TabIndex = 28;
			this.label1.Text = "SMTP Server";
			// 
			// Postman
			// 
			this.AcceptButton = this.btnSend;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(388, 290);
			this.Controls.Add(this.lbInfo);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnSend);
			this.Controls.Add(this.gbMail);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Postman";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Send translation";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Postman_Closing);
			this.VisibleChanged += new System.EventHandler(this.Postman_VisibleChanged);
			this.gbMail.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Fields
		public CultureInfo cultInfo;
		public string Attachment ;

		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods

		private void ChangeBody()
		{
			if(cultInfo != null)
			{	
				txtbBody.Text = "Hello,\r\nMy name is " + txtBName.Text + 
					" and i translated CDInterface Studio in " + cultInfo.EnglishName  +
					".\r\n\r\nRegards, \r\n" + txtBName.Text + "\r\n" + txtbFrom.Text;
			}
		}

		private void txtbFrom_TextChanged(object sender, System.EventArgs e)
		{
			ChangeBody();
		}

		private void Postman_VisibleChanged(object sender, System.EventArgs e)
		{
			if(Visible == true)
			{
				ChangeBody();
				lblSubject.Text = "CDI Translation: " + cultInfo.EnglishName;
				lblAttachment.Text = Attachment;
			}
		}

		private void Postman_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(this.DialogResult == DialogResult.OK)
			{
				//First validate for empty fields
				if(txtBName.Text == "")
				{
					MessageBox.Show(this, "'Name' can NOT be empty.","Empty field",
						MessageBoxButtons.OK , MessageBoxIcon.Warning);
					e.Cancel = true;
				}
				else if(txtbFrom.Text == "")
				{
					MessageBox.Show(this, "'From' can NOT be empty.","Empty field",
						MessageBoxButtons.OK , MessageBoxIcon.Warning);
					e.Cancel = true;
				}

				//Checks if you are connected to the internet
				else if(!InternetCS.IsConnectedToInternet())
				{
					MessageBox.Show(this, "Please , connect with the internet and try again.","Internet Connection",
						MessageBoxButtons.OK , MessageBoxIcon.Warning);
					e.Cancel = true;
				}

				//Send mail
				else
				{
					try
					{
						Cursor = Cursors.WaitCursor;

						//												System.Web.Mail.MailMessage mail = new MailMessage();
						//												mail.From = txtbFrom.Text;
						//												mail.To =  "theodoros.a@cytanet.com.cy";
						//												mail.Subject = lblSubject.Text;
						//												mail.Body = txtbBody.Text;
						//												mail.Attachments.Add(new MailAttachment(Attachment ));
						//						 
						//						//						SmtpMail.SmtpServer = "mail-out.cytanet.com.cy";
						//						//						SmtpMail.Send(mail);
						//
						////						CDIStudio.Studio.SendMail.Smtp smtpClient = new CDIStudio.Studio.SendMail.Smtp("mail-out.cytanet.com.cy", 25);
						////						smtpClient.Send(mail);
						////						MessageBox.Show(this,"Message succesfully send.");
						//
						//
						//						CDIStudio.StudioEmailer.Mailer mailer = new CDIStudio.StudioEmailer.Mailer("mail-out.cytanet.com.cy","theodoros.a@cytanet.com.cy");
						//						mailer.Sender = txtbFrom.Text;
						//						mailer.Recipient =  "theodoros.a@cytanet.com.cy";
						//						mailer.Subject = lblSubject.Text;
						//						mailer.Body = txtbBody.Text;
						//						mailer.Send();
						//						MessageBox.Show(this,"Message succesfully send.");
						////						mailer.Attachments.Add(new MailAttachment(Attachment ));
					

						DotNetOpenMail.EmailMessage emailMessage = new EmailMessage();
						emailMessage.FromAddress = new EmailAddress(txtbFrom.Text);
						emailMessage.AddToAddress(new EmailAddress(textBox1.Text));	
						//						emailMessage.AddToAddress(new EmailAddress("theodoros.a@cytanet.com.cy"));
						emailMessage.Subject = lblSubject.Text;
						emailMessage.TextPart = new TextAttachment(txtbBody.Text);
						FileAttachment fileAttachment = new FileAttachment(new FileInfo(Attachment));
						fileAttachment.ContentType = "application/bin";
						emailMessage.AddMixedAttachment(fileAttachment);
						emailMessage.Send(new SmtpServer(textBox2.Text));
						//						emailMessage.Send(new SmtpServer("mail-out.cytanet.com.cy"));
					
						MessageBox.Show(this, "Translation send successfully.","Translation send",
							MessageBoxButtons.OK , MessageBoxIcon.Information);
					}
					finally
					{
						Cursor = Cursors.Default;
					}
				}
			}
		}
		#endregion
	}
}
