#region	 Licence and informations

/***************************************************************************************
 *		Date	:	25-5-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description: 
 *      -----------
 *			Translator is a tool that creates localized version for CDI Studio.
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO; 
using System.Resources; 
using System.Data;
using System.Xml;
using System.Globalization;
using System.Threading;

namespace CDIStudio.Studio.Tools.Translator
{
	/// <summary>
	/// Translator is a tool that creates localized version for CDI Studio.
	/// </summary>
	public class Translator : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ColumnHeader columnEnglish;
		private System.Windows.Forms.ColumnHeader columnTranslation;
		private TD.SandBar.ToolBar toolBar1;
		private TD.SandBar.ButtonItem btnItemLanguage;
		private TD.SandBar.ButtonItem btnItemSave;
		private System.Windows.Forms.ListView lvTranslations;
		private System.Windows.Forms.TextBox txtbValue;
		private TD.SandBar.ButtonItem buttonItem1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.LinkLabel lblFile;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Construcor.
		/// </summary>
		public Translator()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			EnglishList = new ArrayList();		
			languageSelector = new LanguageSelector();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Translator));
			this.lvTranslations = new System.Windows.Forms.ListView();
			this.columnEnglish = new System.Windows.Forms.ColumnHeader();
			this.columnTranslation = new System.Windows.Forms.ColumnHeader();
			this.txtbValue = new System.Windows.Forms.TextBox();
			this.toolBar1 = new TD.SandBar.ToolBar();
			this.btnItemLanguage = new TD.SandBar.ButtonItem();
			this.btnItemSave = new TD.SandBar.ButtonItem();
			this.buttonItem1 = new TD.SandBar.ButtonItem();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.label1 = new System.Windows.Forms.Label();
			this.lblFile = new System.Windows.Forms.LinkLabel();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// lvTranslations
			// 
			this.lvTranslations.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							 this.columnEnglish,
																							 this.columnTranslation});
			this.lvTranslations.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvTranslations.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvTranslations.HideSelection = false;
			this.lvTranslations.Location = new System.Drawing.Point(0, 30);
			this.lvTranslations.MultiSelect = false;
			this.lvTranslations.Name = "lvTranslations";
			this.lvTranslations.Size = new System.Drawing.Size(529, 167);
			this.lvTranslations.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvTranslations.TabIndex = 0;
			this.lvTranslations.View = System.Windows.Forms.View.Details;
			this.lvTranslations.SizeChanged += new System.EventHandler(this.lvTranslations_SizeChanged);
			this.lvTranslations.SelectedIndexChanged += new System.EventHandler(this.lvTranslations_SelectedIndexChanged);
			// 
			// columnEnglish
			// 
			this.columnEnglish.Text = "English";
			this.columnEnglish.Width = 169;
			// 
			// columnTranslation
			// 
			this.columnTranslation.Text = "";
			this.columnTranslation.Width = 344;
			// 
			// txtbValue
			// 
			this.txtbValue.AcceptsReturn = true;
			this.txtbValue.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.txtbValue.Enabled = false;
			this.txtbValue.Location = new System.Drawing.Point(0, 197);
			this.txtbValue.Multiline = true;
			this.txtbValue.Name = "txtbValue";
			this.txtbValue.Size = new System.Drawing.Size(529, 88);
			this.txtbValue.TabIndex = 1;
			this.txtbValue.Text = "";
			this.txtbValue.WordWrap = false;
			this.txtbValue.TextChanged += new System.EventHandler(this.txtbValue_TextChanged);
			// 
			// toolBar1
			// 
			this.toolBar1.Guid = new System.Guid("8bcad708-0bdb-4a84-8b38-aa2f078da388");
			this.toolBar1.Items.AddRange(new TD.SandBar.ToolbarItemBase[] {
																			  this.btnItemLanguage,
																			  this.btnItemSave,
																			  this.buttonItem1});
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Movable = false;
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.Resizable = false;
			this.toolBar1.Size = new System.Drawing.Size(529, 30);
			this.toolBar1.TabIndex = 4;
			this.toolBar1.Tearable = false;
			this.toolBar1.Text = "toolBar1";
			// 
			// btnItemLanguage
			// 
			this.btnItemLanguage.Image = ((System.Drawing.Image)(resources.GetObject("btnItemLanguage.Image")));
			this.btnItemLanguage.ToolTipText = "Select language";
			this.btnItemLanguage.Activate += new System.EventHandler(this.btnItemLanguage_Activate);
			// 
			// btnItemSave
			// 
			this.btnItemSave.Enabled = false;
			this.btnItemSave.Image = ((System.Drawing.Image)(resources.GetObject("btnItemSave.Image")));
			this.btnItemSave.ToolTipText = "Save";
			this.btnItemSave.Activate += new System.EventHandler(this.btnItemSave_Activate);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.lblFile);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 285);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(529, 78);
			this.panel1.TabIndex = 5;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 194);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(529, 3);
			this.splitter1.TabIndex = 6;
			this.splitter1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(11, 10);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(476, 25);
			this.label1.TabIndex = 0;
			this.label1.Text = "Send the translated file to \"theodoros.a@cytanet.com.cy\" .In the e-mail include y" +
				"our name. The location of translated file is:";
			// 
			// lblFile
			// 
			this.lblFile.Location = new System.Drawing.Point(9, 38);
			this.lblFile.Name = "lblFile";
			this.lblFile.Size = new System.Drawing.Size(509, 34);
			this.lblFile.TabIndex = 1;
			this.lblFile.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.lblFile_LinkClicked);
			// 
			// Translator
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(529, 363);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.lvTranslations);
			this.Controls.Add(this.toolBar1);
			this.Controls.Add(this.txtbValue);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Translator";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Translator";
			this.Load += new System.EventHandler(this.Translator_Load);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private ArrayList EnglishList;
		private LanguageSelector languageSelector;
		private CultureInfo cultInfo;
		private bool isSaved = false;
		#endregion


		#region Propertys


		#endregion


		#region Indexes
		

		#endregion


		#region Methods

		private void Translator_Load(object sender, System.EventArgs e)
		{
			ReadEnglishResourceFile(Var.MainForm.Paths.LanguageFolder + @"\Strings");
			
		}

		private void ReadEnglishResourceFile(string fileName) 
		{
			ResourceReader reader = null;
			ListViewItem item;
			try 
			{
				string fileExtension = ".resources";
				reader = new ResourceReader(fileName + fileExtension);
				IDictionaryEnumerator en = reader.GetEnumerator();
				
				// Goes through the enumerator, listing out the values.
				while (en.MoveNext()) 
				{
					item = lvTranslations.Items.Add((string)en.Value);
					item.SubItems.Add("");
					EnglishList.Add((string)en.Key);
					EnglishList.Sort();
				}
			}
			finally 
			{
				if (null != reader) reader.Close();
			}
		}

		private void ReadLocalResourceFile(string fileName) 
		{
			ResourceReader reader = null;
			ListViewItem item;
			try 
			{
				string fileExtension = ".resources";
				reader = new ResourceReader(fileName + fileExtension);
				IDictionaryEnumerator en = reader.GetEnumerator();
				int i;
				
				// Goes through the enumerator, printing out the key and value pairs.
				while (en.MoveNext()) 
				{		   
					
					i = EnglishList.IndexOf((string)en.Key);
					if(i != -1)
					{
						item = lvTranslations.Items [i];
						item.SubItems[1].Text = (string)en.Value;
					}
				}
				isSaved = true;
			}
			finally 
			{
				if (null != reader) reader.Close();
			}
		}

		private void WriteRecourceFile(string fileName)
		{
			ResourceWriter Writer = null;
			try
			{
				Var.MainForm.localization.ReleaseAllResources();

				//Write the resource file
				Writer = new ResourceWriter(fileName);
				foreach(ListViewItem item in lvTranslations.Items)
				{
					if(item.SubItems[1].Text != "")
					{
						Writer.AddResource((string)EnglishList[item.Index] , item.SubItems[1].Text);
					}
				}
			}
			finally
			{
				if(Writer != null) Writer.Close();
				Var.MainForm.localization.ChangeLocale(Thread.CurrentThread.CurrentUICulture.TwoLetterISOLanguageName);
			}
		}

		private void btnItemLanguage_Activate(object sender, System.EventArgs e)
		{
			if(languageSelector.ShowDialog(this) == DialogResult.OK)
			{
				//Clear	 lvTranslations
				foreach(ListViewItem item in lvTranslations.Items)
				{
					if(item.SubItems[1] != null)
						item.SubItems[1].Text = "";
				}
				
				//Show the new culture in the lvTranslations
				cultInfo = languageSelector.cultInfo;
				lvTranslations.Columns[1].Text = cultInfo.EnglishName;
				string filePath =  Var.MainForm.Paths.LanguageFolder + @"\Strings." + cultInfo.TwoLetterISOLanguageName;
				if(File.Exists(filePath + @".resources"))
				{
					ReadLocalResourceFile(filePath);
					lblFile.Text = filePath+ @".resources";
				}
				else 
				{
					isSaved = false;
					lblFile.Text = "";
				}

				lvTranslations_SelectedIndexChanged(sender,e);

				UpdateIDE();
				
			}
		}
	
		private void lvTranslations_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(lvTranslations.SelectedIndices.Count > 0)
			{
				if(cultInfo != null)
				{
					txtbValue.Enabled = true;
					txtbValue.Text = lvTranslations.SelectedItems[0].SubItems[1].Text;
				}
			}
			else  
			{
				txtbValue.Enabled = false;
				txtbValue.Text = "";
			}
		}

		private void txtbValue_TextChanged(object sender, System.EventArgs e)
		{
			if(lvTranslations.SelectedIndices.Count > 0)
			{
				lvTranslations.SelectedItems[0].SubItems[1].Text = txtbValue.Text;
				isSaved = false;
			}
		}

		private void btnItemSave_Activate(object sender, System.EventArgs e)
		{
			string filePath = Var.MainForm.Paths.LanguageFolder + @"\Strings." + cultInfo.TwoLetterISOLanguageName + @".resources";
			WriteRecourceFile(filePath);
			lblFile.Text = filePath;
			isSaved = true;
		}


		private void UpdateIDE()
		{
			if(cultInfo == null)
			{
				txtbValue.Enabled = false;
				btnItemSave.Enabled = false;
			}
			else
			{
				btnItemSave.Enabled = true;
			}
		}

		private void lvTranslations_SizeChanged(object sender, System.EventArgs e)
		{
			columnTranslation.Width = lvTranslations.ClientRectangle.Width - columnEnglish.Width;
		}

		private void lblFile_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("explorer.exe",@"/select," + lblFile.Text);
		}

		#endregion


	}
}
