#region	 Licence and informations

/***************************************************************************************
 *		Date	:	16-4-2005
 *		Author	:	Lucian Rosu
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://www.sourceforge.net/projects/cdinterface.                      //
//      http://www.cdinterface.sourceforge.net                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using CDIStudio.CDMenus.TypeEditors;
using System.Data;
using XPExplorerBar;

namespace CDIStudio.CDMenus.DB
{
	public class CustomDataPanel : CDIStudio.CDMenus.DB.DataPanel
	{
		private System.Windows.Forms.GroupBox gbAction;
		private XPExplorerBar.XPTextBox txbAction;
		private System.Windows.Forms.Button btnAction;
		private XPExplorerBar.XPTextBox txbTitle;
		private System.Windows.Forms.Label lblTitle;
		private XPExplorerBar.TaskItem AddItem;
		private XPExplorerBar.TaskItem DeleteItem;
		private XPExplorerBar.TaskItem FirstItem;
		private XPExplorerBar.TaskItem NextItem;
		private XPExplorerBar.TaskItem LastItem;
		private System.Windows.Forms.Label lblAction;
		private System.Windows.Forms.GroupBox gbTasks;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.TextBox txbInfo;
		private System.Windows.Forms.Button btnInfo;
		private XPExplorerBar.Expando expItems;
		private XPExplorerBar.TaskItem PreviousItem;
		private System.ComponentModel.IContainer components = null;

		public CustomDataPanel()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();
		}

		public CustomDataPanel(CDIStudio.CDMenus.DB.CustomDB aCustomDB):this()
		{
		    customDB = aCustomDB;
			InitializePanel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.expItems = new XPExplorerBar.Expando();
			this.gbAction = new System.Windows.Forms.GroupBox();
			this.btnAction = new System.Windows.Forms.Button();
			this.txbAction = new XPExplorerBar.XPTextBox();
			this.lblAction = new System.Windows.Forms.Label();
			this.txbTitle = new XPExplorerBar.XPTextBox();
			this.lblTitle = new System.Windows.Forms.Label();
			this.gbTasks = new System.Windows.Forms.GroupBox();
			this.AddItem = new XPExplorerBar.TaskItem();
			this.DeleteItem = new XPExplorerBar.TaskItem();
			this.FirstItem = new XPExplorerBar.TaskItem();
			this.PreviousItem = new XPExplorerBar.TaskItem();
			this.NextItem = new XPExplorerBar.TaskItem();
			this.LastItem = new XPExplorerBar.TaskItem();
			this.txbInfo = new System.Windows.Forms.TextBox();
			this.lblInfo = new System.Windows.Forms.Label();
			this.btnInfo = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.Panel)).BeginInit();
			this.Panel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expItems)).BeginInit();
			this.expItems.SuspendLayout();
			this.gbAction.SuspendLayout();
			this.gbTasks.SuspendLayout();
			this.SuspendLayout();
			// 
			// Panel
			// 
			this.Panel.Expandos.AddRange(new XPExplorerBar.Expando[] {
																		 this.expItems});
			this.Panel.Name = "Panel";
			this.Panel.Size = new System.Drawing.Size(245, 303);
			// 
			// expItems
			// 
			this.expItems.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expItems.Animate = true;
			this.expItems.ExpandedHeight = 270;
			this.expItems.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expItems.Items.AddRange(new System.Windows.Forms.Control[] {
																				this.gbAction,
																				this.txbTitle,
																				this.lblTitle,
																				this.gbTasks,
																				this.txbInfo,
																				this.lblInfo,
																				this.btnInfo});
			this.expItems.Location = new System.Drawing.Point(12, 12);
			this.expItems.Name = "expItems";
			this.expItems.Size = new System.Drawing.Size(221, 270);
			this.expItems.TabIndex = 0;
			this.expItems.Text = "Items";
			// 
			// gbAction
			// 
			this.gbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbAction.Controls.Add(this.btnAction);
			this.gbAction.Controls.Add(this.txbAction);
			this.gbAction.Controls.Add(this.lblAction);
			this.gbAction.Location = new System.Drawing.Point(2, 139);
			this.gbAction.Name = "gbAction";
			this.gbAction.Size = new System.Drawing.Size(216, 52);
			this.gbAction.TabIndex = 3;
			this.gbAction.TabStop = false;
			this.gbAction.Text = "Action";
			// 
			// btnAction
			// 
			this.btnAction.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnAction.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnAction.Location = new System.Drawing.Point(182, 23);
			this.btnAction.Name = "btnAction";
			this.btnAction.Size = new System.Drawing.Size(27, 23);
			this.btnAction.TabIndex = 5;
			this.btnAction.Text = "...";
			this.btnAction.Click += new System.EventHandler(this.btnAction_Click);
			// 
			// txbAction
			// 
			this.txbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbAction.Location = new System.Drawing.Point(58, 22);
			this.txbAction.Name = "txbAction";
			this.txbAction.ReadOnly = true;
			this.txbAction.Size = new System.Drawing.Size(123, 21);
			this.txbAction.TabIndex = 3;
			this.txbAction.Text = "";
			// 
			// lblAction
			// 
			this.lblAction.Location = new System.Drawing.Point(9, 24);
			this.lblAction.Name = "lblAction";
			this.lblAction.Size = new System.Drawing.Size(45, 23);
			this.lblAction.TabIndex = 7;
			// 
			// txbTitle
			// 
			this.txbTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbTitle.Enabled = false;
			this.txbTitle.Location = new System.Drawing.Point(4, 112);
			this.txbTitle.Name = "txbTitle";
			this.txbTitle.Size = new System.Drawing.Size(212, 21);
			this.txbTitle.TabIndex = 4;
			this.txbTitle.Text = "";
			this.txbTitle.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbTitle_KeyDown);
			this.txbTitle.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblTitle
			// 
			this.lblTitle.Location = new System.Drawing.Point(6, 99);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(100, 15);
			this.lblTitle.TabIndex = 5;
			this.lblTitle.Text = "Title";
			// 
			// gbTasks
			// 
			this.gbTasks.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbTasks.Controls.Add(this.AddItem);
			this.gbTasks.Controls.Add(this.DeleteItem);
			this.gbTasks.Controls.Add(this.FirstItem);
			this.gbTasks.Controls.Add(this.PreviousItem);
			this.gbTasks.Controls.Add(this.NextItem);
			this.gbTasks.Controls.Add(this.LastItem);
			this.gbTasks.Location = new System.Drawing.Point(3, 23);
			this.gbTasks.Name = "gbTasks";
			this.gbTasks.Size = new System.Drawing.Size(215, 74);
			this.gbTasks.TabIndex = 6;
			this.gbTasks.TabStop = false;
			// 
			// AddItem
			// 
			this.AddItem.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.AddItem.BackColor = System.Drawing.Color.Transparent;
			this.AddItem.Image = null;
			this.AddItem.Location = new System.Drawing.Point(5, 19);
			this.AddItem.Name = "AddItem";
			this.AddItem.Size = new System.Drawing.Size(203, 16);
			this.AddItem.TabIndex = 2;
			this.AddItem.Text = "Add";
			this.AddItem.Click += new System.EventHandler(this.AddItem_Click);
			// 
			// DeleteItem
			// 
			this.DeleteItem.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DeleteItem.BackColor = System.Drawing.Color.Transparent;
			this.DeleteItem.Enabled = false;
			this.DeleteItem.Image = null;
			this.DeleteItem.Location = new System.Drawing.Point(3, 37);
			this.DeleteItem.Name = "DeleteItem";
			this.DeleteItem.Size = new System.Drawing.Size(202, 16);
			this.DeleteItem.TabIndex = 3;
			this.DeleteItem.Text = "Delete";
			this.DeleteItem.Click += new System.EventHandler(this.DeleteItem_Click);
			// 
			// FirstItem
			// 
			this.FirstItem.BackColor = System.Drawing.Color.Transparent;
			this.FirstItem.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FirstItem.Image = null;
			this.FirstItem.Location = new System.Drawing.Point(6, 55);
			this.FirstItem.Name = "FirstItem";
			this.FirstItem.Size = new System.Drawing.Size(37, 16);
			this.FirstItem.TabIndex = 7;
			this.FirstItem.Text = "<<";
			this.FirstItem.Click += new System.EventHandler(this.FirstItem_Click);
			// 
			// PreviousItem
			// 
			this.PreviousItem.BackColor = System.Drawing.Color.Transparent;
			this.PreviousItem.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.PreviousItem.Image = null;
			this.PreviousItem.Location = new System.Drawing.Point(60, 55);
			this.PreviousItem.Name = "PreviousItem";
			this.PreviousItem.Size = new System.Drawing.Size(23, 16);
			this.PreviousItem.TabIndex = 8;
			this.PreviousItem.Text = "<";
			this.PreviousItem.Click += new System.EventHandler(this.PreviewsItem_Click);
			// 
			// NextItem
			// 
			this.NextItem.BackColor = System.Drawing.Color.Transparent;
			this.NextItem.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.NextItem.Image = null;
			this.NextItem.Location = new System.Drawing.Point(112, 55);
			this.NextItem.Name = "NextItem";
			this.NextItem.Size = new System.Drawing.Size(23, 16);
			this.NextItem.TabIndex = 9;
			this.NextItem.Text = ">";
			this.NextItem.Click += new System.EventHandler(this.NextItem_Click);
			// 
			// LastItem
			// 
			this.LastItem.BackColor = System.Drawing.Color.Transparent;
			this.LastItem.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.LastItem.Image = null;
			this.LastItem.Location = new System.Drawing.Point(149, 55);
			this.LastItem.Name = "LastItem";
			this.LastItem.Size = new System.Drawing.Size(36, 16);
			this.LastItem.TabIndex = 10;
			this.LastItem.Text = ">>";
			this.LastItem.Click += new System.EventHandler(this.LastItem_Click);
			// 
			// txbInfo
			// 
			this.txbInfo.AcceptsReturn = true;
			this.txbInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbInfo.Enabled = false;
			this.txbInfo.Location = new System.Drawing.Point(3, 209);
			this.txbInfo.Name = "txbInfo";
			this.txbInfo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txbInfo.Size = new System.Drawing.Size(183, 21);
			this.txbInfo.TabIndex = 7;
			this.txbInfo.Text = "";
			this.txbInfo.WordWrap = false;
			this.txbInfo.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbInfo_KeyDown);
			this.txbInfo.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblInfo
			// 
			this.lblInfo.Location = new System.Drawing.Point(5, 195);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(44, 15);
			this.lblInfo.TabIndex = 8;
			this.lblInfo.Text = "Info";
			// 
			// btnInfo
			// 
			this.btnInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnInfo.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnInfo.Location = new System.Drawing.Point(187, 208);
			this.btnInfo.Name = "btnInfo";
			this.btnInfo.Size = new System.Drawing.Size(27, 23);
			this.btnInfo.TabIndex = 9;
			this.btnInfo.Text = "...";
			this.btnInfo.Click += new System.EventHandler(this.btnInfo_Click);
			// 
			// CustomDataPanel
			// 
			this.Name = "CustomDataPanel";
			this.Size = new System.Drawing.Size(245, 303);
			((System.ComponentModel.ISupportInitialize)(this.Panel)).EndInit();
			this.Panel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expItems)).EndInit();
			this.expItems.ResumeLayout(false);
			this.gbAction.ResumeLayout(false);
			this.gbTasks.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private CDIStudio.CDMenus.DB.CustomDB	customDB;
		public System.Windows.Forms.Binding BindTitle;
		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void InitializePanel()
		{
			//Synchronise the binding context of the panel with CDMenu
			this.BindingContext[customDB.actionsDT].PositionChanged += 
				new EventHandler(Position_Changed);
			CDMenuFactory.CDMenu.BindingContext[customDB.actionsDT].PositionChanged += 
				new EventHandler(Position_ChangedOfCDMenu);

			//Add DataBindings
			txbTitle.DataBindings.Add( "Text",customDB.actionsDT,"software_title");
			lblAction.DataBindings.Add("Text",customDB.actionsDT,"parameter1");
			txbAction.DataBindings.Add("Text",customDB.actionsDT,"parameter2");
			txbInfo.DataBindings.Add("Text",customDB.actionsDT,"info");
		
			UpdateControls();
		}

		private void UpdateControls()
		{	
			if(this.BindingContext[customDB.actionsDT].Count == 0)
			{	
				txbTitle.Enabled = false;
				txbInfo.Enabled = false;
				DeleteItem.Enabled = false;
				btnAction.Enabled = false;
				btnInfo.Enabled = false;

			}
			else
			{
				txbTitle.Enabled = true;
				txbInfo.Enabled = true;
				DeleteItem.Enabled = true;
				btnAction.Enabled = true;
				btnInfo.Enabled = true;
			}

			UpdateNavigationControls();
		}

		private void UpdateNavigationControls()
		{
			if(this.BindingContext[customDB.actionsDT].Count <= 1)
			{
				FirstItem.Enabled = false;
				PreviousItem.Enabled = false;
				NextItem.Enabled = false;
				LastItem.Enabled = false;
			}
			else if(this.BindingContext[customDB.actionsDT].Position == 0)
			{
				FirstItem.Enabled = false;
				PreviousItem.Enabled = false;
				NextItem.Enabled = true;
				LastItem.Enabled = true;
			}
			else if(this.BindingContext[customDB.actionsDT].Position == this.BindingContext[customDB.actionsDT].Count-1)
			{
				FirstItem.Enabled = true;
				PreviousItem.Enabled = true;
				NextItem.Enabled = false;
				LastItem.Enabled = false;
			}
			else
			{
				FirstItem.Enabled = true;
				PreviousItem.Enabled = true;
				NextItem.Enabled = true;
				LastItem.Enabled = true;
			}
		}

		private void btnAction_Click(object sender, System.EventArgs e)
		{
			int pos = this.BindingContext[customDB.actionsDT].Position;
			CDIStudio.CDMenus.TypeEditors.ActionEditor Editor = new ActionEditor();
			ActionParameters ap = new ActionParameters();

			ap[0] = customDB.actionsDT.Rows[pos]["parameter1"].ToString();
			ap[1] = customDB.actionsDT.Rows[pos]["parameter2"].ToString();
			ap[2] = customDB.actionsDT.Rows[pos]["parameter3"].ToString();
			ap[3] = customDB.actionsDT.Rows[pos]["parameter4"].ToString();
			ap[4] = customDB.actionsDT.Rows[pos]["parameter5"].ToString();
			Editor.Action = ap;

			if( Editor.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				customDB.actionsDT.Rows[pos]["parameter1"] = Editor.Action[0];
				customDB.actionsDT.Rows[pos]["parameter2"] = Editor.Action[1];
				customDB.actionsDT.Rows[pos]["parameter3"] = Editor.Action[2];
				customDB.actionsDT.Rows[pos]["parameter4"] = Editor.Action[3];
				customDB.actionsDT.Rows[pos]["parameter5"] = Editor.Action[4];
			}
		}

		private void AddItem_Click(object sender, System.EventArgs e)
		{
			DataRow dr;

			dr= customDB.actionsDT.NewRow();
			dr["software_title"] = "title";
			dr["parameter1"] = "None";
			customDB.actionsDT.Rows.Add(dr);
			this.BindingContext[customDB.actionsDT].Position = 
				this.BindingContext[customDB.actionsDT].Count-1;

			UpdateControls();
		}

		private void DeleteItem_Click(object sender, System.EventArgs e)
		{
			if(this.BindingContext[customDB.actionsDT].Count > 0)
			{
				this.BindingContext[customDB.actionsDT].RemoveAt(
					this.BindingContext[customDB.actionsDT].Position);
			}

			UpdateControls();
		}

		

		private void txbTitle_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if(e.KeyValue == 13)
				{
					this.BindingContext[customDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[customDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void txbTitle_Validated(object sender, System.EventArgs e)
		{
			try
			{
				this.BindingContext[customDB.actionsDT].EndCurrentEdit();
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}		
		}

		private void FirstItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[customDB.actionsDT].Position = 0;
		}

		private void PreviewsItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[customDB.actionsDT].Position--;
		}

		private void NextItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[customDB.actionsDT].Position++;
		}

		private void LastItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[customDB.actionsDT].Position =
				this.BindingContext[customDB.actionsDT].Count-1;
		}

		private void Position_Changed(object sender, EventArgs e)
		{
			CDMenuFactory.CDMenu.BindingContext[customDB.actionsDT].Position = this.BindingContext[customDB.actionsDT].Position;
			UpdateNavigationControls();
		}

		private void Position_ChangedOfCDMenu(object sender, EventArgs e)
		{
			this.BindingContext[customDB.actionsDT].Position = CDMenuFactory.CDMenu.BindingContext[customDB.actionsDT].Position; 
			
		}

		private void txbInfo_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{	 
				if(e.KeyValue == 13)
				{
					this.BindingContext[customDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbInfo.SelectAll();					
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[customDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbInfo.Select(0,txbInfo.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void btnInfo_Click(object sender, System.EventArgs e)
		{
			TextEditor te = new TextEditor();
			te.TxtBox.Text =txbInfo.Text;
			if(te.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbInfo.Text = te.TxtBox.Text;
				this.BindingContext[customDB.actionsDT].EndCurrentEdit();
			}
		}

		#endregion


		
	}
}

