#region	 Licence and informations

/***************************************************************************************
 *		Date	:	17-4-2005
 *		Author	:	Lucian Rosu
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using CDIStudio.CDMenus.TypeEditors;
using System.Data;
using XPExplorerBar;

namespace CDIStudio.CDMenus.DB
{
	public class PackageDataPanel : CDIStudio.CDMenus.DB.DataPanel
	{
		private XPExplorerBar.XPTextBox txbTitle;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.GroupBox gbTasks;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.TextBox txbInfo;
		private System.Windows.Forms.Button btnInfo;
		private System.Windows.Forms.Label lblSerial;
		private XPExplorerBar.XPTextBox txbSerial;
		private XPExplorerBar.Expando expPackages;
		private XPExplorerBar.Expando expando1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private XPExplorerBar.XPTextBox xpTextBox1;
		private System.Windows.Forms.Label label1;
		private XPExplorerBar.XPTextBox xpTextBox2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private XPExplorerBar.TaskItem taskItem1;
		private XPExplorerBar.TaskItem taskItem2;
		private XPExplorerBar.TaskItem taskItem3;
		private XPExplorerBar.TaskItem taskItem4;
		private XPExplorerBar.TaskItem taskItem5;
		private XPExplorerBar.TaskItem taskItem6;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.GroupBox gbAction;
		private System.Windows.Forms.Button btnAction;
		private XPExplorerBar.XPTextBox txbAction;
		private System.Windows.Forms.Label lblAction;
		private XPExplorerBar.TaskItem AddPackage;
		private XPExplorerBar.TaskItem DeletePackage;
		private XPExplorerBar.TaskItem FirstPackage;
		private XPExplorerBar.TaskItem PreviousPackage;
		private XPExplorerBar.TaskItem NextPackage;
		private XPExplorerBar.TaskItem LastPackage;
		private System.ComponentModel.IContainer components = null;

		public PackageDataPanel()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();
		}

		public PackageDataPanel(CDIStudio.CDMenus.DB.PackageDB aPackageDB):this()
		{
		    packageDB = aPackageDB;
			InitializePanel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.expPackages = new XPExplorerBar.Expando();
			this.txbTitle = new XPExplorerBar.XPTextBox();
			this.lblTitle = new System.Windows.Forms.Label();
			this.gbTasks = new System.Windows.Forms.GroupBox();
			this.AddPackage = new XPExplorerBar.TaskItem();
			this.DeletePackage = new XPExplorerBar.TaskItem();
			this.FirstPackage = new XPExplorerBar.TaskItem();
			this.PreviousPackage = new XPExplorerBar.TaskItem();
			this.NextPackage = new XPExplorerBar.TaskItem();
			this.LastPackage = new XPExplorerBar.TaskItem();
			this.txbInfo = new System.Windows.Forms.TextBox();
			this.lblInfo = new System.Windows.Forms.Label();
			this.btnInfo = new System.Windows.Forms.Button();
			this.lblSerial = new System.Windows.Forms.Label();
			this.txbSerial = new XPExplorerBar.XPTextBox();
			this.expando1 = new XPExplorerBar.Expando();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.xpTextBox1 = new XPExplorerBar.XPTextBox();
			this.xpTextBox2 = new XPExplorerBar.XPTextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.taskItem1 = new XPExplorerBar.TaskItem();
			this.taskItem2 = new XPExplorerBar.TaskItem();
			this.taskItem3 = new XPExplorerBar.TaskItem();
			this.taskItem4 = new XPExplorerBar.TaskItem();
			this.taskItem5 = new XPExplorerBar.TaskItem();
			this.taskItem6 = new XPExplorerBar.TaskItem();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.gbAction = new System.Windows.Forms.GroupBox();
			this.btnAction = new System.Windows.Forms.Button();
			this.txbAction = new XPExplorerBar.XPTextBox();
			this.lblAction = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.Panel)).BeginInit();
			this.Panel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expPackages)).BeginInit();
			this.expPackages.SuspendLayout();
			this.gbTasks.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expando1)).BeginInit();
			this.expando1.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.gbAction.SuspendLayout();
			// 
			// Panel
			// 
			this.Panel.Expandos.AddRange(new XPExplorerBar.Expando[] {
																		 this.expPackages,
																		 this.expando1});
			this.Panel.Name = "Panel";
			this.Panel.Size = new System.Drawing.Size(248, 339);
			// 
			// expPackages
			// 
			this.expPackages.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expPackages.Animate = true;
			this.expPackages.ExpandedHeight = 195;
			this.expPackages.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expPackages.Items.AddRange(new System.Windows.Forms.Control[] {
																				   this.txbTitle,
																				   this.lblTitle,
																				   this.gbTasks,
																				   this.txbInfo,
																				   this.lblInfo,
																				   this.btnInfo,
																				   this.lblSerial,
																				   this.txbSerial});
			this.expPackages.Location = new System.Drawing.Point(12, 12);
			this.expPackages.Name = "expPackages";
			this.expPackages.Size = new System.Drawing.Size(224, 195);
			this.expPackages.TabIndex = 0;
			this.expPackages.Text = "Packages";
			// 
			// txbTitle
			// 
			this.txbTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbTitle.Enabled = false;
			this.txbTitle.Location = new System.Drawing.Point(4, 85);
			this.txbTitle.Name = "txbTitle";
			this.txbTitle.Size = new System.Drawing.Size(215, 21);
			this.txbTitle.TabIndex = 4;
			this.txbTitle.Text = "";
			this.txbTitle.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbTitle_KeyDown);
			this.txbTitle.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblTitle
			// 
			this.lblTitle.Location = new System.Drawing.Point(6, 71);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(100, 15);
			this.lblTitle.TabIndex = 5;
			this.lblTitle.Text = "Title";
			// 
			// gbTasks
			// 
			this.gbTasks.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbTasks.Controls.Add(this.AddPackage);
			this.gbTasks.Controls.Add(this.DeletePackage);
			this.gbTasks.Controls.Add(this.FirstPackage);
			this.gbTasks.Controls.Add(this.PreviousPackage);
			this.gbTasks.Controls.Add(this.NextPackage);
			this.gbTasks.Controls.Add(this.LastPackage);
			this.gbTasks.Location = new System.Drawing.Point(3, 21);
			this.gbTasks.Name = "gbTasks";
			this.gbTasks.Size = new System.Drawing.Size(218, 48);
			this.gbTasks.TabIndex = 6;
			this.gbTasks.TabStop = false;
			// 
			// AddPackage
			// 
			this.AddPackage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.AddPackage.BackColor = System.Drawing.Color.Transparent;
			this.AddPackage.Image = null;
			this.AddPackage.Location = new System.Drawing.Point(7, 13);
			this.AddPackage.Name = "AddPackage";
			this.AddPackage.Size = new System.Drawing.Size(65, 16);
			this.AddPackage.TabIndex = 2;
			this.AddPackage.Text = "Add";
			this.AddPackage.Click += new System.EventHandler(this.AddPackage_Click);
			// 
			// DeletePackage
			// 
			this.DeletePackage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DeletePackage.BackColor = System.Drawing.Color.Transparent;
			this.DeletePackage.Image = null;
			this.DeletePackage.Location = new System.Drawing.Point(70, 13);
			this.DeletePackage.Name = "DeletePackage";
			this.DeletePackage.Size = new System.Drawing.Size(86, 16);
			this.DeletePackage.TabIndex = 3;
			this.DeletePackage.Text = "Delete";
			this.DeletePackage.Click += new System.EventHandler(this.DeletePackage_Click);
			// 
			// FirstPackage
			// 
			this.FirstPackage.BackColor = System.Drawing.Color.Transparent;
			this.FirstPackage.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FirstPackage.Image = null;
			this.FirstPackage.Location = new System.Drawing.Point(6, 26);
			this.FirstPackage.Name = "FirstPackage";
			this.FirstPackage.Size = new System.Drawing.Size(37, 16);
			this.FirstPackage.TabIndex = 7;
			this.FirstPackage.Text = "<<";
			this.FirstPackage.Click += new System.EventHandler(this.FirstPackage_Click);
			// 
			// PreviousPackage
			// 
			this.PreviousPackage.BackColor = System.Drawing.Color.Transparent;
			this.PreviousPackage.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.PreviousPackage.Image = null;
			this.PreviousPackage.Location = new System.Drawing.Point(60, 26);
			this.PreviousPackage.Name = "PreviousPackage";
			this.PreviousPackage.Size = new System.Drawing.Size(23, 16);
			this.PreviousPackage.TabIndex = 8;
			this.PreviousPackage.Text = "<";
			this.PreviousPackage.Click += new System.EventHandler(this.PreviewsPackage_Click);
			// 
			// NextPackage
			// 
			this.NextPackage.BackColor = System.Drawing.Color.Transparent;
			this.NextPackage.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.NextPackage.Image = null;
			this.NextPackage.Location = new System.Drawing.Point(112, 26);
			this.NextPackage.Name = "NextPackage";
			this.NextPackage.Size = new System.Drawing.Size(23, 16);
			this.NextPackage.TabIndex = 9;
			this.NextPackage.Text = ">";
			this.NextPackage.Click += new System.EventHandler(this.NextPackage_Click);
			// 
			// LastPackage
			// 
			this.LastPackage.BackColor = System.Drawing.Color.Transparent;
			this.LastPackage.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.LastPackage.Image = null;
			this.LastPackage.Location = new System.Drawing.Point(149, 26);
			this.LastPackage.Name = "LastPackage";
			this.LastPackage.Size = new System.Drawing.Size(36, 16);
			this.LastPackage.TabIndex = 10;
			this.LastPackage.Text = ">>";
			this.LastPackage.Click += new System.EventHandler(this.LastPackage_Click);
			// 
			// txbInfo
			// 
			this.txbInfo.AcceptsReturn = true;
			this.txbInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbInfo.Enabled = false;
			this.txbInfo.Location = new System.Drawing.Point(3, 159);
			this.txbInfo.Name = "txbInfo";
			this.txbInfo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txbInfo.Size = new System.Drawing.Size(186, 21);
			this.txbInfo.TabIndex = 7;
			this.txbInfo.Text = "";
			this.txbInfo.WordWrap = false;
			this.txbInfo.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbInfo_KeyDown);
			this.txbInfo.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblInfo
			// 
			this.lblInfo.Location = new System.Drawing.Point(5, 145);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(44, 15);
			this.lblInfo.TabIndex = 8;
			this.lblInfo.Text = "Info";
			// 
			// btnInfo
			// 
			this.btnInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnInfo.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnInfo.Location = new System.Drawing.Point(190, 159);
			this.btnInfo.Name = "btnInfo";
			this.btnInfo.Size = new System.Drawing.Size(27, 23);
			this.btnInfo.TabIndex = 9;
			this.btnInfo.Text = "...";
			this.btnInfo.Click += new System.EventHandler(this.btnInfo_Click);
			// 
			// lblSerial
			// 
			this.lblSerial.Location = new System.Drawing.Point(6, 106);
			this.lblSerial.Name = "lblSerial";
			this.lblSerial.Size = new System.Drawing.Size(100, 15);
			this.lblSerial.TabIndex = 10;
			this.lblSerial.Text = "Serial number";
			// 
			// txbSerial
			// 
			this.txbSerial.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbSerial.Enabled = false;
			this.txbSerial.Location = new System.Drawing.Point(4, 121);
			this.txbSerial.Name = "txbSerial";
			this.txbSerial.Size = new System.Drawing.Size(215, 21);
			this.txbSerial.TabIndex = 5;
			this.txbSerial.Text = "";
			// 
			// expando1
			// 
			this.expando1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expando1.Animate = true;
			this.expando1.ExpandedHeight = 210;
			this.expando1.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expando1.Items.AddRange(new System.Windows.Forms.Control[] {
																				this.groupBox1,
																				this.xpTextBox2,
																				this.label2,
																				this.groupBox2,
																				this.textBox1,
																				this.label3,
																				this.button2});
			this.expando1.Location = new System.Drawing.Point(12, 219);
			this.expando1.Name = "expando1";
			this.expando1.Size = new System.Drawing.Size(224, 210);
			this.expando1.TabIndex = 1;
			this.expando1.Text = "Software";
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Controls.Add(this.xpTextBox1);
			this.groupBox1.Location = new System.Drawing.Point(2, 116);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(219, 48);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Action";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(9, 17);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(31, 23);
			this.label1.TabIndex = 7;
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(185, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(27, 23);
			this.button1.TabIndex = 5;
			this.button1.Text = "...";
			// 
			// xpTextBox1
			// 
			this.xpTextBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.xpTextBox1.Location = new System.Drawing.Point(49, 17);
			this.xpTextBox1.Name = "xpTextBox1";
			this.xpTextBox1.ReadOnly = true;
			this.xpTextBox1.Size = new System.Drawing.Size(126, 21);
			this.xpTextBox1.TabIndex = 3;
			this.xpTextBox1.Text = "";
			// 
			// xpTextBox2
			// 
			this.xpTextBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.xpTextBox2.Enabled = false;
			this.xpTextBox2.Location = new System.Drawing.Point(4, 92);
			this.xpTextBox2.Name = "xpTextBox2";
			this.xpTextBox2.Size = new System.Drawing.Size(215, 21);
			this.xpTextBox2.TabIndex = 4;
			this.xpTextBox2.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(6, 76);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 15);
			this.label2.TabIndex = 5;
			this.label2.Text = "Title";
			// 
			// groupBox2
			// 
			this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox2.Controls.Add(this.taskItem1);
			this.groupBox2.Controls.Add(this.taskItem2);
			this.groupBox2.Controls.Add(this.taskItem3);
			this.groupBox2.Controls.Add(this.taskItem4);
			this.groupBox2.Controls.Add(this.taskItem5);
			this.groupBox2.Controls.Add(this.taskItem6);
			this.groupBox2.Location = new System.Drawing.Point(3, 23);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(218, 52);
			this.groupBox2.TabIndex = 6;
			this.groupBox2.TabStop = false;
			// 
			// taskItem1
			// 
			this.taskItem1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.taskItem1.BackColor = System.Drawing.Color.Transparent;
			this.taskItem1.Image = null;
			this.taskItem1.Location = new System.Drawing.Point(7, 13);
			this.taskItem1.Name = "taskItem1";
			this.taskItem1.Size = new System.Drawing.Size(58, 16);
			this.taskItem1.TabIndex = 2;
			this.taskItem1.Text = "Add";
			// 
			// taskItem2
			// 
			this.taskItem2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.taskItem2.BackColor = System.Drawing.Color.Transparent;
			this.taskItem2.Image = null;
			this.taskItem2.Location = new System.Drawing.Point(65, 13);
			this.taskItem2.Name = "taskItem2";
			this.taskItem2.Size = new System.Drawing.Size(83, 16);
			this.taskItem2.TabIndex = 3;
			this.taskItem2.Text = "Delete";
			// 
			// taskItem3
			// 
			this.taskItem3.BackColor = System.Drawing.Color.Transparent;
			this.taskItem3.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.taskItem3.Image = null;
			this.taskItem3.Location = new System.Drawing.Point(6, 29);
			this.taskItem3.Name = "taskItem3";
			this.taskItem3.Size = new System.Drawing.Size(37, 23);
			this.taskItem3.TabIndex = 7;
			this.taskItem3.Text = "<<";
			// 
			// taskItem4
			// 
			this.taskItem4.BackColor = System.Drawing.Color.Transparent;
			this.taskItem4.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.taskItem4.Image = null;
			this.taskItem4.Location = new System.Drawing.Point(60, 29);
			this.taskItem4.Name = "taskItem4";
			this.taskItem4.Size = new System.Drawing.Size(23, 16);
			this.taskItem4.TabIndex = 8;
			this.taskItem4.Text = "<";
			// 
			// taskItem5
			// 
			this.taskItem5.BackColor = System.Drawing.Color.Transparent;
			this.taskItem5.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.taskItem5.Image = null;
			this.taskItem5.Location = new System.Drawing.Point(112, 29);
			this.taskItem5.Name = "taskItem5";
			this.taskItem5.Size = new System.Drawing.Size(23, 16);
			this.taskItem5.TabIndex = 9;
			this.taskItem5.Text = ">";
			// 
			// taskItem6
			// 
			this.taskItem6.BackColor = System.Drawing.Color.Transparent;
			this.taskItem6.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.taskItem6.Image = null;
			this.taskItem6.Location = new System.Drawing.Point(149, 29);
			this.taskItem6.Name = "taskItem6";
			this.taskItem6.Size = new System.Drawing.Size(36, 16);
			this.taskItem6.TabIndex = 10;
			this.taskItem6.Text = ">>";
			// 
			// textBox1
			// 
			this.textBox1.AcceptsReturn = true;
			this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.textBox1.Enabled = false;
			this.textBox1.Location = new System.Drawing.Point(3, 180);
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(186, 21);
			this.textBox1.TabIndex = 7;
			this.textBox1.Text = "";
			this.textBox1.WordWrap = false;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(5, 162);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(44, 15);
			this.label3.TabIndex = 8;
			this.label3.Text = "Info";
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button2.Location = new System.Drawing.Point(190, 180);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(27, 23);
			this.button2.TabIndex = 9;
			this.button2.Text = "...";
			// 
			// gbAction
			// 
			this.gbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbAction.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(214)), ((System.Byte)(223)), ((System.Byte)(247)));
			this.gbAction.Controls.Add(this.btnAction);
			this.gbAction.Controls.Add(this.txbAction);
			this.gbAction.Controls.Add(this.lblAction);
			this.gbAction.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.gbAction.Location = new System.Drawing.Point(2, 144);
			this.gbAction.Name = "gbAction";
			this.gbAction.Size = new System.Drawing.Size(219, 52);
			this.gbAction.TabIndex = 3;
			this.gbAction.TabStop = false;
			this.gbAction.Text = "Action";
			// 
			// btnAction
			// 
			this.btnAction.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnAction.BackColor = System.Drawing.SystemColors.Control;
			this.btnAction.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnAction.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnAction.Location = new System.Drawing.Point(185, 23);
			this.btnAction.Name = "btnAction";
			this.btnAction.Size = new System.Drawing.Size(27, 23);
			this.btnAction.TabIndex = 5;
			this.btnAction.Text = "...";
			this.btnAction.Click += new System.EventHandler(this.btnAction_Click);
			// 
			// txbAction
			// 
			this.txbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbAction.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txbAction.Location = new System.Drawing.Point(58, 22);
			this.txbAction.Name = "txbAction";
			this.txbAction.ReadOnly = true;
			this.txbAction.Size = new System.Drawing.Size(126, 20);
			this.txbAction.TabIndex = 3;
			this.txbAction.Text = "";
			// 
			// lblAction
			// 
			this.lblAction.BackColor = System.Drawing.SystemColors.Control;
			this.lblAction.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAction.Location = new System.Drawing.Point(9, 24);
			this.lblAction.Name = "lblAction";
			this.lblAction.Size = new System.Drawing.Size(45, 23);
			this.lblAction.TabIndex = 7;
			// 
			// PackageDataPanel
			// 
			this.Name = "PackageDataPanel";
			this.Size = new System.Drawing.Size(248, 339);
			((System.ComponentModel.ISupportInitialize)(this.Panel)).EndInit();
			this.Panel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expPackages)).EndInit();
			this.expPackages.ResumeLayout(false);
			this.gbTasks.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expando1)).EndInit();
			this.expando1.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.gbAction.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private CDIStudio.CDMenus.DB.PackageDB	packageDB;
		public System.Windows.Forms.Binding BindTitle;
		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void InitializePanel()
		{
			//Synchronise the binding context of the panel with CDMenu
			this.BindingContext[packageDB.actionsDT].PositionChanged += 
				new EventHandler(Position_Changed);
			CDMenuFactory.CDMenu.BindingContext[packageDB.actionsDT].PositionChanged += 
				new EventHandler(Position_ChangedOfCDMenu);

			//Add DataBindings
			txbTitle.DataBindings.Add( "Text",packageDB.actionsDT,"software_title");
			lblAction.DataBindings.Add("Text",packageDB.actionsDT,"parameter1");
			txbAction.DataBindings.Add("Text",packageDB.actionsDT,"parameter2");
			txbInfo.DataBindings.Add("Text",packageDB.actionsDT,"info");
		
			UpdateControls();
		}

		private void UpdateControls()
		{	
			if(this.BindingContext[packageDB.actionsDT].Count == 0)
			{	
				txbTitle.Enabled = false;
				txbInfo.Enabled = false;
				DeletePackage.Enabled = false;
				btnAction.Enabled = false;
				btnInfo.Enabled = false;

			}
			else
			{
				txbTitle.Enabled = true;
				txbInfo.Enabled = true;
				DeletePackage.Enabled = true;
				btnAction.Enabled = true;
				btnInfo.Enabled = true;
			}

			UpdateNavigationControls();
		}

		private void UpdateNavigationControls()
		{
			if(this.BindingContext[packageDB.actionsDT].Count <= 1)
			{
				FirstPackage.Enabled = false;
				PreviousPackage.Enabled = false;
				NextPackage.Enabled = false;
				LastPackage.Enabled = false;
			}
			else if(this.BindingContext[packageDB.actionsDT].Position == 0)
			{
				FirstPackage.Enabled = false;
				PreviousPackage.Enabled = false;
				NextPackage.Enabled = true;
				LastPackage.Enabled = true;
			}
			else if(this.BindingContext[packageDB.actionsDT].Position == this.BindingContext[packageDB.actionsDT].Count-1)
			{
				FirstPackage.Enabled = true;
				PreviousPackage.Enabled = true;
				NextPackage.Enabled = false;
				LastPackage.Enabled = false;
			}
			else
			{
				FirstPackage.Enabled = true;
				PreviousPackage.Enabled = true;
				NextPackage.Enabled = true;
				LastPackage.Enabled = true;
			}
		}

		private void btnAction_Click(object sender, System.EventArgs e)
		{
			int pos = this.BindingContext[packageDB.actionsDT].Position;
			CDIStudio.CDMenus.TypeEditors.ActionEditor Editor = new ActionEditor();
			ActionParameters ap = new ActionParameters();

			ap[0] = packageDB.actionsDT.Rows[pos]["parameter1"].ToString();
			ap[1] = packageDB.actionsDT.Rows[pos]["parameter2"].ToString();
			ap[2] = packageDB.actionsDT.Rows[pos]["parameter3"].ToString();
			ap[3] = packageDB.actionsDT.Rows[pos]["parameter4"].ToString();
			ap[4] = packageDB.actionsDT.Rows[pos]["parameter5"].ToString();
			Editor.Action = ap;

			if( Editor.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				packageDB.actionsDT.Rows[pos]["parameter1"] = Editor.Action[0];
				packageDB.actionsDT.Rows[pos]["parameter2"] = Editor.Action[1];
				packageDB.actionsDT.Rows[pos]["parameter3"] = Editor.Action[2];
				packageDB.actionsDT.Rows[pos]["parameter4"] = Editor.Action[3];
				packageDB.actionsDT.Rows[pos]["parameter5"] = Editor.Action[4];
			}
		}

		private void AddItem_Click(object sender, System.EventArgs e)
		{
		
		}

		private void DeleteItem_Click(object sender, System.EventArgs e)
		{
		
		}

		

		private void txbTitle_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if(e.KeyValue == 13)
				{
					this.BindingContext[packageDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[packageDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void txbTitle_Validated(object sender, System.EventArgs e)
		{
			try
			{
				this.BindingContext[packageDB.actionsDT].EndCurrentEdit();
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}		
		}

		private void FirstItem_Click(object sender, System.EventArgs e)
		{
			
		}

		private void PreviewsItem_Click(object sender, System.EventArgs e)
		{
			
		}

		private void NextItem_Click(object sender, System.EventArgs e)
		{
			
		}

		private void LastItem_Click(object sender, System.EventArgs e)
		{
			
		}

		private void Position_Changed(object sender, EventArgs e)
		{
			CDMenuFactory.CDMenu.BindingContext[packageDB.actionsDT].Position = this.BindingContext[packageDB.actionsDT].Position;
			UpdateNavigationControls();
		}

		private void Position_ChangedOfCDMenu(object sender, EventArgs e)
		{
			this.BindingContext[packageDB.actionsDT].Position = CDMenuFactory.CDMenu.BindingContext[packageDB.actionsDT].Position; 
			
		}

		private void txbInfo_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{	 
				if(e.KeyValue == 13)
				{
					this.BindingContext[packageDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbInfo.SelectAll();					
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[packageDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbInfo.Select(0,txbInfo.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void btnInfo_Click(object sender, System.EventArgs e)
		{
			TextEditor te = new TextEditor();
			te.TxtBox.Text =txbInfo.Text;
			if(te.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbInfo.Text = te.TxtBox.Text;
				this.BindingContext[packageDB.actionsDT].EndCurrentEdit();
			}
		}

		#endregion

		private void DeletePackage_Click(object sender, System.EventArgs e)
		{
			if(this.BindingContext[packageDB.actionsDT].Count > 0)
			{
				this.BindingContext[packageDB.actionsDT].RemoveAt(
					this.BindingContext[packageDB.actionsDT].Position);
			}

			UpdateControls();
		}

		private void AddPackage_Click(object sender, System.EventArgs e)
		{
			DataRow dr;

			dr= packageDB.actionsDT.NewRow();
			dr["software_title"] = "title";
			dr["parameter1"] = "None";
			packageDB.actionsDT.Rows.Add(dr);
			this.BindingContext[packageDB.actionsDT].Position = 
				this.BindingContext[packageDB.actionsDT].Count-1;

			UpdateControls();
		}

		private void FirstPackage_Click(object sender, System.EventArgs e)
		{
		this.BindingContext[packageDB.actionsDT].Position = 0;
		}

		private void PreviewsPackage_Click(object sender, System.EventArgs e)
		{
		this.BindingContext[packageDB.actionsDT].Position--;
		}

		private void NextPackage_Click(object sender, System.EventArgs e)
		{
		this.BindingContext[packageDB.actionsDT].Position++;
		}

		private void LastPackage_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[packageDB.actionsDT].Position =
				this.BindingContext[packageDB.actionsDT].Count-1;
		}


		
	}
}

