#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using CDIStudio.CDMenus.TypeEditors;
using CDIStudio.CDMenus.Wizards;
using System.Data;
using XPExplorerBar;

namespace CDIStudio.CDMenus.DB
{
	public class SimpleDataPanel : CDIStudio.CDMenus.DB.DataPanel
	{
		private System.Windows.Forms.GroupBox gbAction;
		private XPExplorerBar.XPTextBox txbAction;
		private System.Windows.Forms.Button btnAction;
		private XPExplorerBar.XPTextBox txbTitle;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.Label lblAction;
		private System.Windows.Forms.GroupBox gbTasks;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.TextBox txbInfo;
		private System.Windows.Forms.Button btnInfo;
		private XPExplorerBar.Expando expItems;
		private System.Windows.Forms.ToolTip toolTip1;
		private CDIStudio.CDMenus.Components.DBNavigation dbNavigation1;
		private System.ComponentModel.IContainer components = null;

		public SimpleDataPanel()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();
		}

		public SimpleDataPanel(CDIStudio.CDMenus.DB.SimpleDB aSimpleDB):this()
		{
		    simpleDB = aSimpleDB;
			InitializePanel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.expItems = new XPExplorerBar.Expando();
			this.gbAction = new System.Windows.Forms.GroupBox();
			this.btnAction = new System.Windows.Forms.Button();
			this.txbAction = new XPExplorerBar.XPTextBox();
			this.lblAction = new System.Windows.Forms.Label();
			this.txbTitle = new XPExplorerBar.XPTextBox();
			this.lblTitle = new System.Windows.Forms.Label();
			this.gbTasks = new System.Windows.Forms.GroupBox();
			this.dbNavigation1 = new CDIStudio.CDMenus.Components.DBNavigation();
			this.txbInfo = new System.Windows.Forms.TextBox();
			this.lblInfo = new System.Windows.Forms.Label();
			this.btnInfo = new System.Windows.Forms.Button();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			((System.ComponentModel.ISupportInitialize)(this.Panel)).BeginInit();
			this.Panel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expItems)).BeginInit();
			this.expItems.SuspendLayout();
			this.gbAction.SuspendLayout();
			this.gbTasks.SuspendLayout();
			this.SuspendLayout();
			// 
			// Panel
			// 
			this.Panel.Expandos.AddRange(new XPExplorerBar.Expando[] {
																		 this.expItems});
			this.Panel.Name = "Panel";
			this.Panel.Size = new System.Drawing.Size(245, 303);
			// 
			// expItems
			// 
			this.expItems.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expItems.Animate = true;
			this.expItems.ExpandedHeight = 210;
			this.expItems.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expItems.Items.AddRange(new System.Windows.Forms.Control[] {
																				this.gbAction,
																				this.txbTitle,
																				this.lblTitle,
																				this.gbTasks,
																				this.txbInfo,
																				this.lblInfo,
																				this.btnInfo});
			this.expItems.Location = new System.Drawing.Point(12, 12);
			this.expItems.Name = "expItems";
			this.expItems.Size = new System.Drawing.Size(221, 210);
			this.expItems.TabIndex = 0;
			this.expItems.Text = "Items";
			// 
			// gbAction
			// 
			this.gbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbAction.Controls.Add(this.btnAction);
			this.gbAction.Controls.Add(this.txbAction);
			this.gbAction.Controls.Add(this.lblAction);
			this.gbAction.Location = new System.Drawing.Point(4, 115);
			this.gbAction.Name = "gbAction";
			this.gbAction.Size = new System.Drawing.Size(216, 52);
			this.gbAction.TabIndex = 3;
			this.gbAction.TabStop = false;
			this.gbAction.Text = "Action";
			// 
			// btnAction
			// 
			this.btnAction.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnAction.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnAction.Location = new System.Drawing.Point(180, 17);
			this.btnAction.Name = "btnAction";
			this.btnAction.Size = new System.Drawing.Size(27, 23);
			this.btnAction.TabIndex = 5;
			this.btnAction.Text = "...";
			this.btnAction.Click += new System.EventHandler(this.btnAction_Click);
			// 
			// txbAction
			// 
			this.txbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbAction.Location = new System.Drawing.Point(56, 18);
			this.txbAction.Name = "txbAction";
			this.txbAction.ReadOnly = true;
			this.txbAction.Size = new System.Drawing.Size(123, 21);
			this.txbAction.TabIndex = 3;
			this.txbAction.Text = "";
			// 
			// lblAction
			// 
			this.lblAction.Location = new System.Drawing.Point(9, 17);
			this.lblAction.Name = "lblAction";
			this.lblAction.Size = new System.Drawing.Size(45, 23);
			this.lblAction.TabIndex = 7;
			// 
			// txbTitle
			// 
			this.txbTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbTitle.Enabled = false;
			this.txbTitle.Location = new System.Drawing.Point(2, 88);
			this.txbTitle.Name = "txbTitle";
			this.txbTitle.Size = new System.Drawing.Size(212, 21);
			this.txbTitle.TabIndex = 4;
			this.txbTitle.Text = "";
			this.txbTitle.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbTitle_KeyDown);
			this.txbTitle.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblTitle
			// 
			this.lblTitle.Location = new System.Drawing.Point(4, 75);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(100, 15);
			this.lblTitle.TabIndex = 5;
			this.lblTitle.Text = "Title";
			// 
			// gbTasks
			// 
			this.gbTasks.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbTasks.Controls.Add(this.dbNavigation1);
			this.gbTasks.Location = new System.Drawing.Point(3, 23);
			this.gbTasks.Name = "gbTasks";
			this.gbTasks.Size = new System.Drawing.Size(215, 47);
			this.gbTasks.TabIndex = 6;
			this.gbTasks.TabStop = false;
			// 
			// dbNavigation1
			// 
			this.dbNavigation1.Location = new System.Drawing.Point(6, 10);
			this.dbNavigation1.Name = "dbNavigation1";
			this.dbNavigation1.Size = new System.Drawing.Size(202, 30);
			this.dbNavigation1.TabIndex = 0;
			this.dbNavigation1.PreviousClick += new System.EventHandler(this.PreviousItem_Click);
			this.dbNavigation1.NextClick += new System.EventHandler(this.NextItem_Click);
			this.dbNavigation1.AddClick += new System.EventHandler(this.AddItem_Click);
			this.dbNavigation1.FirstClick += new System.EventHandler(this.FirstItem_Click);
			this.dbNavigation1.DeleteClick += new System.EventHandler(this.DeleteItem_Click);
			this.dbNavigation1.WizardClick += new System.EventHandler(this.WizardItem_Click);
			this.dbNavigation1.LastClick += new System.EventHandler(this.LastItem_Click);
			// 
			// txbInfo
			// 
			this.txbInfo.AcceptsReturn = true;
			this.txbInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbInfo.Enabled = false;
			this.txbInfo.Location = new System.Drawing.Point(1, 185);
			this.txbInfo.Name = "txbInfo";
			this.txbInfo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txbInfo.Size = new System.Drawing.Size(183, 21);
			this.txbInfo.TabIndex = 7;
			this.txbInfo.Text = "";
			this.txbInfo.WordWrap = false;
			this.txbInfo.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txbInfo_KeyDown);
			this.txbInfo.Validated += new System.EventHandler(this.txbTitle_Validated);
			// 
			// lblInfo
			// 
			this.lblInfo.Location = new System.Drawing.Point(3, 171);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(44, 15);
			this.lblInfo.TabIndex = 8;
			this.lblInfo.Text = "Info";
			// 
			// btnInfo
			// 
			this.btnInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnInfo.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnInfo.Location = new System.Drawing.Point(187, 184);
			this.btnInfo.Name = "btnInfo";
			this.btnInfo.Size = new System.Drawing.Size(27, 23);
			this.btnInfo.TabIndex = 9;
			this.btnInfo.Text = "...";
			this.btnInfo.Click += new System.EventHandler(this.btnInfo_Click);
			// 
			// SimpleDataPanel
			// 
			this.Name = "SimpleDataPanel";
			this.Size = new System.Drawing.Size(245, 303);
			((System.ComponentModel.ISupportInitialize)(this.Panel)).EndInit();
			this.Panel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expItems)).EndInit();
			this.expItems.ResumeLayout(false);
			this.gbAction.ResumeLayout(false);
			this.gbTasks.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private CDIStudio.CDMenus.DB.SimpleDB simpleDB;
		private FileAdditionWizard wizard;
		public System.Windows.Forms.Binding BindTitle;
		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void InitializePanel()
		{
			//Synchronise the binding context of the panel with CDMenu
			this.BindingContext[simpleDB.actionsDT].PositionChanged += 
				new EventHandler(Position_Changed);
			CDMenuFactory.CDMenu.BindingContext[simpleDB.actionsDT].PositionChanged += 
				new EventHandler(Position_ChangedOfCDMenu);

			//Add DataBindings
			txbTitle.DataBindings.Add( "Text",simpleDB.actionsDT,"software_title");
			lblAction.DataBindings.Add("Text",simpleDB.actionsDT,"parameter1");
			txbAction.DataBindings.Add("Text",simpleDB.actionsDT,"parameter2");
			txbInfo.DataBindings.Add("Text",simpleDB.actionsDT,"info");
		
			//Wizard
			wizard = new FileAdditionWizard();
			wizard.AddingFile += new AddFileDelegate(this.AddFile);

			UpdateControls();
		}

		private void UpdateControls()
		{	
			if(this.BindingContext[simpleDB.actionsDT].Count == 0)
			{	
				txbTitle.Enabled = false;
				txbInfo.Enabled = false;
				btnAction.Enabled = false;
				btnInfo.Enabled = false;
				dbNavigation1.DeleteCtrl.Enabled = false;
			}
			else
			{
				txbTitle.Enabled = true;
				txbInfo.Enabled = true;
				btnAction.Enabled = true;
				btnInfo.Enabled = true;
				dbNavigation1.DeleteCtrl.Enabled = true;
			}

			UpdateNavigationControls();
		}

		private void UpdateNavigationControls()
		{
			if(this.BindingContext[simpleDB.actionsDT].Count <= 1)
			{
				dbNavigation1.FirstCtrl.Enabled = false;
				dbNavigation1.PreviousCtrl.Enabled = false;
				dbNavigation1.NextCtrl.Enabled = false;
				dbNavigation1.LastCtrl.Enabled = false;
			}
			else if(this.BindingContext[simpleDB.actionsDT].Position == 0)
			{
				dbNavigation1.FirstCtrl.Enabled = false;
				dbNavigation1.PreviousCtrl.Enabled = false;
				dbNavigation1.NextCtrl.Enabled = true;
				dbNavigation1.LastCtrl.Enabled = true;
			}
			else if(this.BindingContext[simpleDB.actionsDT].Position == this.BindingContext[simpleDB.actionsDT].Count-1)
			{
				dbNavigation1.FirstCtrl.Enabled = true;
				dbNavigation1.PreviousCtrl.Enabled = true;
				dbNavigation1.NextCtrl.Enabled = false;
				dbNavigation1.LastCtrl.Enabled = false;
			}
			else
			{
				dbNavigation1.FirstCtrl.Enabled = true;
				dbNavigation1.PreviousCtrl.Enabled = true;
				dbNavigation1.NextCtrl.Enabled = true;
				dbNavigation1.LastCtrl.Enabled = true;
			}
		}

		private void btnAction_Click(object sender, System.EventArgs e)
		{
			int pos = this.BindingContext[simpleDB.actionsDT].Position;
			CDIStudio.CDMenus.TypeEditors.ActionEditor Editor = new ActionEditor();
			ActionParameters ap = new ActionParameters();

			ap[0] = simpleDB.actionsDT.Rows[pos]["parameter1"].ToString();
			ap[1] = simpleDB.actionsDT.Rows[pos]["parameter2"].ToString();
			ap[2] = simpleDB.actionsDT.Rows[pos]["parameter3"].ToString();
			ap[3] = simpleDB.actionsDT.Rows[pos]["parameter4"].ToString();
			ap[4] = simpleDB.actionsDT.Rows[pos]["parameter5"].ToString();
			Editor.Action = ap;

			if( Editor.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				simpleDB.actionsDT.Rows[pos]["parameter1"] = Editor.Action[0];
				simpleDB.actionsDT.Rows[pos]["parameter2"] = Editor.Action[1];
				simpleDB.actionsDT.Rows[pos]["parameter3"] = Editor.Action[2];
				simpleDB.actionsDT.Rows[pos]["parameter4"] = Editor.Action[3];
				simpleDB.actionsDT.Rows[pos]["parameter5"] = Editor.Action[4];
			}
		}

		private void AddItem_Click(object sender, System.EventArgs e)
		{
			AddFile("title","");
			this.BindingContext[simpleDB.actionsDT].Position = 
				this.BindingContext[simpleDB.actionsDT].Count-1;
			UpdateControls();
		}

		private void DeleteItem_Click(object sender, System.EventArgs e)
		{
			if(this.BindingContext[simpleDB.actionsDT].Count > 0)
			{
				this.BindingContext[simpleDB.actionsDT].RemoveAt(
					this.BindingContext[simpleDB.actionsDT].Position);
			}

			UpdateControls();
		}

		

		private void txbTitle_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if(e.KeyValue == 13)
				{
					this.BindingContext[simpleDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[simpleDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbTitle.Select(0,txbTitle.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void txbTitle_Validated(object sender, System.EventArgs e)
		{
			try
			{
				this.BindingContext[simpleDB.actionsDT].EndCurrentEdit();
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}		
		}

		private void FirstItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[simpleDB.actionsDT].Position = 0;
		}

		private void PreviousItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[simpleDB.actionsDT].Position--;
		}

		private void NextItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[simpleDB.actionsDT].Position++;
		}

		private void LastItem_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[simpleDB.actionsDT].Position =
				this.BindingContext[simpleDB.actionsDT].Count-1;
		}

		private void Position_Changed(object sender, EventArgs e)
		{
			CDMenuFactory.CDMenu.BindingContext[simpleDB.actionsDT].Position = this.BindingContext[simpleDB.actionsDT].Position;
			UpdateNavigationControls();
		}

		private void Position_ChangedOfCDMenu(object sender, EventArgs e)
		{
			this.BindingContext[simpleDB.actionsDT].Position = CDMenuFactory.CDMenu.BindingContext[simpleDB.actionsDT].Position; 
			
		}

		private void txbInfo_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{	 
				if(e.KeyValue == 13)
				{
					this.BindingContext[simpleDB.actionsDT].EndCurrentEdit();
					e.Handled = false;
					txbInfo.SelectAll();					
				}
				else if(e.KeyValue == 27)
				{
					this.BindingContext[simpleDB.actionsDT].CancelCurrentEdit();
					e.Handled = true;
					txbInfo.Select(0,txbInfo.Text.Length);
				}
			}
			catch  (System.Exception eEndEdit)
			{
				MessageBox.Show(eEndEdit.Message);
			}
		}

		private void btnInfo_Click(object sender, System.EventArgs e)
		{
			TextEditor te = new TextEditor();
			te.TxtBox.Text =txbInfo.Text;
			if(te.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbInfo.Text = te.TxtBox.Text;
				this.BindingContext[simpleDB.actionsDT].EndCurrentEdit();
			}
		}

		private void WizardItem_Click(object sender, System.EventArgs e)
		{
			if(wizard.ShowDialog(this) == DialogResult.OK)
			{
				this.BindingContext[simpleDB.actionsDT].Position = 
					this.BindingContext[simpleDB.actionsDT].Count-1;
				UpdateControls();
			}
		}

		public void  AddFile(string Title, string FilePath)
		{
			DataRow dr;
			
			dr= simpleDB.actionsDT.NewRow();
			dr["software_title"] = Title;
			if(FilePath == "")
			{
				dr["parameter1"] = "None";
			}
			else
			{
				dr["parameter1"] = "File";
				dr["parameter2"] = CDMenus.Forms.CDMenu.GetRelativePath(FilePath);
			}

			simpleDB.actionsDT.Rows.Add(dr);
		}		
		#endregion
	}
}

