#region	 Licence and informations



/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.Serialization;
using Finisar.SQLite;
using System.Data;
using CDIStudio.CDMenus.DB;

namespace CDIStudio.CDMenus.Forms
{
	[Serializable]
	public class CDSimple : CDIStudio.CDMenus.Forms.CDMenu
	{
		private System.Windows.Forms.Button btnInstall;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.Label lblinfo;
		private System.Windows.Forms.ListBox lbSoftwares;
		private XPExplorerBar.TaskPane ExplorerBar;
		private XPExplorerBar.Expando expandoList;
		private XPExplorerBar.Expando expandoTasks;
		private XPExplorerBar.TaskItem BrowseCDItem;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.TextBox txtSearch;
		private System.Windows.Forms.Label lblSearch;
		private System.Windows.Forms.PictureBox pictureBoxBackGround;
		private System.ComponentModel.IContainer components = null;

		public CDSimple()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// Version of this CD-Menu
			fMajorVersion = 1;		
			fMinorVersion = 0;

			//Database
			fDB = new CDIStudio.CDMenus.DB.SimpleDB();

			//Add propertys
			PropertyTemplates.PropTemplateForm TemplForm =	new PropertyTemplates.PropTemplateForm(this,"Form");
			TemplForm.BackgroundImage = false;
			PropManager.AddTemplates(TemplForm);
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateLable(lblTitle,"Label Title"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateLable(lblinfo,"Label Info"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateButton(btnInstall,"Button Install"));


		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CDSimple));
			this.lblTitle = new System.Windows.Forms.Label();
			this.btnInstall = new System.Windows.Forms.Button();
			this.lblinfo = new System.Windows.Forms.Label();
			this.ExplorerBar = new XPExplorerBar.TaskPane();
			this.expandoList = new XPExplorerBar.Expando();
			this.lbSoftwares = new System.Windows.Forms.ListBox();
			this.expandoTasks = new XPExplorerBar.Expando();
			this.BrowseCDItem = new XPExplorerBar.TaskItem();
			this.txtSearch = new System.Windows.Forms.TextBox();
			this.lblSearch = new System.Windows.Forms.Label();
			this.btnSearch = new System.Windows.Forms.Button();
			this.pictureBoxBackGround = new System.Windows.Forms.PictureBox();
			((System.ComponentModel.ISupportInitialize)(this.ExplorerBar)).BeginInit();
			this.ExplorerBar.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expandoList)).BeginInit();
			this.expandoList.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.expandoTasks)).BeginInit();
			this.expandoTasks.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblTitle
			// 
			this.lblTitle.BackColor = System.Drawing.Color.Transparent;
			this.lblTitle.Font = new System.Drawing.Font("Bookman Old Style", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTitle.ForeColor = System.Drawing.Color.SteelBlue;
			this.lblTitle.Location = new System.Drawing.Point(198, 13);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(231, 43);
			this.lblTitle.TabIndex = 2;
			this.lblTitle.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnInstall
			// 
			this.btnInstall.BackColor = System.Drawing.SystemColors.Window;
			this.btnInstall.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnInstall.ForeColor = System.Drawing.SystemColors.ControlText;
			this.btnInstall.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnInstall.Location = new System.Drawing.Point(225, 254);
			this.btnInstall.Name = "btnInstall";
			this.btnInstall.Size = new System.Drawing.Size(181, 23);
			this.btnInstall.TabIndex = 0;
			this.btnInstall.Text = "Install";
			this.btnInstall.Click += new System.EventHandler(this.btnInstall_Click);
			// 
			// lblinfo
			// 
			this.lblinfo.BackColor = System.Drawing.Color.Transparent;
			this.lblinfo.ForeColor = System.Drawing.Color.LightSlateGray;
			this.lblinfo.Location = new System.Drawing.Point(208, 86);
			this.lblinfo.Name = "lblinfo";
			this.lblinfo.Size = new System.Drawing.Size(213, 144);
			this.lblinfo.TabIndex = 3;
			this.lblinfo.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// ExplorerBar
			// 
			this.ExplorerBar.AutoScroll = true;
			this.ExplorerBar.AutoScrollMargin = new System.Drawing.Size(12, 12);
			this.ExplorerBar.Dock = System.Windows.Forms.DockStyle.Left;
			this.ExplorerBar.Expandos.AddRange(new XPExplorerBar.Expando[] {
																			   this.expandoList,
																			   this.expandoTasks});
			this.ExplorerBar.Location = new System.Drawing.Point(0, 0);
			this.ExplorerBar.Name = "ExplorerBar";
			this.ExplorerBar.Size = new System.Drawing.Size(188, 289);
			this.ExplorerBar.TabIndex = 4;
			this.ExplorerBar.Text = "taskPane1";
			// 
			// expandoList
			// 
			this.expandoList.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expandoList.Animate = true;
			this.expandoList.ExpandedHeight = 143;
			this.expandoList.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expandoList.Items.AddRange(new System.Windows.Forms.Control[] {
																				   this.lbSoftwares});
			this.expandoList.Location = new System.Drawing.Point(12, 12);
			this.expandoList.Name = "expandoList";
			this.expandoList.Size = new System.Drawing.Size(164, 143);
			this.expandoList.TabIndex = 0;
			this.expandoList.Text = "Softwares";
			// 
			// lbSoftwares
			// 
			this.lbSoftwares.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lbSoftwares.Location = new System.Drawing.Point(1, 23);
			this.lbSoftwares.Name = "lbSoftwares";
			this.lbSoftwares.Size = new System.Drawing.Size(162, 108);
			this.lbSoftwares.TabIndex = 1;
			// 
			// expandoTasks
			// 
			this.expandoTasks.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.expandoTasks.Animate = true;
			this.expandoTasks.ExpandedHeight = 110;
			this.expandoTasks.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.expandoTasks.Items.AddRange(new System.Windows.Forms.Control[] {
																					this.BrowseCDItem,
																					this.txtSearch,
																					this.lblSearch});
			this.expandoTasks.Location = new System.Drawing.Point(12, 167);
			this.expandoTasks.Name = "expandoTasks";
			this.expandoTasks.Size = new System.Drawing.Size(164, 110);
			this.expandoTasks.TabIndex = 1;
			this.expandoTasks.Text = "Tasks";
			// 
			// BrowseCDItem
			// 
			this.BrowseCDItem.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.BrowseCDItem.BackColor = System.Drawing.Color.Transparent;
			this.BrowseCDItem.Image = ((System.Drawing.Image)(resources.GetObject("BrowseCDItem.Image")));
			this.BrowseCDItem.Location = new System.Drawing.Point(18, 90);
			this.BrowseCDItem.Name = "BrowseCDItem";
			this.BrowseCDItem.Size = new System.Drawing.Size(121, 16);
			this.BrowseCDItem.TabIndex = 0;
			this.BrowseCDItem.Text = "Browse CD";
			this.BrowseCDItem.Click += new System.EventHandler(this.BrowseCDItem_Click);
			// 
			// txtSearch
			// 
			this.txtSearch.Location = new System.Drawing.Point(6, 46);
			this.txtSearch.Name = "txtSearch";
			this.txtSearch.Size = new System.Drawing.Size(151, 21);
			this.txtSearch.TabIndex = 1;
			this.txtSearch.Text = "";
			this.txtSearch.TextChanged += new System.EventHandler(this.txtSearch_TextChanged);
			// 
			// lblSearch
			// 
			this.lblSearch.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblSearch.Location = new System.Drawing.Point(6, 29);
			this.lblSearch.Name = "lblSearch";
			this.lblSearch.Size = new System.Drawing.Size(100, 14);
			this.lblSearch.TabIndex = 2;
			this.lblSearch.Text = "Search";
			// 
			// btnSearch
			// 
			this.btnSearch.Location = new System.Drawing.Point(0, 0);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.TabIndex = 0;
			// 
			// pictureBoxBackGround
			// 
			this.pictureBoxBackGround.Dock = System.Windows.Forms.DockStyle.Right;
			this.pictureBoxBackGround.Location = new System.Drawing.Point(188, 0);
			this.pictureBoxBackGround.Name = "pictureBoxBackGround";
			this.pictureBoxBackGround.Size = new System.Drawing.Size(252, 289);
			this.pictureBoxBackGround.TabIndex = 5;
			this.pictureBoxBackGround.TabStop = false;
			// 
			// CDSimple
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(440, 289);
			this.Controls.Add(this.ExplorerBar);
			this.Controls.Add(this.lblinfo);
			this.Controls.Add(this.btnInstall);
			this.Controls.Add(this.lblTitle);
			this.Controls.Add(this.pictureBoxBackGround);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "CDSimple";
			this.Text = "Simple";
			((System.ComponentModel.ISupportInitialize)(this.ExplorerBar)).EndInit();
			this.ExplorerBar.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expandoList)).EndInit();
			this.expandoList.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.expandoTasks)).EndInit();
			this.expandoTasks.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region	CDMenu Info

		private new static CDMenuInfo fInfo;
		static new public CDMenuInfo Info
		{
			get{ return fInfo; }  
		}

		//Static constructor. Initialize CDMenuInfo.
		static CDSimple()
		{
			fInfo = new CDMenuInfo();   			
			Info.Name = "Simple";
			Info.Description = "A collection of softwares.";
			Info.Librarys = new string[] {"XPExplorerBar.dll"};
			Info.Authors = new string[] {"Theodoros Antoniou"};
		}
		#endregion


		#region Serialization & PropertyEditor support
		
		//Deserialization constructor.
		public CDSimple(SerializationInfo info, StreamingContext ctxt):this()
		{	
			PropManager.Deserialize(info);  
		}

		//Serialization function
		public override void GetObjectData(SerializationInfo info, StreamingContext ctxt)
		{
			//When you mark an object with the Serialize attribute , it uses this function
			//for serialization.
			
			PropManager.Serialize(info);	
		}
	
		#endregion	


		#region	Run time support
	
		/// <summary>
		/// It is called when the CDMenu is instantiate at autorun.
		/// Here you should put the code that you want to be executed only at autorun time. 
		/// </summary>
		public override void  AutorunInitialization()
		{
			
		}
		#endregion

		#region	Database

		public override void InitializeDataBindings()
		{
			
			DataTable actionsTable =	DB.DS.Tables["actions"];
			lbSoftwares.DataSource = actionsTable;
			lbSoftwares.DisplayMember = "software_title";
			lblTitle.DataBindings.Add("text",actionsTable,"software_title");
			lblinfo.DataBindings.Add("text",actionsTable,"info");
		}


	    #endregion
		

		#region	Behavior

		private void btnInstall_Click(object sender, System.EventArgs e)
		{
			DataTable actionsTable =	DB.DS.Tables["actions"];
			if(actionsTable.Rows.Count > 0 )
			{
				ActionParameters ap = new ActionParameters();
				int pos = this.BindingContext[actionsTable].Position;
				ap.Parameters[0] = actionsTable.Rows[pos]["parameter1"].ToString();
				ap.Parameters[1] = actionsTable.Rows[pos]["parameter2"].ToString();
				ap.Parameters[2] = actionsTable.Rows[pos]["parameter3"].ToString();
				ap.Parameters[3] = actionsTable.Rows[pos]["parameter4"].ToString();
				ap.Parameters[4] = actionsTable.Rows[pos]["parameter5"].ToString();
				CDIStudio.CDMenus.ProcessManager.Start(ap);
			}
		}

		private void BrowseCDItem_Click(object sender, System.EventArgs e)
		{
			ActionParameters ap = new ActionParameters();
			ap.Parameters[0] = "Folder";
			ap.Parameters[1] = ProjectFolder;
			CDIStudio.CDMenus.ProcessManager.Start(ap);		
		}

		private void txtSearch_TextChanged(object sender, System.EventArgs e)
		{
			if( txtSearch.Text != "")
			{
				int indx = lbSoftwares.FindString(txtSearch.Text);
				if ((0 <= indx) &&(indx <= lbSoftwares.Items.Count))
					lbSoftwares.SelectedIndex =	indx;
			}
		}
		#endregion


	}


}


	

