
#region	 Licence and informations



/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Diagnostics;

namespace CDIStudio.CDMenus.Forms
{
	[Serializable]
	public class CDSingle : CDIStudio.CDMenus.Forms.CDMenu
	{
		private System.ComponentModel.IContainer components = null;

		public CDSingle()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// Version of this CD-Menu
			fMajorVersion = 1;		
			fMinorVersion = 0;

			//Give a round look
			CreateRoundRectagle(); 

			actionInstall = new ActionParameters();
			actionInstall.Name = "Run";
			actionTask1 = new ActionParameters();
			actionTask1.Name = "Task 1";

			PropertyTemplates.PropTemplateForm TemplForm =	new PropertyTemplates.PropTemplateForm(this,"Form");
			TemplForm.BackgroundImage = false;
			PropManager.AddTemplates(TemplForm);
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateXPGradientPanel(xpGradientPanel,"Gradient Panel"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateLinkLable(lblTitle,"Label Title"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateLinkLable(lblTask1,"Label Task 1"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateLable(lblInfo,"Label Info"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateAction(actionInstall,"Actions"));
			PropManager.AddTemplates(new PropertyTemplates.PropTemplateAction(actionTask1,"Actions"));
		}
 
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CDSingle));
			this.xpGradientPanel = new SteepValley.Windows.Forms.XPGradientPanel();
			this.lblTask1 = new System.Windows.Forms.LinkLabel();
			this.lblTitle = new System.Windows.Forms.LinkLabel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.lblInfo = new System.Windows.Forms.Label();
			this.xpGradientPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// xpGradientPanel
			// 
			this.xpGradientPanel.Controls.Add(this.lblTask1);
			this.xpGradientPanel.Controls.Add(this.lblTitle);
			this.xpGradientPanel.Controls.Add(this.pictureBox1);
			this.xpGradientPanel.Controls.Add(this.lblInfo);
			this.xpGradientPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.xpGradientPanel.EndColor = System.Drawing.Color.White;
			this.xpGradientPanel.Location = new System.Drawing.Point(0, 0);
			this.xpGradientPanel.Name = "xpGradientPanel";
			this.xpGradientPanel.Size = new System.Drawing.Size(344, 278);
			this.xpGradientPanel.StartColor = System.Drawing.Color.MediumBlue;
			this.xpGradientPanel.TabIndex = 3;
			this.xpGradientPanel.Watermark = ((System.Drawing.Image)(resources.GetObject("xpGradientPanel.Watermark")));
			// 
			// lblTask1
			// 
			this.lblTask1.ActiveLinkColor = System.Drawing.Color.LightCoral;
			this.lblTask1.BackColor = System.Drawing.Color.Transparent;
			this.lblTask1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblTask1.Font = new System.Drawing.Font("Comic Sans MS", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTask1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.lblTask1.LinkColor = System.Drawing.Color.White;
			this.lblTask1.Location = new System.Drawing.Point(6, 250);
			this.lblTask1.Name = "lblTask1";
			this.lblTask1.Size = new System.Drawing.Size(328, 23);
			this.lblTask1.TabIndex = 8;
			this.lblTask1.TabStop = true;
			this.lblTask1.Text = "www.mysite.com";
			this.lblTask1.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			this.lblTask1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.Task1_Click);
			// 
			// lblTitle
			// 
			this.lblTitle.ActiveLinkColor = System.Drawing.Color.LightCoral;
			this.lblTitle.BackColor = System.Drawing.Color.Transparent;
			this.lblTitle.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblTitle.Font = new System.Drawing.Font("Comic Sans MS", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTitle.ForeColor = System.Drawing.SystemColors.WindowText;
			this.lblTitle.LinkColor = System.Drawing.Color.White;
			this.lblTitle.Location = new System.Drawing.Point(16, 43);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(312, 50);
			this.lblTitle.TabIndex = 7;
			this.lblTitle.TabStop = true;
			this.lblTitle.Text = "Title";
			this.lblTitle.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblTitle.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.Run_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
			this.pictureBox1.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(314, 9);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(24, 24);
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Click += new System.EventHandler(this.pictureBox1_Click);
			// 
			// lblInfo
			// 
			this.lblInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblInfo.BackColor = System.Drawing.Color.Transparent;
			this.lblInfo.Font = new System.Drawing.Font("Comic Sans MS", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblInfo.ForeColor = System.Drawing.Color.PeachPuff;
			this.lblInfo.Location = new System.Drawing.Point(16, 120);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(312, 106);
			this.lblInfo.TabIndex = 4;
			this.lblInfo.Text = "Some information.";
			this.lblInfo.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// CDSingle
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(344, 278);
			this.Controls.Add(this.xpGradientPanel);
			this.KeyPreview = true;
			this.Name = "CDSingle";
			this.Text = "Single";
			this.xpGradientPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label lblInfo;
		private SteepValley.Windows.Forms.XPGradientPanel xpGradientPanel;
		private System.Windows.Forms.LinkLabel lblTitle;
		private System.Windows.Forms.LinkLabel lblTask1;

		

		#region	CDMenu Info

		private new static CDMenuInfo fInfo;
		static new public CDMenuInfo Info
		{
			get{ return fInfo; }  
		}

		//Static constructor. Initialize CDMenuInfo.
		static CDSingle()
		{
			fInfo = new CDMenuInfo();   			
			Info.Name = "Single";
			Info.Description = "A single software.";
			Info.Authors = new string[] {"Theodoros Antoniou"};
			Info.Librarys = new string[] {"xpcommoncontrols.dll"};
		}
		#endregion


		#region Serialization & PropertyEditor support
		
		//Deserialization constructor.
		public CDSingle(SerializationInfo info, StreamingContext ctxt):this()
		{	
			PropManager.Deserialize(info);  
		}

		//Serialization function
		public override void GetObjectData(SerializationInfo info, StreamingContext ctxt)
		{
			//When you mark an object with the Serialize attribute , it uses this function
			//for serialization.
			
			PropManager.Serialize(info);	
		}

	
		#endregion	

		#region	Run time support
	
		/// <summary>
		/// It is called when the CDMenu is instantiate at autorun.
		/// Here you should put the code that you want to be executed only at autorun time. 
		/// </summary>
		public override void  AutorunInitialization()
		{
			ClientMoveable = true;						    
			MoveableControls(new Control[]{xpGradientPanel ,  lblTitle, lblTask1, lblInfo});
		}
		#endregion

		#region	Behavior
		
		protected CDIStudio.CDMenus.ActionParameters factionInstall;
		protected CDIStudio.CDMenus.ActionParameters factionTask1;

		public CDIStudio.CDMenus.ActionParameters actionInstall
		{
			get{ return factionInstall; }
			set{ factionInstall = value; }
		}

		public CDIStudio.CDMenus.ActionParameters actionTask1
		{
			get{ return factionTask1; }
			set{ factionTask1 = value; }
		}

		private void pictureBox1_Click(object sender, System.EventArgs e)
		{
			Close();   
		}		
	
		private void Run_Click(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			CDIStudio.CDMenus.ProcessManager.Start(actionInstall);   
		}	
	
		private void Task1_Click(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			CDIStudio.CDMenus.ProcessManager.Start(actionTask1);  
		}

		#endregion 
	}
}
		

	

