#region	 Licence and informations



/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.Serialization;

namespace CDIStudio.CDMenus.Forms
{
	[Serializable]
	public class CDWebBrowser : CDIStudio.CDMenus.Forms.CDMenu
	{
		private System.ComponentModel.IContainer components = null;

		public CDWebBrowser()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// Version of this CD-Menu
			fMajorVersion = 1;		
			fMinorVersion = 0;
			
			this.FormBorderStyle = FormBorderStyle.Sizable;
			//Add propertys here
			PropertyTemplates.PropTemplateForm TemplForm =	new PropertyTemplates.PropTemplateForm(this,"Form");
			TemplForm.BackgroundImage = false;
			TemplForm.BackColor = false;
			TemplForm.FormBorderStyle = true;
			TemplForm.Size = true;
			PropManager.AddTemplates(TemplForm);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CDWebBrowser));
			this.WebBrowser = new AxSHDocVw.AxWebBrowser();
			((System.ComponentModel.ISupportInitialize)(this.WebBrowser)).BeginInit();
			this.SuspendLayout();
			// 
			// WebBrowser
			// 
			this.WebBrowser.Dock = System.Windows.Forms.DockStyle.Fill;
			this.WebBrowser.Enabled = true;
			this.WebBrowser.Location = new System.Drawing.Point(0, 0);
			this.WebBrowser.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("WebBrowser.OcxState")));
			this.WebBrowser.Size = new System.Drawing.Size(494, 312);
			this.WebBrowser.TabIndex = 0;
			this.WebBrowser.BeforeNavigate2 += new AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2EventHandler(this.WebBrowser_BeforeNavigate2);
			// 
			// CDWebBrowser
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(494, 312);
			this.Controls.Add(this.WebBrowser);
			this.Name = "CDWebBrowser";
			((System.ComponentModel.ISupportInitialize)(this.WebBrowser)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private AxSHDocVw.AxWebBrowser WebBrowser;



		#region	CDMenu Info

		private new static CDMenuInfo fInfo;
		static new public CDMenuInfo Info
		{
			get{ return fInfo; }  
		}

		//Static constructor. Initialize CDMenuInfo.
		static CDWebBrowser()
		{
			fInfo = new CDMenuInfo();   			
			Info.Name = "Web Browser";
			Info.Description = "A web browser.It can host your site.";
			Info.Librarys = new string[2] {"AxInterop.SHDocVw.dll","Interop.SHDocVw.dll"};
			Info.Authors = new string[] {"Theodoros Antoniou"};
		}
		#endregion


		#region Serialization & PropertyEditor support
		
		//Deserialization constructor.
		public CDWebBrowser(SerializationInfo info, StreamingContext ctxt):this()
		{	
			PropManager.Deserialize(info);  
		}

		//Serialization function
		public override void GetObjectData(SerializationInfo info, StreamingContext ctxt)
		{
			//When you mark an object with the Serialize attribute , it uses this function
			//for serialization.
			
			PropManager.Serialize(info);	
		}
	
		#endregion	


		#region	Run time support
	
		/// <summary>
		/// It is called when the CDMenu is instantiate at autorun.
		/// Here you should put the code that you want to be executed only at autorun time. 
		/// </summary>
		public override void  AutorunInitialization()
		{
			WebBrowser.Navigate("www.google.com");
		}
		#endregion

		#region	Database

		public override void InitializeDataBindings()
		{
			//Add the databindings.

		}


	    #endregion


		private void WebBrowser_BeforeNavigate2(object sender, AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2Event e)
		{
			MessageBox.Show("uRL :" + (string)e.uRL);
			if(@"http://cdinterface.sourceforge.net/static-pages/downloads.php/" == (string)e.uRL)
			{
				MessageBox.Show("Canceled");
				e.cancel = true;
			}
		}
		
	}
}
