#region	 Licence and informations

/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Collections;
using System.Windows.Forms;
using System.ComponentModel;
using System.Diagnostics;
using SteepValley.Windows.Forms;

namespace CDIStudio.CDMenus.PropertyTemplates
{
	
	#region	 Class	PropTemplate
	/// <summary>
	/// Summary description for PropertysClasses.
	/// </summary>
	public class PropTemplate
	{
		public PropTemplate(object aObject, string aCategory)
		{
			fObj = aObject;
			fCategory = aCategory;
		}

		protected object fObj;
		protected string fCategory; 
		public virtual void AddPropertys(){}
		public virtual void PropertysGetValue(PropertySpecEventArgs e){}
		public virtual void PropertysSetValue(PropertySpecEventArgs e){}
		public virtual void Serialize(SerializationInfo info, ArrayList meta){}
		public virtual void Deserialize(SerializationInfo info, System.Collections.ArrayList meta ){}
		public string Category
		{
			get{ return fCategory;	}
			set{ fCategory = value; }
		}

		protected CDIStudio.CDMenus.Forms.CDMenu cdMenu
		{
			get{ return  CDIStudio.CDMenus.CDMenuFactory.CDMenu; }
		}

	}

	#endregion

	#region	 Class PropTemplateForm

	public class PropTemplateForm   : PropTemplate
	{
		public PropTemplateForm(object aObject, string aCategory):base(aObject,aCategory)
		{
		   ((Form)aObject).SizeChanged += new System.EventHandler(this.SizeChanged);
		}

		public System.Windows.Forms.Form form
		{
			get{ return (System.Windows.Forms.Form)fObj;	}
			set{ fObj = (System.Windows.Forms.Form)value;  }
		}

		
		public override void AddPropertys()
		{
			if(form.DataBindings["Text"] == null)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Text", typeof(string), Category, "Text on button.",form.Text ));
			if((form.DataBindings["BackColor"] == null)&& BackColor)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Background Color", typeof(System.Drawing.Color), Category, "",form.BackColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Icon", typeof(System.Drawing.Icon), Category, "",null,typeof(System.Drawing.Design.IconEditor),"dummy"));								 
			cdMenu.PropBag.Properties.Add(new PropertySpec("Opacity", typeof(double), Category, "",null,"OpacityEditor",typeof(OpacityConverter)));
			if((form.DataBindings["BackgroundImage"] == null)&& BackgroundImage)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Background Image", typeof(System.Drawing.Image), Category, "",null,typeof(System.Drawing.Design.ImageEditor),"dummy"));
			if((form.DataBindings["FormBorderStyle"] == null)&& FormBorderStyle)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Border Style", typeof(FormBorderStyle), Category, "",null,"FormBorderStyle","dummy"));
			if((form.DataBindings["Size"] == null)&& Size)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Size", typeof(System.Drawing.Size), Category, "",null,"Size","dummy"));
			
//				cdMenu.PropBag.Properties.Add(new PropertySpec("Window", typeof(CDIStudio.CDMenus.Forms.CDMenu), Category, "Form appearance.",null,typeof(CDIStudio.CDMenus.TypeEditors.FormTypeEditor),typeof(CDIStudio.CDMenus.TypeEditors.FormConverter)));
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text":  {e.Value = form.Text;  break;}
				case "Background Color": {e.Value = form.BackColor; break;}
				case "Icon": {e.Value = form.Icon; break;}
				case "Opacity": {e.Value = form.Opacity; break;}
				case "Background Image": {e.Value = form.BackgroundImage; break;}
				case "Border Style": {e.Value = form.FormBorderStyle; break;}
				case "Size": {e.Value = form.Size; break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text": { form.Text = (string)e.Value;  break;}
				case "Background Color": { form.BackColor = (System.Drawing.Color)e.Value;  break;}
				case "Icon": { form.Icon = (System.Drawing.Icon)e.Value;  break;}
				case "Opacity": { form.Opacity = (double)e.Value;  break;}
				case "Background Image": { form.BackgroundImage = (System.Drawing.Image)e.Value;  break;}
				case "Border Style": { form.FormBorderStyle = (System.Windows.Forms.FormBorderStyle)e.Value;  break;}
				case "Size": { form.Size = (System.Drawing.Size)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{	
			if(form.DataBindings["Text"] == null)
			{
				info.AddValue(form.Name + ".Text", form.Text);
				meta.Add(form.Name + ".Text");
			}

			if((form.DataBindings["BackColor"] == null)&& BackColor)
			{
				info.AddValue(form.Name + ".BackColor", form.BackColor);
				meta.Add(form.Name + ".BackColor");
			}

			info.AddValue(form.Name + ".Icon", form.Icon);
			meta.Add(form.Name + ".Icon");

			info.AddValue(form.Name + ".Opacity", form.Opacity);
			meta.Add(form.Name + ".Opacity");

			if((form.DataBindings["BackgroundImage"] == null)&& BackgroundImage)
			{
				info.AddValue(form.Name + ".BackgroundImage", form.BackgroundImage);
				meta.Add(form.Name + ".BackgroundImage");
			}

			if((form.DataBindings["FormBorderStyle"] == null) && FormBorderStyle)
			{
				info.AddValue(form.Name + ".FormBorderStyle", form.FormBorderStyle);
				meta.Add(form.Name + ".FormBorderStyle");
			}

			if((form.DataBindings["Size"] == null) && Size)
			{
				info.AddValue(form.Name + ".Size", form.Size);
				meta.Add(form.Name + ".Size");
			}
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{	
			if((form.DataBindings["Text"] == null) && (meta.Contains(form.Name + ".Text")))
			{
				form.Text = info.GetString(form.Name + ".Text" );
			}

			if(((form.DataBindings["BackColor"] == null)&& BackColor) && (meta.Contains(form.Name + ".BackColor")))
			{
				form.BackColor = (System.Drawing.Color)info.GetValue(form.Name + ".BackColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(form.Name + ".Icon"))
			{
				form.Icon = (System.Drawing.Icon)info.GetValue(form.Name + ".Icon" , typeof(System.Drawing.Icon));
			}

			if(meta.Contains(form.Name + ".Opacity"))
			{
				form.Opacity = info.GetDouble(form.Name + ".Opacity");
			}
			
			if((form.DataBindings["BackgroundImage"] == null)&& BackgroundImage && (meta.Contains(form.Name + ".Image")))
				form.BackgroundImage = (System.Drawing.Image)info.GetValue(form.Name + ".Image", typeof(System.Drawing.Image));
			
			if((form.DataBindings["FormBorderStyle"] == null) && FormBorderStyle &&  (meta.Contains(form.Name + ".FormBorderStyle")))
				form.FormBorderStyle = (System.Windows.Forms.FormBorderStyle)info.GetValue(form.Name + ".FormBorderStyle", typeof(System.Windows.Forms.FormBorderStyle));
		
			if((form.DataBindings["Size"] == null)&& Size && (meta.Contains(form.Name + ".Size")))
				form.Size = (System.Drawing.Size)info.GetValue(form.Name + ".Size", typeof(System.Drawing.Size));
		}


		#region	Flags
		bool fBackColor = true;
		bool fBackgroundImage = true;
	    bool fFormBorderStyle = false;
		bool fSize = false;

		public bool BackColor
		{
			get{ return fBackColor; }
			set{ fBackColor = value; }
		}
		public bool BackgroundImage
		{
			get{ return fBackgroundImage; }
			set{ fBackgroundImage = value; }
		}
		public bool FormBorderStyle
		{
			get{ return fFormBorderStyle; }
			set{ fFormBorderStyle = value; }
		}
		public bool Size
		{
			get{ return fSize; }
			set{ fSize = value; }
		}
		#endregion

		#region	Refresh property editor
		private void SizeChanged(object sender, System.EventArgs e)
		{
			if((cdMenu != null) &&  (cdMenu.PropertyGrid != null))
				cdMenu.PropertyGrid.Refresh();
		}

	    #endregion
	}

	#endregion

	#region	 Class PropTemplateLable

	public class PropTemplateLable   : PropTemplate
	{
		public PropTemplateLable(object aObject, string aCategory):base(aObject,aCategory)
		{
			 
		}


		public System.Windows.Forms.Label Label
		{
			get{ return (System.Windows.Forms.Label)fObj;	}
			set{ fObj = (System.Windows.Forms.Label)value;  }
		}

		
		public override void AddPropertys()
		{
			if(Label.DataBindings["Text"] == null)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Text", typeof(string), Category, "Text on button.",Label.Text ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font", typeof(System.Drawing.Font), Category, "Text on button.",Label.Font ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font Color", typeof(System.Drawing.Color), Category, "Text on button.",Label.ForeColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Background Color", typeof(System.Drawing.Color), Category, "Text on button.",Label.BackColor ));
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text":  {e.Value = Label.Text;  break;}
				case "Font":  {e.Value = Label.Font;  break;}
				case "Font Color":  {e.Value = Label.ForeColor;  break;}
				case "Background Color":  {e.Value = Label.BackColor;  break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text": { Label.Text = (string)e.Value;  break;}
				case "Font": { Label.Font = (System.Drawing.Font)e.Value;  break;}
				case "Font Color": { Label.ForeColor = (System.Drawing.Color)e.Value;  break;}
				case "Background Color": { Label.BackColor = (System.Drawing.Color)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			if(Label.DataBindings["Text"] == null)
			{
				info.AddValue(Label.Name + ".Text", Label.Text);
				meta.Add(Label.Name + ".Text");
			}

			info.AddValue(Label.Name + ".ForeColor", Label.ForeColor);
			meta.Add(Label.Name + ".ForeColor");

			info.AddValue(Label.Name + ".Font", Label.Font);
			meta.Add(Label.Name + ".Font");

			info.AddValue(Label.Name + ".BackColor", Label.BackColor);
			meta.Add(Label.Name + ".BackColor");
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			if(meta.Contains(Label.Name + ".Text"))
			{
				Label.Text = info.GetString(Label.Name + ".Text" );
			}

			if(meta.Contains(Label.Name + ".Font"))
			{
				Label.Font = (System.Drawing.Font)info.GetValue(Label.Name + ".Font" , typeof(System.Drawing.Font));
			}

			if(meta.Contains(Label.Name + ".ForeColor"))
			{
				Label.ForeColor = (System.Drawing.Color)info.GetValue(Label.Name + ".ForeColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(Label.Name + ".BackColor"))
			{
				Label.BackColor = (System.Drawing.Color)info.GetValue(Label.Name + ".BackColor" , typeof(System.Drawing.Color));
			}
		}
	}

	#endregion

	#region	 Class PropTemplateLinkLable

	public class PropTemplateLinkLable   : PropTemplate
	{
		public PropTemplateLinkLable(object aObject, string aCategory):base(aObject,aCategory)
		{
			 
		}


		public System.Windows.Forms.LinkLabel LinkLabel
		{
			get{ return (System.Windows.Forms.LinkLabel)fObj;	}
			set{ fObj = (System.Windows.Forms.LinkLabel)value;  }
		}

		
		public override void AddPropertys()
		{
			if(LinkLabel.DataBindings["Text"] == null)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Text", typeof(string), Category, "Text on button.",LinkLabel.Text ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font", typeof(System.Drawing.Font), Category, "Text on button.",LinkLabel.Font ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font Active Color", typeof(System.Drawing.Color), Category, "Text on button.",LinkLabel.ActiveLinkColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font Link Color", typeof(System.Drawing.Color), Category, "Text on button.",LinkLabel.LinkColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Background Color", typeof(System.Drawing.Color), Category, "Text on button.",LinkLabel.BackColor ));
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text":  {e.Value = LinkLabel.Text;  break;}
				case "Font":  {e.Value = LinkLabel.Font;  break;}
				case "Font Active Color":  {e.Value = LinkLabel.ActiveLinkColor;  break;}
				case "Font Link Color":  {e.Value = LinkLabel.LinkColor;  break;}
				case "Background Color":  {e.Value = LinkLabel.BackColor;  break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text": { LinkLabel.Text = (string)e.Value;  break;}
				case "Font": { LinkLabel.Font = (System.Drawing.Font)e.Value;  break;}
				case "Font Active Color": { LinkLabel.ActiveLinkColor = (System.Drawing.Color)e.Value;  break;}
				case "Font Link Color": { LinkLabel.LinkColor = (System.Drawing.Color)e.Value;  break;}
				case "Background Color": { LinkLabel.BackColor = (System.Drawing.Color)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			if(LinkLabel.DataBindings["Text"] == null)
			{
				info.AddValue(LinkLabel.Name + ".Text", LinkLabel.Text);
				meta.Add(LinkLabel.Name + ".Text");
			}
			
			info.AddValue(LinkLabel.Name + ".ActiveLinkColor", LinkLabel.ActiveLinkColor);
			meta.Add(LinkLabel.Name + ".ActiveLinkColor");

			info.AddValue(LinkLabel.Name + ".LinkColor", LinkLabel.LinkColor);
			meta.Add(LinkLabel.Name + ".LinkColor");

			info.AddValue(LinkLabel.Name + ".Font", LinkLabel.Font);
			meta.Add(LinkLabel.Name + ".Font");

			info.AddValue(LinkLabel.Name + ".BackColor", LinkLabel.BackColor);
			meta.Add(LinkLabel.Name + ".BackColor");
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			if(meta.Contains(LinkLabel.Name + ".Text"))
			{
				LinkLabel.Text = info.GetString(LinkLabel.Name + ".Text" );
			}

			if(meta.Contains(LinkLabel.Name + ".Font"))
			{
				LinkLabel.Font = (System.Drawing.Font)info.GetValue(LinkLabel.Name + ".Font" , typeof(System.Drawing.Font));
			}

			if(meta.Contains(LinkLabel.Name + ".ActiveLinkColor"))
			{
				LinkLabel.ActiveLinkColor = (System.Drawing.Color)info.GetValue(LinkLabel.Name + ".ActiveLinkColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(LinkLabel.Name + ".LinkColor"))
			{
				LinkLabel.LinkColor = (System.Drawing.Color)info.GetValue(LinkLabel.Name + ".LinkColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(LinkLabel.Name + ".BackColor"))
			{
				LinkLabel.BackColor = (System.Drawing.Color)info.GetValue(LinkLabel.Name + ".BackColor" , typeof(System.Drawing.Color));
			}
		}
	}

	#endregion

	#region	 Class PropTemplateButton

	public class PropTemplateButton   : PropTemplate
	{
		public PropTemplateButton(object aObject, string aCategory):base(aObject,aCategory)
		{
			 
		}

		
		public System.Windows.Forms.Button button
		{
			get{ return (System.Windows.Forms.Button)fObj;	}
			set{ fObj = (System.Windows.Forms.Button)value;  }
		}

		
		public override void AddPropertys()
		{
			if(button.DataBindings["Text"] == null)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Text", typeof(string), Category, "Text on button.",button.Text ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Font", typeof(System.Drawing.Font), Category, "Text on button.",button.Font ));
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text":  {e.Value = button.Text;  break;}
				case "Font":  {e.Value = button.Font;  break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Text": { button.Text = (string)e.Value;  break;}
				case "Font": { button.Font = (System.Drawing.Font)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			if(button.DataBindings["Text"] == null)
			{
				info.AddValue(button.Name + ".Text", button.Text);
				meta.Add(button.Name + ".Text");
			}

			info.AddValue(button.Name + ".Font", button.Font);
			meta.Add(button.Name + ".Font");
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			if(meta.Contains(button.Name + ".Text"))
			{
				button.Text = info.GetString(button.Name + ".Text" );
			}

			if(meta.Contains(button.Name + ".Font"))
			{
				button.Font = (System.Drawing.Font)info.GetValue(button.Name + ".Font" , typeof(System.Drawing.Font));
			}
		}
	}

	#endregion

	#region	 Class PropTemplatePictureBox

	public class PropTemplatePictureBox   : PropTemplate
	{
		public PropTemplatePictureBox(object aObject, string aCategory):base(aObject,aCategory)
		{
			 
		}

		
		public System.Windows.Forms.PictureBox pictureBox
		{
			get{ return (System.Windows.Forms.PictureBox)fObj;	}
			set{ fObj = (System.Windows.Forms.PictureBox)value;  }
		}

		
		public override void AddPropertys()
		{
			if((pictureBox.DataBindings["BackColor"] == null)&& BackColor)
				cdMenu.PropBag.Properties.Add(new PropertySpec("Background Color", typeof(System.Drawing.Color), Category, "Text on button.",pictureBox.BackColor ));							 
			if((pictureBox.DataBindings["BackgroundImage"] == null)&& BackgroundImage)	
				cdMenu.PropBag.Properties.Add(new PropertySpec("Background Image", typeof(System.Drawing.Image), Category, "Text on button.",null,typeof(System.Drawing.Design.ImageEditor),"dummy"));
			if((pictureBox.DataBindings["Image"] == null)&& Image)	
				cdMenu.PropBag.Properties.Add(new PropertySpec("Image", typeof(System.Drawing.Image), Category, "Text on button.",null,typeof(System.Drawing.Design.ImageEditor),"dummy"));
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Background Color": {e.Value = pictureBox.BackColor; break;}
				case "Background Image": {e.Value = pictureBox.BackgroundImage; break;}
				case "Image": {e.Value = pictureBox.Image; break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Background Color": { pictureBox.BackColor = (System.Drawing.Color)e.Value;  break;}
				case "Background Image": { pictureBox.BackgroundImage = (System.Drawing.Image)e.Value;  break;}
				case "Image": { pictureBox.Image = (System.Drawing.Image)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			if((pictureBox.DataBindings["BackColor"] == null)&& BackColor)
			{
				info.AddValue(pictureBox.Name + ".BackColor", pictureBox.BackColor);
				meta.Add(pictureBox.Name + ".BackColor");
			}

			if((pictureBox.DataBindings["BackgroundImage"] == null)&& BackgroundImage)
			{
				info.AddValue(pictureBox.Name + ".BackgroundImage", pictureBox.BackgroundImage);
				meta.Add(pictureBox.Name + ".BackgroundImage");
			}

			if((pictureBox.DataBindings["Image"] == null)&& Image)
			{
				info.AddValue(pictureBox.Name + ".Image", pictureBox.Image);
				meta.Add(pictureBox.Name + ".Image");
			}
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{	
			if((pictureBox.DataBindings["BackColor"] == null)&& BackColor && (meta.Contains(pictureBox.Name + ".BackColor")))
				pictureBox.BackColor = (System.Drawing.Color)info.GetValue(pictureBox.Name + ".BackColor" , typeof(System.Drawing.Color));
			
			if((pictureBox.DataBindings["BackgroundImage"] == null)&& BackgroundImage && (meta.Contains(pictureBox.Name + ".BackgroundImage")))
				pictureBox.BackgroundImage = (System.Drawing.Image)info.GetValue(pictureBox.Name + ".BackgroundImage", typeof(System.Drawing.Image));
			
			if((pictureBox.DataBindings["Image"] == null)&& Image && (meta.Contains(pictureBox.Name + ".Image")))
				pictureBox.Image = (System.Drawing.Image)info.GetValue(pictureBox.Name + ".Image", typeof(System.Drawing.Image));
		}

		#region	Flags
		bool fBackColor = true;
		bool fBackgroundImage = true;
		bool fImage = true;

		public bool BackColor
		{
			get{ return fBackColor; }
			set{ fBackColor = value; }
		}
		public bool BackgroundImage
		{
			get{ return fBackgroundImage; }
			set{ fBackgroundImage = value; }
		}
		public bool Image
		{
			get{ return fImage; }
			set{ fImage = value; }
		}
		#endregion
	}

	#endregion

	#region	 Class PropTemplateCDOptions

	public class PropTemplateCDOptions   : PropTemplate
	{
		public PropTemplateCDOptions(object aObject, string aCategory):base(aObject,aCategory)
		{
			fCategory = "Options"; 
		}

		
		public CDIStudio.CDMenus.CDOptions cdOptions
		{
			get{ return (CDIStudio.CDMenus.CDOptions)fObj;	}
			set{ fObj = (CDIStudio.CDMenus.CDOptions)value;  }
		}

		
		public override void AddPropertys()
		{
			cdMenu.PropBag.Properties.Add(new PropertySpec("Autorun", typeof(CDIStudio.CDMenus.ActionParameters), Category, "On autorun.",null,typeof(CDIStudio.CDMenus.TypeEditors.ActionTypeEditor),typeof(ActionParametersConverter)));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Info", typeof(CDIStudio.CDMenus.Forms.CDMenu), Category, "Informations about CDMenu.",null,typeof(CDIStudio.CDMenus.TypeEditors.CDMenuInfoTypeEditor),typeof(CDIStudio.CDMenus.TypeEditors.CDMenuInfoConverter)));
			cdMenu.PropBag.Properties.Add(new PropertySpec("CD Icon", typeof(System.Drawing.Icon), Category, "",null,typeof(System.Drawing.Design.IconEditor),"dummy"));
		}																																					

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "CD Icon":  {e.Value = cdOptions.Icon;  break;}
				case "Autorun": {e.Value = cdOptions.Autorun;  break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "CD Icon": { cdOptions.Icon = (System.Drawing.Icon)e.Value;  break;}
				case "Autorun": { cdOptions.Autorun = (CDIStudio.CDMenus.ActionParameters)e.Value; break; }
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			info.AddValue(Category + ".Icon", cdOptions.Icon);
			meta.Add(Category + ".Icon");

			info.AddValue(Category + ".Autorun", cdOptions.Autorun.Parameters);
			meta.Add(Category + ".Autorun");
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			//Autorun
			if(meta.Contains(Category + ".Autorun"))
			{
			    cdOptions.Autorun.Parameters = (string[])info.GetValue(Category + ".Autorun", typeof(string[]));
			}

			if(meta.Contains(Category + ".Icon"))
			{
				cdOptions.Icon = (System.Drawing.Icon)info.GetValue(Category + ".Icon", typeof(System.Drawing.Icon));
			}
		}
	}

	#endregion

	#region	 Class PropTemplateAction

	public class PropTemplateAction   : PropTemplate
	{

		public PropTemplateAction(object aObject, string aCategory):base(aObject,aCategory)
		{
			
		}

		public CDIStudio.CDMenus.ActionParameters Action
		{
			get{ return (CDIStudio.CDMenus.ActionParameters)fObj;	}
			set{ fObj = (CDIStudio.CDMenus.ActionParameters)value;  } 
		}

		
		public override void AddPropertys()
		{
			//When the user press "Delete" the action becomes "None"
			CDIStudio.CDMenus.ActionParameters defaultAction = new ActionParameters();
			defaultAction[0] = "None";
			cdMenu.PropBag.Properties.Add(new PropertySpec(Action.Name, typeof(CDIStudio.CDMenus.ActionParameters), Category, "On autorun.",defaultAction,typeof(CDIStudio.CDMenus.TypeEditors.ActionTypeEditor),typeof(ActionParametersConverter)));
		}																																					

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			if(e.Property.Name == Action.Name )
			{
				 e.Value = Action;
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			if(e.Property.Name == Action.Name)
			{
				((CDIStudio.CDMenus.ActionParameters)e.Value).CopyParameters(Action);
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 
			info.AddValue(Category + "." + Action.Name, Action.Parameters); 
			meta.Add(Category + "." + Action.Name);
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			if(meta.Contains(Category + "." + Action.Name))
			{
				Action.Parameters = (string[])info.GetValue(Category + "." + Action.Name, typeof(string[]));
			}
		}
	}

	#endregion

	#region	 Class PropTemplateXPGradientPanel

	public class PropTemplateXPGradientPanel   : PropTemplate
	{
		public PropTemplateXPGradientPanel(object aObject, string aCategory):base(aObject,aCategory)
		{
			 
		}


		public SteepValley.Windows.Forms.XPGradientPanel GradientPanel
		{
			get{ return (SteepValley.Windows.Forms.XPGradientPanel)fObj;	}
			set{ fObj = (SteepValley.Windows.Forms.XPGradientPanel)value;  }
		}

		
		public override void AddPropertys()
		{
			cdMenu.PropBag.Properties.Add(new PropertySpec("Start Color", typeof(System.Drawing.Color), Category, "Text on button.",GradientPanel.StartColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("End Color", typeof(System.Drawing.Color), Category, "Text on button.",GradientPanel.EndColor ));
			cdMenu.PropBag.Properties.Add(new PropertySpec("Gradient", typeof(System.Drawing.Drawing2D.LinearGradientMode), Category, "Text on button.",GradientPanel.Gradient ));
			if((GradientPanel.DataBindings["Watermark"] == null))
			{   
				cdMenu.PropBag.Properties.Add(new PropertySpec("Watermark", typeof(System.Drawing.Image), Category, "Text on button.",null,typeof(System.Drawing.Design.ImageEditor),"dummy"));
			}																																		 
		}

		public override void PropertysGetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Start Color":  {e.Value = GradientPanel.StartColor;  break;}
				case "End Color":  {e.Value = GradientPanel.EndColor;  break;}
				case "Gradient":  {e.Value = GradientPanel.Gradient;  break;}
				case "Watermark": {e.Value = GradientPanel.Watermark; break;}
			}		
		}

		public override void PropertysSetValue(PropertySpecEventArgs e)
		{
			switch(e.Property.Name)
			{
				case "Start Color": { GradientPanel.StartColor = (System.Drawing.Color)e.Value;  break;}
				case "End Color": { GradientPanel.EndColor = (System.Drawing.Color)e.Value;  break;}
				case "Gradient": { GradientPanel.Gradient = (System.Drawing.Drawing2D.LinearGradientMode)e.Value;  break;}
				case "Watermark": { GradientPanel.Watermark = (System.Drawing.Image)e.Value;  break;}
			}
		}
		public override void Serialize(SerializationInfo info, ArrayList meta)
		{ 		
			info.AddValue(GradientPanel.Name + ".StartColor", GradientPanel.StartColor);
			meta.Add(GradientPanel.Name + ".StartColor");

			info.AddValue(GradientPanel.Name + ".EndColor", GradientPanel.EndColor);
			meta.Add(GradientPanel.Name + ".EndColor");

			info.AddValue(GradientPanel.Name + ".Gradient", GradientPanel.Gradient);
			meta.Add(GradientPanel.Name + ".Gradient");

			if((GradientPanel.DataBindings["Watermark"] == null))
			{
				info.AddValue(GradientPanel.Name + ".Watermark", GradientPanel.Watermark);
				meta.Add(GradientPanel.Name + ".Watermark");
			}
		}
		public override void Deserialize(SerializationInfo info , System.Collections.ArrayList meta )
		{
			if(meta.Contains(GradientPanel.Name + ".StartColor"))
			{
				GradientPanel.StartColor = (System.Drawing.Color)info.GetValue(GradientPanel.Name + ".StartColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(GradientPanel.Name + ".EndColor"))
			{
				GradientPanel.EndColor = (System.Drawing.Color)info.GetValue(GradientPanel.Name + ".EndColor" , typeof(System.Drawing.Color));
			}

			if(meta.Contains(GradientPanel.Name + ".Gradient"))
			{
				GradientPanel.Gradient = (System.Drawing.Drawing2D.LinearGradientMode)info.GetValue(GradientPanel.Name + ".Gradient" , typeof(System.Drawing.Drawing2D.LinearGradientMode));
			}

			if((GradientPanel.DataBindings["Watermark"] == null) && (meta.Contains(GradientPanel.Name + ".Watermark")))
			{
				GradientPanel.Watermark = (System.Drawing.Image)info.GetValue(GradientPanel.Name + ".Watermark", typeof(System.Drawing.Image));
			}
		}
	}

	#endregion
}
