#region	 Licence and informations



/***************************************************************************************
 *		Date	:	14-3-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 * 
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://www.sourceforge.net/projects/cdinterface.                      //
//      http://www.cdinterface.sourceforge.net                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Drawing.Design;
using CDIStudio.CDMenus.Forms;
using System.Diagnostics;

namespace CDIStudio.CDMenus.TypeEditors
{
	/// <summary>
	/// Summary description for ActionEditor.
	/// </summary>
	public class ActionEditor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private XPExplorerBar.Expando ExpdActionType;
		private XPExplorerBar.Expando ExpdFile;
		private XPExplorerBar.Expando ExpdFolder;
		private XPExplorerBar.Expando ExpdInternet;
		private System.Windows.Forms.ComboBox cbAction;
		private XPExplorerBar.TaskPane taskPane;
		private XPExplorerBar.XPTextBox txbFile;
		private System.Windows.Forms.Button btnBrowseFile;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private XPExplorerBar.XPTextBox txbFolder;
		private System.Windows.Forms.Button btnBrowseFolder;
		private XPExplorerBar.XPTextBox txbInternet;
		private System.Windows.Forms.Button btnTest;
		private System.Windows.Forms.Label lblhttp;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ActionEditor()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InitializeExpandos();
			//folderBrowserDialog.RootFolder = CDMenuFactory.CDMenu.ProcessManager.ProjectDirectory.FullName;
			openFileDialog.InitialDirectory = CDMenu.MyFilesFolder;	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ActionEditor));
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.taskPane = new XPExplorerBar.TaskPane();
			this.ExpdActionType = new XPExplorerBar.Expando();
			this.cbAction = new System.Windows.Forms.ComboBox();
			this.btnTest = new System.Windows.Forms.Button();
			this.ExpdFile = new XPExplorerBar.Expando();
			this.txbFile = new XPExplorerBar.XPTextBox();
			this.btnBrowseFile = new System.Windows.Forms.Button();
			this.ExpdFolder = new XPExplorerBar.Expando();
			this.txbFolder = new XPExplorerBar.XPTextBox();
			this.btnBrowseFolder = new System.Windows.Forms.Button();
			this.ExpdInternet = new XPExplorerBar.Expando();
			this.txbInternet = new XPExplorerBar.XPTextBox();
			this.lblhttp = new System.Windows.Forms.Label();
			this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			((System.ComponentModel.ISupportInitialize)(this.taskPane)).BeginInit();
			this.taskPane.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ExpdActionType)).BeginInit();
			this.ExpdActionType.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ExpdFile)).BeginInit();
			this.ExpdFile.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ExpdFolder)).BeginInit();
			this.ExpdFolder.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ExpdInternet)).BeginInit();
			this.ExpdInternet.SuspendLayout();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(119, 236);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "OK";
			this.button1.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// button2
			// 
			this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button2.Location = new System.Drawing.Point(198, 236);
			this.button2.Name = "button2";
			this.button2.TabIndex = 2;
			this.button2.Text = "Cancel";
			// 
			// taskPane
			// 
			this.taskPane.AutoScroll = true;
			this.taskPane.AutoScrollMargin = new System.Drawing.Size(12, 12);
			this.taskPane.Dock = System.Windows.Forms.DockStyle.Top;
			this.taskPane.Expandos.AddRange(new XPExplorerBar.Expando[] {
																			this.ExpdActionType,
																			this.ExpdFile,
																			this.ExpdFolder,
																			this.ExpdInternet});
			this.taskPane.Location = new System.Drawing.Point(0, 0);
			this.taskPane.Name = "taskPane";
			this.taskPane.Size = new System.Drawing.Size(285, 230);
			this.taskPane.TabIndex = 3;
			// 
			// ExpdActionType
			// 
			this.ExpdActionType.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ExpdActionType.Animate = true;
			this.ExpdActionType.ExpandedHeight = 90;
			this.ExpdActionType.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.ExpdActionType.Items.AddRange(new System.Windows.Forms.Control[] {
																					  this.cbAction,
																					  this.btnTest});
			this.ExpdActionType.Location = new System.Drawing.Point(12, 12);
			this.ExpdActionType.Name = "ExpdActionType";
			this.ExpdActionType.Size = new System.Drawing.Size(244, 90);
			this.ExpdActionType.TabIndex = 0;
			this.ExpdActionType.Text = "Action type";
			// 
			// cbAction
			// 
			this.cbAction.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cbAction.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbAction.Items.AddRange(new object[] {
														  "None",
														  "File",
														  "Folder",
														  "Internet"});
			this.cbAction.Location = new System.Drawing.Point(2, 32);
			this.cbAction.Name = "cbAction";
			this.cbAction.Size = new System.Drawing.Size(237, 21);
			this.cbAction.TabIndex = 0;
			this.cbAction.SelectedValueChanged += new System.EventHandler(this.cbAction_TextChanged);
			// 
			// btnTest
			// 
			this.btnTest.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnTest.Location = new System.Drawing.Point(4, 62);
			this.btnTest.Name = "btnTest";
			this.btnTest.TabIndex = 1;
			this.btnTest.Text = "Test";
			this.btnTest.Click += new System.EventHandler(this.btnTest_Click);
			// 
			// ExpdFile
			// 
			this.ExpdFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ExpdFile.Animate = true;
			this.ExpdFile.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.ExpdFile.Items.AddRange(new System.Windows.Forms.Control[] {
																				this.txbFile,
																				this.btnBrowseFile});
			this.ExpdFile.Location = new System.Drawing.Point(12, 114);
			this.ExpdFile.Name = "ExpdFile";
			this.ExpdFile.Size = new System.Drawing.Size(244, 100);
			this.ExpdFile.TabIndex = 1;
			this.ExpdFile.Text = "File";
			this.ExpdFile.Visible = false;
			// 
			// txbFile
			// 
			this.txbFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbFile.Location = new System.Drawing.Point(4, 40);
			this.txbFile.Name = "txbFile";
			this.txbFile.Size = new System.Drawing.Size(215, 21);
			this.txbFile.TabIndex = 0;
			this.txbFile.Text = "";
			this.txbFile.TextChanged += new System.EventHandler(this.txbFile_TextChanged);
			// 
			// btnBrowseFile
			// 
			this.btnBrowseFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowseFile.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseFile.Location = new System.Drawing.Point(220, 40);
			this.btnBrowseFile.Name = "btnBrowseFile";
			this.btnBrowseFile.Size = new System.Drawing.Size(22, 23);
			this.btnBrowseFile.TabIndex = 1;
			this.btnBrowseFile.Text = "...";
			this.btnBrowseFile.Click += new System.EventHandler(this.btnBrowseFile_Click);
			// 
			// ExpdFolder
			// 
			this.ExpdFolder.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ExpdFolder.Animate = true;
			this.ExpdFolder.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.ExpdFolder.Items.AddRange(new System.Windows.Forms.Control[] {
																				  this.txbFolder,
																				  this.btnBrowseFolder});
			this.ExpdFolder.Location = new System.Drawing.Point(12, 226);
			this.ExpdFolder.Name = "ExpdFolder";
			this.ExpdFolder.Size = new System.Drawing.Size(244, 100);
			this.ExpdFolder.TabIndex = 2;
			this.ExpdFolder.Text = "Folder";
			this.ExpdFolder.Visible = false;
			// 
			// txbFolder
			// 
			this.txbFolder.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbFolder.Location = new System.Drawing.Point(4, 40);
			this.txbFolder.Name = "txbFolder";
			this.txbFolder.Size = new System.Drawing.Size(215, 21);
			this.txbFolder.TabIndex = 2;
			this.txbFolder.Text = "";
			this.txbFolder.TextChanged += new System.EventHandler(this.txbFolder_TextChanged);
			// 
			// btnBrowseFolder
			// 
			this.btnBrowseFolder.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowseFolder.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseFolder.Location = new System.Drawing.Point(220, 40);
			this.btnBrowseFolder.Name = "btnBrowseFolder";
			this.btnBrowseFolder.Size = new System.Drawing.Size(22, 23);
			this.btnBrowseFolder.TabIndex = 3;
			this.btnBrowseFolder.Text = "...";
			this.btnBrowseFolder.Click += new System.EventHandler(this.btnBrowseFolder_Click);
			// 
			// ExpdInternet
			// 
			this.ExpdInternet.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ExpdInternet.Animate = true;
			this.ExpdInternet.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.ExpdInternet.Items.AddRange(new System.Windows.Forms.Control[] {
																					this.txbInternet,
																					this.lblhttp});
			this.ExpdInternet.Location = new System.Drawing.Point(12, 338);
			this.ExpdInternet.Name = "ExpdInternet";
			this.ExpdInternet.Size = new System.Drawing.Size(244, 100);
			this.ExpdInternet.TabIndex = 3;
			this.ExpdInternet.Text = "Internet";
			this.ExpdInternet.Visible = false;
			// 
			// txbInternet
			// 
			this.txbInternet.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txbInternet.Location = new System.Drawing.Point(39, 40);
			this.txbInternet.Name = "txbInternet";
			this.txbInternet.Size = new System.Drawing.Size(199, 21);
			this.txbInternet.TabIndex = 2;
			this.txbInternet.Text = "";
			this.txbInternet.TextChanged += new System.EventHandler(this.txbInternet_TextChanged);
			// 
			// lblhttp
			// 
			this.lblhttp.Location = new System.Drawing.Point(2, 41);
			this.lblhttp.Name = "lblhttp";
			this.lblhttp.Size = new System.Drawing.Size(38, 23);
			this.lblhttp.TabIndex = 3;
			this.lblhttp.Text = "http://";
			// 
			// ActionEditor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(285, 265);
			this.Controls.Add(this.taskPane);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ActionEditor";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Action Editor";
			((System.ComponentModel.ISupportInitialize)(this.taskPane)).EndInit();
			this.taskPane.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ExpdActionType)).EndInit();
			this.ExpdActionType.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ExpdFile)).EndInit();
			this.ExpdFile.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ExpdFolder)).EndInit();
			this.ExpdFolder.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ExpdInternet)).EndInit();
			this.ExpdInternet.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Fields
		private int currentExpandos = -1;
		private CDIStudio.CDMenus.ActionParameters fAction;

		#endregion


		#region Propertys
		public CDIStudio.CDMenus.ActionParameters Action
		{
			get
			{
				return fAction;
			}
			set
			{
				fAction = ((CDIStudio.CDMenus.ActionParameters)value).Clone();
				ActionToControls();
			}
		}

		#endregion


		#region Indexes


		#endregion


		#region Methods
		private void InitializeExpandos()
		{	 
			for(int i=2; i < taskPane.Expandos.Count; i++)
				taskPane.Expandos[i].Location = ExpdFile.Location;
		}
		
		private void ChangeExpandos( XPExplorerBar.Expando NewExpandos )
		{
			XPExplorerBar.Expando OldExpandos;
			if( 0 <= currentExpandos << taskPane.Expandos.Count)
			{
				OldExpandos = taskPane.Expandos[currentExpandos];
				OldExpandos.Hide();
			}

			if ( NewExpandos != null)
			{
				NewExpandos.Show();
				NewExpandos.Expand();
				currentExpandos = taskPane.Expandos.IndexOf(NewExpandos);
			}
			else
			{	currentExpandos = -1; }
		}

		private void ActionToControls()
		{
			cbAction.Text = fAction[0];
		//	MessageBox.Show(fAction[0]);
			switch (fAction[0])
			{
				case "None" : 
				{
					break; 
				}	 

				case "File" : 
				{
					txbFile.Text = fAction[1];
					break;
				}
				case "Folder" : 
				{
					txbFolder.Text = fAction[1];
					break;
				}
				case "Internet" : 
				{
					txbInternet.Text = fAction[1];
					break;
				}
			}		
		}
		private void ControlsToAction()
		{
			switch (cbAction.Text)
			{
				case "None" : 
				{
					fAction[0] = "None";
					fAction[1] = "";
					break; 
				}	 

				case "File" : 
				{
					fAction[0] = "File";
					fAction[1] = txbFile.Text;
					break;
				}
				case "Folder" : 
				{
					fAction[0] = "Folder";
					fAction[1] = txbFolder.Text;
					break;
				}
				case "Internet" : 
				{
					fAction[0] = "Internet";
					fAction[1] = txbInternet.Text;
					break;
				}
			}		
		}
		#endregion


		#region Events
		private void cbAction_TextChanged(object sender, System.EventArgs e)
		{
			switch (cbAction.Text)
			{
				case "None" :		{	ChangeExpandos(null);	break;			} 
				case "File" :		{	ChangeExpandos(ExpdFile);  break;		}
				case "Folder" :		{	ChangeExpandos(ExpdFolder);	 break;		}
				case "Internet" :	{   ChangeExpandos(ExpdInternet);   break;	}				
			}
		}

		private void btnBrowseFile_Click(object sender, System.EventArgs e)
		{	
			if (openFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbFile.Text = CDMenu.GetRelativePath( openFileDialog.FileName);
			}
		}

		private void btnBrowseFolder_Click(object sender, System.EventArgs e)
		{										   
			vbAccelerator.Components.Shell.FolderBrowser  folderBrowser= new vbAccelerator.Components.Shell.FolderBrowser();
			folderBrowser.RootPath = CDMenu.ProjectFolder;
			folderBrowser.Title = "Select a folder:";
			folderBrowser.InitialPath =  CDMenu.GetFullPath(txbFolder.Text);
//			folderBrowser.IncludeFiles = true;
			if (folderBrowser.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbFolder.Text = CDMenu.GetRelativePath(folderBrowser.SelectedPath);
			}
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			ControlsToAction();
		}

		private void btnTest_Click(object sender, System.EventArgs e)
		{
			ControlsToAction();
			CDIStudio.CDMenus.ProcessManager.Start(Action);
		}

		private void txbFile_TextChanged(object sender, System.EventArgs e)
		{
			Action[1] = txbFile.Text;
		}

		private void txbFolder_TextChanged(object sender, System.EventArgs e)
		{
			Action[1] = txbFolder.Text;
		}

		private void txbInternet_TextChanged(object sender, System.EventArgs e)
		{
			Action[1] = txbInternet.Text;
		}
		#endregion


	}

	#region	 ActionTypeEditor

	public class ActionTypeEditor : System.Drawing.Design.UITypeEditor 
	{
		public ActionTypeEditor()
		{
			 
	
		}

		[System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name="FullTrust")]
		public override System.Drawing.Design.UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
		{
			
			return UITypeEditorEditStyle.Modal;	 
		}

		[System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name="FullTrust")]
		public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, System.IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
			if( edSvc != null )
			{					
				ActionEditor editor = new ActionEditor();

				editor.Action = ((CDIStudio.CDMenus.ActionParameters)(value)).Clone();
				if (edSvc.ShowDialog(editor) == System.Windows.Forms.DialogResult.OK)
				{  
					editor.Action.CopyParameters((CDIStudio.CDMenus.ActionParameters)(value));
					Debug.WriteLine(((CDIStudio.CDMenus.ActionParameters)(value))[0]," editor");
					return value;
				}
			}
			return value;
		}

		public override bool GetPaintValueSupported(
			System.ComponentModel.ITypeDescriptorContext context)
		{
			// No special thumbnail will be shown for the grid.
			return false;
		}		
	}
	#endregion
}
