#region	 Licence and informations

/***************************************************************************************
 *		Date	:	20-5-2005
 *		Author	:	Theodoros Antoniou
 * 
 *		Description:
 *      -----------
 *		A wizard that will help you add files quickly by scanning a folder.
 * 
 *	   Copyright (C) 2005  Theodoros Antoniou 
 ***************************************************************************************/
 

////////////////////////////////////////////////////////////////////////////////
//   License Agreement:                                                       //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA //
//                                                                            //
//    The project web site is located on:                                     //
//      http://cdinterface.sourceforge.net									  //
//      http://www.sourceforge.net/projects/cdinterface						  //
//																			  //
//    Contact:																  //
//      defdef@users.sourceforge.net										  //
//                                                                            //                               
////////////////////////////////////////////////////////////////////////////////

#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace CDIStudio.CDMenus.Wizards
{
	
	public delegate void  AddFileDelegate(string Title, string FilePath);
	
	/// <summary>
	/// A wizard that will help you add files quickly by scanning a folder.
	/// </summary>
	public class FileAdditionWizard : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox cbExtensions;
		private Divelements.WizardFramework.Wizard wizard;
		private Divelements.WizardFramework.IntroductionPage introductionPage;
		private Divelements.WizardFramework.FinishPage finishPage;
		private Divelements.WizardFramework.WizardPage Page1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txbFolder;
		private Divelements.WizardFramework.WizardPage Page2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.ColumnHeader columnHeaderTitle;
		private System.Windows.Forms.ColumnHeader columnHeaderPath;
		private System.Windows.Forms.ListView lvFiles;
		private System.Windows.Forms.CheckBox chBSubFolder;
		private System.Windows.Forms.Button btnBrowse;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FileAdditionWizard()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FileAdditionWizard));
			this.wizard = new Divelements.WizardFramework.Wizard();
			this.Page1 = new Divelements.WizardFramework.WizardPage();
			this.chBSubFolder = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.cbExtensions = new System.Windows.Forms.ComboBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.txbFolder = new System.Windows.Forms.TextBox();
			this.Page2 = new Divelements.WizardFramework.WizardPage();
			this.lvFiles = new System.Windows.Forms.ListView();
			this.columnHeaderTitle = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderPath = new System.Windows.Forms.ColumnHeader();
			this.progressBar1 = new System.Windows.Forms.ProgressBar();
			this.label3 = new System.Windows.Forms.Label();
			this.finishPage = new Divelements.WizardFramework.FinishPage();
			this.introductionPage = new Divelements.WizardFramework.IntroductionPage();
			this.wizard.SuspendLayout();
			this.Page1.SuspendLayout();
			this.Page2.SuspendLayout();
			this.SuspendLayout();
			// 
			// wizard
			// 
			this.wizard.BannerImage = ((System.Drawing.Image)(resources.GetObject("wizard.BannerImage")));
			this.wizard.Controls.Add(this.introductionPage);
			this.wizard.Controls.Add(this.Page1);
			this.wizard.Controls.Add(this.Page2);
			this.wizard.Controls.Add(this.finishPage);
			this.wizard.Location = new System.Drawing.Point(0, 0);
			this.wizard.MarginImage = ((System.Drawing.Image)(resources.GetObject("wizard.MarginImage")));
			this.wizard.Name = "wizard";
			this.wizard.SelectedPage = this.introductionPage;
			this.wizard.TabIndex = 0;
			// 
			// Page1
			// 
			this.Page1.Controls.Add(this.chBSubFolder);
			this.Page1.Controls.Add(this.label2);
			this.Page1.Controls.Add(this.label1);
			this.Page1.Controls.Add(this.cbExtensions);
			this.Page1.Controls.Add(this.btnBrowse);
			this.Page1.Controls.Add(this.txbFolder);
			this.Page1.Description = "Select a folder to scan for files.";
			this.Page1.Location = new System.Drawing.Point(19, 73);
			this.Page1.Name = "Page1";
			this.Page1.NextPage = this.Page2;
			this.Page1.PreviousPage = this.introductionPage;
			this.Page1.Size = new System.Drawing.Size(459, 227);
			this.Page1.TabIndex = 1004;
			this.Page1.Text = "Select a Folder";
			// 
			// chBSubFolder
			// 
			this.chBSubFolder.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chBSubFolder.Location = new System.Drawing.Point(42, 48);
			this.chBSubFolder.Name = "chBSubFolder";
			this.chBSubFolder.Size = new System.Drawing.Size(135, 24);
			this.chBSubFolder.TabIndex = 6;
			this.chBSubFolder.Text = "Scan sub-folders.";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(39, 94);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 11);
			this.label2.TabIndex = 5;
			this.label2.Text = "Extensions:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(41, 6);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 13);
			this.label1.TabIndex = 4;
			this.label1.Text = "Folder:";
			// 
			// cbExtensions
			// 
			this.cbExtensions.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbExtensions.Items.AddRange(new object[] {
															  "Installers       (*.exe,*.msi)",
															  "Executables  (*.exe)",
															  "E-Books         (*.pdf,*.chm)",
															  "All files           (*.*)"});
			this.cbExtensions.Location = new System.Drawing.Point(39, 108);
			this.cbExtensions.Name = "cbExtensions";
			this.cbExtensions.Size = new System.Drawing.Size(373, 21);
			this.cbExtensions.TabIndex = 2;
			// 
			// btnBrowse
			// 
			this.btnBrowse.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowse.Location = new System.Drawing.Point(376, 16);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(33, 23);
			this.btnBrowse.TabIndex = 1;
			this.btnBrowse.Text = "...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// txbFolder
			// 
			this.txbFolder.Location = new System.Drawing.Point(39, 19);
			this.txbFolder.Name = "txbFolder";
			this.txbFolder.ReadOnly = true;
			this.txbFolder.Size = new System.Drawing.Size(329, 20);
			this.txbFolder.TabIndex = 0;
			this.txbFolder.Text = "";
			// 
			// Page2
			// 
			this.Page2.Controls.Add(this.lvFiles);
			this.Page2.Controls.Add(this.progressBar1);
			this.Page2.Controls.Add(this.label3);
			this.Page2.Description = "Select files to add.";
			this.Page2.Location = new System.Drawing.Point(19, 73);
			this.Page2.Name = "Page2";
			this.Page2.NextPage = this.finishPage;
			this.Page2.PreviousPage = this.Page1;
			this.Page2.Size = new System.Drawing.Size(459, 227);
			this.Page2.TabIndex = 1006;
			this.Page2.Text = "Select files";
			this.Page2.AfterDisplay += new System.EventHandler(this.Page2_AfterDisplay);
			this.Page2.BeforeMoveNext += new Divelements.WizardFramework.WizardPageEventHandler(this.Page2_BeforeMoveNext);
			// 
			// lvFiles
			// 
			this.lvFiles.CheckBoxes = true;
			this.lvFiles.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					  this.columnHeaderTitle,
																					  this.columnHeaderPath});
			this.lvFiles.Location = new System.Drawing.Point(35, 24);
			this.lvFiles.Name = "lvFiles";
			this.lvFiles.Size = new System.Drawing.Size(388, 159);
			this.lvFiles.TabIndex = 14;
			this.lvFiles.View = System.Windows.Forms.View.Details;
			// 
			// columnHeaderTitle
			// 
			this.columnHeaderTitle.Text = "Title";
			this.columnHeaderTitle.Width = 145;
			// 
			// columnHeaderPath
			// 
			this.columnHeaderPath.Text = "Path";
			this.columnHeaderPath.Width = 225;
			// 
			// progressBar1
			// 
			this.progressBar1.Location = new System.Drawing.Point(34, 192);
			this.progressBar1.Name = "progressBar1";
			this.progressBar1.Size = new System.Drawing.Size(388, 23);
			this.progressBar1.Step = 1;
			this.progressBar1.TabIndex = 13;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(36, 10);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 12);
			this.label3.TabIndex = 12;
			this.label3.Text = "Files:";
			// 
			// finishPage
			// 
			this.finishPage.AllowCancel = false;
			this.finishPage.AllowMovePrevious = false;
			this.finishPage.FinishText = "You have successfully completed the File Addition Wizard.";
			this.finishPage.Location = new System.Drawing.Point(177, 66);
			this.finishPage.Name = "finishPage";
			this.finishPage.PreviousPage = this.Page2;
			this.finishPage.Size = new System.Drawing.Size(307, 234);
			this.finishPage.TabIndex = 1005;
			this.finishPage.Text = "Completing the File Addition Wizard";
			// 
			// introductionPage
			// 
			this.introductionPage.IntroductionText = "This wizard helps you add files quickly by scanning a folder.";
			this.introductionPage.Location = new System.Drawing.Point(177, 66);
			this.introductionPage.Name = "introductionPage";
			this.introductionPage.NextPage = this.Page1;
			this.introductionPage.Size = new System.Drawing.Size(307, 234);
			this.introductionPage.TabIndex = 1003;
			this.introductionPage.Text = "Welcome to the File Addition Wizard";
			// 
			// FileAdditionWizard
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(497, 360);
			this.Controls.Add(this.wizard);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FileAdditionWizard";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "File Addition Wizard";
			this.Load += new System.EventHandler(this.SimpleWizard_Load);
			this.wizard.ResumeLayout(false);
			this.Page1.ResumeLayout(false);
			this.Page2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
							
		
		
		#region Fields


		#endregion


		#region Propertys


		#endregion


		#region Indexes


		#endregion

		#region Events

		public event AddFileDelegate AddingFile;

		#endregion

		#region Methods
		private void SimpleWizard_Load(object sender, System.EventArgs e)
		{
			wizard.SelectedPage = introductionPage;
			cbExtensions.SelectedIndex = 0;
			if(txbFolder.Text == "")
				txbFolder.Text = CDMenus.Forms.CDMenu.ProjectFolder;
		}

		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			vbAccelerator.Components.Shell.FolderBrowser folderBrowser = new vbAccelerator.Components.Shell.FolderBrowser();
			folderBrowser.RootPath = CDMenus.Forms.CDMenu.ProjectFolder;
			folderBrowser.Title = "Select a folder:";
			folderBrowser.InitialPath = txbFolder.Text;
			folderBrowser.NoNewFolderButton = true;
			if(folderBrowser.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				txbFolder.Text = folderBrowser.SelectedPath;
			}
		}

		private void Page2_AfterDisplay(object sender, System.EventArgs e)
		{
			//Clear controls
			lvFiles.Items.Clear();
			progressBar1.Value = 0;

			
			if(chBSubFolder.Checked)
			{
				GetFilesRecursive(txbFolder.Text);
			}
			else
			{
				Scanfolder(txbFolder.Text);
			}
		}

		private void GetFilesRecursive(string dir)
		{
			foreach (string newDir in Directory.GetDirectories(dir))
				GetFilesRecursive(newDir);

			Scanfolder(dir);
		}

		private void Scanfolder(string dir)
		{
			switch (cbExtensions.SelectedIndex)
			{
				case 0:	
				{
					Scanfolder(dir,"*.exe");
					Scanfolder(dir,"*.msi");
					break;
				}
				case 1:	Scanfolder(dir,"*.exe"); break;
				case 2:	
				{
					Scanfolder(dir,"*.pdf");
					Scanfolder(dir,"*.chm");
					break;
				}
				case 3:	Scanfolder(dir,"*.*"); break;
			}
		}

		private void Scanfolder(string dir,string searchPatern)
		{
			foreach(string files in Directory.GetFiles(dir,searchPatern))
			{				
				System.Windows.Forms.ListViewItem item;
				item = lvFiles.Items.Add(Path.GetFileNameWithoutExtension(files));
				item.SubItems.Add(Path.GetFullPath(files));
				item.Checked = true;
			}
		}

		private void Page2_BeforeMoveNext(object sender, System.ComponentModel.CancelEventArgs e)
		{
			progressBar1.Maximum = lvFiles.CheckedItems.Count;
			foreach(System.Windows.Forms.ListViewItem item in lvFiles.CheckedItems)
			{ 
				//Fire Add event
				if(AddingFile  != null)
					AddingFile(item.Text,item.SubItems[1].Text);

				progressBar1.PerformStep();
			}
		}

		#endregion

	}
}
